﻿Public Class Neige
    Private x1, x2 As Integer '
    Dim x_Sk, x_Sna As Double
    ''' <summary>
    ''' Altitude de la construction
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Altitude As Integer
        Get
            Altitude = x1
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de l'altitude n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de l'altitude doit être positive.")
            Else
                x1 = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Region neige de la construction
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property RegNeige As Integer
        Get
            RegNeige = x2
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la région n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la region doit être positive.")
            Else
                x2 = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' application clause B3: vrai si application sinon faux
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property B3 As Boolean = False
    ''' <summary>
    ''' Neige caractéristique au sol
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Sk As Double
        Get
            Sk = x_Sk
        End Get
    End Property
    ''' <summary>
    ''' Neige accidentelle
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Sna As Double
        Get
            Sna = x_sna
        End Get
    End Property
    ''' <summary>
    ''' decrochage: b1 (provisoire)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property b1 As Double
    ''' <summary>
    ''' decrochage: b2 (provisoire)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property b2 As Double
    ''' <summary>
    ''' decrochage: h (provisoire)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property h As Double
    ''' <summary>
    ''' longueur projetée versant adjacent: Lproj (provisoire)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Lproj As Double
    ''' <summary>
    ''' calcul Sk, Sna
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Neige_General()
        Select Case RegNeige
            Case 1 'région A1
                x_Sk = 45 : x_Sna = 0
            Case 2 'région A2
                x_Sk = 45 : x_Sna = 100
            Case 3 'région B1
                x_Sk = 55 : x_Sna = 100
            Case 4 'région B2
                x_Sk = 55 : x_Sna = 135
            Case 5 'région C1
                x_Sk = 65 : x_Sna = 0
            Case 6 'région C2
                x_Sk = 65 : x_Sna = 135
            Case 7 'région D
                x_Sk = 90 : x_Sna = 180
            Case 8 'région E
                x_Sk = 140 : x_Sna = 0
        End Select
        Select Case RegNeige
            Case 1 To 7 'région A à D
                Select Case Altitude
                    Case Is < 200
                        x_Sk = x_Sk
                    Case Is < 500
                        x_Sk = x_Sk + (Altitude / 1000 - 0.2) * 100
                    Case Is < 1000
                        x_Sk = x_Sk + (1.5 * Altitude / 1000 - 0.45) * 100
                    Case Else
                        x_Sk = x_Sk + (3.5 * Altitude / 1000 - 2.45) * 100
                End Select
            Case 8 'région E
                Select Case Altitude
                    Case Is < 200
                        x_Sk = x_Sk
                    Case Is < 500
                        x_Sk = x_Sk + (1.5 * Altitude / 1000 - 0.3) * 100
                    Case Is < 1000
                        x_Sk = x_Sk + (3.5 * Altitude / 1000 - 1.3) * 100
                    Case Else
                        x_Sk = x_Sk + (7 * Altitude / 1000 - 4.8) * 100
                End Select
        End Select
    End Sub
End Class
