﻿Imports System.Math
Public Class Vent
    Private _Vb0, _RegVent, _Duree, _CatVent, _OroCas, _ValCpi, _GeomToiture, _GeomBat As Integer
    Private _Cprob, _Vb, _Cseason, _Cdir, _Hbat, _LongBat, _LargBat, _Zeref, _CsCd, _Coro, _SalpG, _SalpD, _SapigB, _SapigH, _CpiPlus, _CpiMoins, _hp, _r, _alpha As Double
    Private _P1v, _Pvg, _Pvd, _DecalFaitage As Double

    ''' <summary>
    ''' Region vent de la construction
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property RegVent As Integer
        Get
            RegVent = _RegVent
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la région n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la region doit être positive.")
            Else
                _RegVent = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Vitesse moyenne du vent
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Vb0 As Integer
        Get
            Vb0 = _Vb0
        End Get
    End Property
    ''' <summary>
    ''' Coefficient de probabilité
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Cprob As Double
        Get
            Cprob = _Cprob
        End Get
    End Property
    ''' <summary>
    ''' Durée de la construction
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Duree As Integer
        Get
            Duree = _Duree
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la durée n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la durée doit être positive.")
            Else
                _Duree = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Coefficient de saisonnalité
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Cseason As Double
        Get
            Cseason = _Cseason
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du Coefficient de saisonnalité n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur du Coefficient de saisonnalité doit être positive.")
            Else
                _Cseason = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Coefficient de direction 
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Cdir As Double
        Get
            Cdir = _Cdir
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du Coefficient de direction n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur du Coefficient de direction doit être positive.")
            Else
                _Cdir = value
            End If
        End Set
    End Property
    ''' Vitesse de référence du vent
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property Vb As Double
        Get
            Vb = _Vb
        End Get
    End Property
    ''' <summary>
    ''' Hauteur du bâtiment
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Hbat As Double
        Get
            Hbat = _Hbat
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la Hauteur du bâtiment n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la Hauteur du bâtiment doit être positive.")
            Else
                _Hbat = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Longueur du bâtiment
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property LongBat As Double
        Get
            LongBat = _LongBat
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la Longueur du bâtiment n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la Longueur du bâtiment doit être positive.")
            Else
                _LongBat = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Largeur du bâtiment
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property LargBat As Double
        Get
            LargBat = _LargBat
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la Largeur du bâtiment n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la Largeur du bâtiment doit être positive.")
            Else
                _LargBat = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' rugosité du terrain
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property CatVent As Integer
        Get
            CatVent = _CatVent
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la rugosité du terrain n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la rugosité du terrain doit être positive.")
            Else
                _CatVent = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Influence avoisinant
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Zeref As Double
        Get
            Zeref = _Zeref
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de l'influence des avoisinant n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de l'influence des avoisinant doit être positive.")
            Else
                _Zeref = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Coefficient structural
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property CsCd As Double
        Get
            CsCd = _CsCd
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du Coefficient structural n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur du Coefficient structural doit être positive.")
            Else
                _CsCd = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Type de terrain orographique
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property OroCas As Integer
        Get
            OroCas = _OroCas
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du type de terrain orographique n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur du type de terrain orographique doit être positive.")
            Else
                _OroCas = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Coefficient orographique
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Coro As Double
        Get
            Coro = _Coro
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du Coefficient orographique n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur du Coefficient orographique doit être positive.")
            Else
                _Coro = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Modèle de valeurs des Cpi
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ValCpi As Integer
        Get
            ValCpi = _ValCpi
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du Modèle de valeurs des Cpi n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur du Modèle de valeurs des Cpi doit être positive.")
            Else
                _ValCpi = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Surface cumulée des ouvertures sur le longpan gauche 
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property SalpG As Double
        Get
            SalpG = _SalpG
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la Surface cumulée des ouvertures sur le longpan gauche n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la Surface cumulée des ouvertures sur le longpan gauche doit être positive.")
            Else
                _SalpG = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Surface cumulée des ouvertures sur le longpan droit
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property SalpD As Double
        Get
            SalpD = _SalpD
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la Surface cumulée des ouvertures sur le longpan droit n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la Surface cumulée des ouvertures sur le longpan droit doit être positive.")
            Else
                _SalpD = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  Surface cumulée des ouvertures sur le pignon bas :
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property SapigB As Double
        Get
            SapigB = _SapigB
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la Surface cumulée des ouvertures sur le pignon bas n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la Surface cumulée des ouvertures sur le pignon bas doit être positive.")
            Else
                _SapigB = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  Surface cumulée des ouvertures sur le pignon Haut :
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property SapigH As Double
        Get
            SapigH = _SapigH
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la Surface cumulée des ouvertures sur le pignon haut n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la Surface cumulée des ouvertures sur le pignon haut doit être positive.")
            Else
                _SapigH = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  Coefficient de pression interne directement renseigné - positif
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property CpiPlus As Double
        Get
            CpiPlus = _CpiPlus
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du Coefficient de pression interne directement renseigné positif n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur du Coefficient de pression interne directement renseigné positif doit être positive.")
            Else
                _CpiPlus = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  Coefficient de pression interne directement renseigné - négatif
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property CpiMoins As Double
        Get
            CpiMoins = _CpiMoins
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du Coefficient de pression interne directement renseigné négatif n'est pas numérique.")
            ElseIf value > 0 Then
                Throw New ArgumentException("La valeur du Coefficient de pression interne directement renseigné négatif doit être négative.")
            Else
                _CpiMoins = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Géométrie de la toiture
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property GeomToiture As Integer
        Get
            GeomToiture = _GeomToiture
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la géométrie de la toiture n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la géométrie de la toiture doit être positive.")
            Else
                _GeomToiture = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  Hauteur acrotère toiture terrasse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Hp As Double
        Get
            Hp = _hp
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la hauteur d'acrotère n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la hauteur d'acrotère doit être positive.")
            Else
                _hp = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  rayon de l'arrondi de rive toiture terrasse
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property r As Double
        Get
            r = _r
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du rayon de l'arrondi de rive toiture terrasse n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur du rayon de l'arrondi de rive toiture terrasse doit être positive.")
            Else
                _r = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  angle du brisis mansardé
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property alpha As Double
        Get
            alpha = _alpha
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur   de l'angle du brisis mansardé n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur  de l'angle du brisis mansardé doit être positive.")
            Else
                _alpha = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  Pente 1 versant
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Pente_1Vers As Double
        Get
            Pente_1Vers = _P1v
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la pente n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la pente doit être positive.")
            Else
                _P1v = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  Pente gauche toiture 2 versants
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Pvg As Double
        Get
            Pvg = _Pvg
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la pente n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la pente doit être positive.")
            Else
                _Pvg = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  Pente droite toiture 2 versants
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Pvd As Double
        Get
            Pvd = _Pvd
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la pente n'est pas numérique.")
            ElseIf value < 0 Then
                Throw New ArgumentException("La valeur de la pente doit être positive.")
            Else
                _Pvd = value
            End If
        End Set
    End Property
    ''' <summary>
    '''  décalage du faitage toiture 2 versants
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property DecalFaitage As Double
        Get
            DecalFaitage = _DecalFaitage
        End Get
        Set(value As Double)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur du décalage de faitage n'est pas numérique.")
            Else
                _DecalFaitage = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Géométrie du bâtiment
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property GeomBat As Integer
        Get
            GeomBat = _GeomBat
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur de la géométrie du bâtiment n'est pas numérique.")
            ElseIf value <= 0 Then
                Throw New ArgumentException("La valeur de la géométrie du bâtiment doit être positive.")
            Else
                _GeomBat = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Facteur de terrain 
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Kr As Double
    ''' <summary>
    ''' Coefficient de turbulence
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Ki As Double
    ''' <summary>
    ''' Hauteur de référence
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Ze As New List(Of Double)
    ''' <summary>
    ''' Hauteur de référence mur au vent
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Ze_Mur As New List(Of Double)
    ''' <summary>
    '''  Coefficient de rugosité pour la hauteur de référence Ze
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Cr As Double
    ''' <summary>
    ''' Indice de turbulence pour la hauteur de référence Ze
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Iv As Double
    ''' <summary>
    ''' Vitesse moyenne du vent pour la hauteur de référence Ze
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Vm As Double
    ''' <summary>
    ''' Coefficient d'exposition
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Ce As Double
    ''' <summary>
    ''' nbre de profil de pression sur le longPan Gauche
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Profil_LongPan As Integer
    ''' <summary>
    ''' nbre de profil de pression sur le Pignon
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Profil_Pignon As Integer
    ''' <summary>
    ''' Coefficient de frottement Mur
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Cfr_Mur As Double
    ''' <summary>
    ''' Coefficient de frottement Toiture
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Cfr_Toit As Double
    ''' <summary>
    ''' Acrotère suivant LongPan
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Acrot_LongPan As Boolean
    ''' <summary>
    ''' Acrotère suivant Pignon
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks> 
    Public Property Acrot_Pignon As Boolean
    Public Sub Initialisation()
        Dim p, K As Double
        'Vitesse moyenne du vent  
        Select Case RegVent
            Case 1 'région 1
                _Vb0 = 22
            Case 2 'région 2
                _Vb0 = 24
            Case 3 'région 3
                _Vb0 = 26
            Case 4 'région 4
                _Vb0 = 28
        End Select
        'calcul du coefficient de probabilité
        Select Case Duree 'durée du projet
            Case 2 '2 ans
                p = 0.5 : K = 0.15
            Case 5 '5 ans
                p = 0.2 : K = 0.15
            Case 10 ' 10 ans
                p = 0.1 : K = 0.15
            Case 25 '25 ans
                p = 0.04 : K = 0.15
            Case 50 '50 ans
                p = 0.02 : K = 0.15
            Case 100 '100 ans
                p = 0.01 : K = 0.2
        End Select
        _Cprob = ((1 - K * Log(-Log(1 - p))) / (1 - K * Log(-Log(0.98)))) ^ 0.5
        _Vb = _Cprob * _Cdir * _Cseason * _Vb0 'vitesse de référence
        ''Détermination de la hauteur maximale du bâtiment pour détermination de la hauteur de référence
        ''voir EN1991-1-4 §7.2.2(1)Note
        'Hbat = 0
        'For i = 1 To nbhall
        '    If Hbat < Y_noe(nbFaitage(i)) Then Hbat = Y_noe(nbFaitage(i))
        'Next
        'Tab_Vent(5) = Hbat
    End Sub

End Class
