﻿Imports System.Math
Imports System.IO
Public Class frmNeige
    Dim Fichier_NotedeCalcul As String
    Private Sub BtnOK_Click(sender As Object, e As EventArgs) Handles BtnOK.Click
        Dim Verif As Boolean = True
        Dim Ndc_Neige As String
        'writer de sortie du RTF
        Dim sw As New System.IO.StringWriter
        'crée un writer de RTF avec une police par défaut
        Dim rtf As New RtfAnsiTextWriter(sw, New Font(FontFamily.GenericSerif, 12, FontStyle.Regular))
        Dim rtff, msg As String
        Try
            Call Lecture(Verif)
            If Verif = False Then Exit Sub
            Call Coherence(Verif)
            If Verif = False Then Exit Sub
            Call Ecriture_Hypothese_Note_de_calcul(rtf)
            Call Calcul_Neige(rtf, Verif)
            'génère le RTF complet
            Ndc_Neige = "Neige_" & Mise_en_Forme_date(CStr(DateTime.Now)) & ".rtf"
            Fichier_NotedeCalcul = Aff.msgResult & "\" & Ndc_Neige
            rtf.Generate() : rtff = sw.ToString : File.WriteAllText(Fichier_NotedeCalcul, rtff)

            Call Ecriture_Resultats()
        Catch ex As Exception
            msg = "Problème rencontré au cours du calcul" & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try

    End Sub
    Private Sub Lecture(ByRef verif As Boolean)
        Dim i As Integer
        Select Case CBNeige.SelectedIndex
            Case 0 'A1()
                Snw.RegNeige = 1
            Case 1 'A2()
                Snw.RegNeige = 2
            Case 2 'B1()
                Snw.RegNeige = 3
            Case 3 'B2()
                Snw.RegNeige = 4
            Case 4 'C1()
                Snw.RegNeige = 5
            Case 5 'C2()
                Snw.RegNeige = 6
            Case 6 'D()
                Snw.RegNeige = 7
            Case 7 'E()
                Snw.RegNeige = 8
        End Select
        If gestionderreur(TxtAltitude) = True Then Snw.Altitude = CInt(TxtAltitude.Text) Else verif = False
        If RbtnB3Oui.Checked = True Then Snw.B3 = True Else Snw.B3 = False
        i = CInt(LblnbVersant.Text) - 1 'car la collection commence à 0
        Lecture_Pente(i, verif)
        If RbtnAvecDecrochage.Checked = True Then
            If gestionderreur(Txtb1) = True Then Snw.b1 = CDbl(Txtb1.Text) Else verif = False
            If gestionderreur(Txtb2) = True Then Snw.b2 = CDbl(Txtb2.Text) Else verif = False
            If gestionderreur(Txth) = True Then Snw.h = CDbl(Txth.Text) Else verif = False
            If gestionderreur(TxtLproj) = True Then Snw.Lproj = CDbl(TxtLproj.Text) Else verif = False
        End If

    End Sub
    Private Sub Coherence(ByRef Verif As Boolean)
        Dim i As Integer
        For i = 0 To Roof.Count - 1
            Select Case i
                Case 0
                    'pas de modification
                Case Roof.Count - 1
                    'pas de modification
                Case Else
                    If Roof.Item(i).Acrotere = True Then Roof.Item(i).Acrotere = False 'pas d'acrotère intermédiaire
            End Select
        Next
        If RbtnAvecDecrochage.Checked = True Then

        Else

        End If
    End Sub
    Private Sub Ecriture_Hypothese_Note_de_calcul(ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String

        rtf.WriteStartGroup()
        rtf.NewParagraph(RtfAnsiTextWriter.Align.Center) : rtf.Bold = True : rtf.FontSize = 18 : rtf.Underline = True
        rtf.WriteString("Charge de neige suivant Eurocode 1")
        rtf.NewLine()
        rtf.Bold = False : rtf.FontSize = 10 : rtf.Underline = False : rtf.NewParagraph(RtfAnsiTextWriter.Align.Left)
        rtf.WriteString("Note de calcul du : ") : msg = Mise_en_Forme_date(CStr(DateTime.Now)) : rtf.WriteString(msg) : rtf.NewLine()
        rtf.WriteString("Rédacteur : " & Aff.Redacteur) : rtf.NewLine()
        rtf.WriteString("Chantier : " & Aff.Chantier) : rtf.NewLine()
        rtf.WriteString("Logiciel : calculette bâtiment  -  version 1.0  2015") : rtf.NewLine()
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("1 - Rappel des hypothèses") : rtf.Bold = False
        rtf.FontSize = 10 : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
        rtf.Underline = True : rtf.WriteString("1 - 1 Codes de calcul") : rtf.Underline = False : rtf.NewLine()
        rtf.WriteString("-  EN 1991-1-3:2003 et annexe nationale 2007") : rtf.NewLine() : rtf.NewLine()
        rtf.Underline = True : rtf.WriteString("1 - 2 Caractéristiques géographiques") : rtf.Underline = False : rtf.NewLine()
        Select Case CBNeige.SelectedIndex
            Case 0 'A1()
                msg = "A1"
            Case 1 'A2()
                msg = "A2"
            Case 2 'B1()
                msg = "B1"
            Case 3 'B2()
                msg = "B2"
            Case 4 'C1()
                msg = "C1"
            Case 5 'C2()
                msg = "C2"
            Case 6 'D()
                msg = "D"
            Case 7 'E()
                msg = "E"
        End Select
        rtf.WriteString("Région géographique d'implantation de la construction: " & msg) : rtf.NewLine()
        rtf.WriteString("Altitude d'implantation du projet :" & Snw.Altitude.ToString("#,##0") & " m.") : rtf.NewLine()
        If RbtnB3Oui.Checked = True Then msg = " étude cas B3 imposée par le CCTP" Else msg = " étude cas B3 non imposée par le CCTP"
        rtf.WriteString("Situations de projet suivant EN 1991-1-3 annexe A : " & msg) : rtf.NewLine()
        rtf.Underline = True : rtf.WriteString("1 - 3 Caractéristiques techniques") : rtf.Underline = False : rtf.NewLine()
        If Rbtn1Versant.Checked = True Then rtf.WriteString(" • Toiture 1 versant") : rtf.NewLine()
        If Rbtn2Versant.Checked = True Then rtf.WriteString(" • Toiture 2 versants") : rtf.NewLine()
        If RbtnVersantMultiple.Checked = True Then rtf.WriteString(" • Toiture à versants multiple") : rtf.NewLine()
        If Roof.Item(0).Acrotere = False And Roof.Item(Roof.Count - 1).Acrotere = False Then
            rtf.WriteString(" • Sans acrotère") : rtf.NewLine()
        Else
            rtf.WriteString(" • Avec acrotère") : rtf.NewLine()
        End If
        Dim toto As Boolean = False
        For i = 0 To Roof.Count - 1
            If Roof.Item(i).Barre_A_Neige = True Then toto = True : Exit For
        Next
        If toto = False Then
            rtf.WriteString(" • Sans barre à neige ou équivalent") : rtf.NewLine()
        Else
            rtf.WriteString(" • Avec barre à neige ou équivalent pour certains versants de la toiture") : rtf.NewLine()
        End If
        rtf.WriteEndGroup()
    End Sub
    Private Sub Ecriture_Resultats()
        Dim msg As String
        Select Case Roof.Count '=nbre de versant de toiture
            Case 1 'toiture à 1 versant
                msg = "Charge de projet: 1 seul cas de charge pour chaque Etat Limite." & vbCrLf
                msg = msg & "  - Durable/transitoire - Sn = " & Roof.Item(0).Sn.ToString("#0.00") & " daN/m²." & vbCrLf
                If Roof.Item(0).Sa < 1 Then
                    msg = msg & "  - Accidentel: sans objet"
                Else
                    msg = msg & "  - Accidentel - Sad = " & Roof.Item(0).Sa.ToString("#0.00") & " daN/m²."
                End If
                RtbResultats.Text = msg
            Case 2 'toiture à 2 versants
                If Snw.h < 0.1 Then
                    msg = "Charge de projet: 3 cas de charge pour chaque Etat Limite." & vbCrLf
                    msg = msg & "  - Durable/transitoire :" & vbCrLf
                    msg = msg & "Cas 1: versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(0).ToString("#0.00") & " daN/m²." & vbCrLf
                    msg = msg & "Cas 2: versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(1).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                    msg = msg & "Cas 3: versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(2).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(2).ToString("#0.00") & " daN/m²." & vbCrLf
                    If Roof.Item(0).Sa < 1 Then
                        msg = msg & "  - Accidentel: sans objet"
                    Else
                        msg = msg & "  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)" & vbCrLf
                        msg = msg & "Cas 1: versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²." & vbCrLf
                        msg = msg & "Cas 2: versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                        msg = msg & "Cas 3: versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(2).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(2).ToString("#0.00") & " daN/m²." & vbCrLf
                    End If
                Else
                    msg = "Charge de projet: toiture supérieure = 1 seul cas de charge (cas1) et toiture inférieure = 2 cas de charge (cas 1 et 2)" & vbCrLf
                    msg = msg & "  - Durable/transitoire :" & vbCrLf
                    msg = msg & "Cas 1: toiture supérieure - Sn = " & Roof.Item(0).K_charge1.Item(0).ToString("#0.00") & " daN/m² " & vbCrLf
                    msg = msg & "Cas 1: toiture inférieure - Sn = " & Roof.Item(1).K_charge1.Item(0).ToString("#0.00") & " daN/m² " & vbCrLf
                    msg = msg & "Cas 2: toiture inférieure - Sn1 = " & Roof.Item(1).K_charge1.Item(0).ToString("#0.00") & " daN/m² - Sn2 = " & Roof.Item(1).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                    If Roof.Item(0).Sa < 1 Then
                        msg = msg & "  - Accidentel: sans objet"
                    Else
                        msg = msg & "  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)" & vbCrLf
                        msg = msg & "Cas 1: toiture supérieure - Sad = " & Roof.Item(0).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²" & vbCrLf
                        msg = msg & "Cas 1: toiture inférieure - Sad = " & Roof.Item(1).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²" & vbCrLf
                        msg = msg & "Cas 2: toiture inférieure - Sad1 = " & Roof.Item(1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m² - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                    End If
                End If

                RtbResultats.Text = msg
            Case Is > 2 'toiture à versants multiples
                If Snw.h < 0.1 Then
                    msg = "Charge de projet: 2 cas de charge pour chaque Etat Limite." & vbCrLf
                    msg = msg & "  - Durable/transitoire :" & vbCrLf & "Cas 1: " & vbCrLf
                    For i = 0 To Roof.Count - 1 Step 2
                        'Toiture_Versants_Multiples(i)
                        msg = msg & " versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(0).ToString("#0.00") & " daN/m²." & vbCrLf
                    Next
                    msg = msg & "Cas 2: " & vbCrLf
                    For i = 0 To Roof.Count - 1 Step 2
                        Select Case i
                            Case 0
                                msg = msg & " versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(1).ToString("#0.00") & " daN/m²" & vbCrLf
                                msg = msg & " versant droit - Sn2(µ1) = " & Roof.Item(1).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                msg = msg & "               - Sn2(µ2) = " & Roof.Item(1).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                            Case Roof.Count - 2
                                msg = msg & " versant gauche - Sn2(µ2) = " & Roof.Item(i).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                msg = msg & "               - Sn2(µ1) = " & Roof.Item(i).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                msg = msg & " versant droit - Sn1 = " & Roof.Item(i + 1).K_charge1.Item(1).ToString("#0.00") & " daN/m²" & vbCrLf
                            Case Else
                                msg = msg & " versant gauche - Sn2(µ1) = " & Roof.Item(i).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                msg = msg & "               - Sn2(µ2) = " & Roof.Item(i).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                msg = msg & " versant droit - Sn2(µ2) = " & Roof.Item(i + 1).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                msg = msg & "               - Sn2(µ1) = " & Roof.Item(i + 1).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                        End Select
                    Next
                    If Roof.Item(0).Sa < 1 Then
                        msg = msg & "  - Accidentel: sans objet"
                    Else
                        msg = msg & "  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)" & vbCrLf & vbCrLf & "Cas 1: " & vbCrLf
                        For i = 0 To Roof.Count - 1 Step 2
                            msg = msg & " versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²." & vbCrLf
                        Next
                        msg = msg & "Cas 2: " & vbCrLf
                        For i = 0 To Roof.Count - 1 Step 2
                            Select Case i
                                Case 0
                                    msg = msg & " versant gauche - Sn1 = " & Roof.Item(0).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²" & vbCrLf
                                    msg = msg & " versant droit - Sn2(µ1) = " & Roof.Item(1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                    msg = msg & "               - Sn2(µ2) = " & Roof.Item(1).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                Case Roof.Count - 2
                                    msg = msg & " versant gauche - Sn2(µ2) = " & Roof.Item(i).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                    msg = msg & "               - Sn2(µ1) = " & Roof.Item(i).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                    msg = msg & " versant droit - Sn1 = " & Roof.Item(i + 1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²" & vbCrLf
                                Case Else
                                    msg = msg & " versant gauche - Sn2(µ1) = " & Roof.Item(i).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                    msg = msg & "               - Sn2(µ2) = " & Roof.Item(i).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                    msg = msg & " versant droit - Sn2(µ2) = " & Roof.Item(i + 1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                    msg = msg & "               - Sn2(µ1) = " & Roof.Item(i + 1).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                            End Select
                        Next

                    End If
                Else
                    Select Case Roof.Count
                        Case 3
                            msg = "Charge de projet: 3 cas de charge pour chaque Etat Limite pour la partie toiture supérieure" & vbCrLf
                            msg = msg & "  - Durable/transitoire :" & vbCrLf
                            msg = msg & "Cas 1: versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(0).ToString("#0.00") & " daN/m²." & vbCrLf
                            msg = msg & "Cas 2: versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(1).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                            msg = msg & "Cas 3: versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(2).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(2).ToString("#0.00") & " daN/m²." & vbCrLf
                            If Roof.Item(0).Sa < 1 Then
                                msg = msg & "  - Accidentel: sans objet"
                            Else
                                msg = msg & "  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)" & vbCrLf
                                msg = msg & "Cas 1: versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²." & vbCrLf
                                msg = msg & "Cas 2: versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                msg = msg & "Cas 3: versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(2).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(2).ToString("#0.00") & " daN/m²." & vbCrLf
                            End If
                            msg = msg & "Charge de projet: 2 cas de charge pour chaque Etat Limite pour la partie toiture inférieure" & vbCrLf
                            msg = msg & "  - Durable/transitoire :" & vbCrLf
                            msg = msg & "Cas 1: toiture inférieure - Sn = " & Roof.Item(2).K_charge1.Item(0).ToString("#0.00") & " daN/m² " & vbCrLf
                            msg = msg & "Cas 2: toiture inférieure - Sn1 = " & Roof.Item(2).K_charge1.Item(1).ToString("#0.00") & " daN/m² - Sn2 = " & Roof.Item(2).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                            If Roof.Item(0).Sa < 1 Then
                                msg = msg & "  - Accidentel: sans objet"
                            Else
                                msg = msg & "  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)" & vbCrLf
                                msg = msg & "Cas 1: toiture inférieure - Sad = " & Roof.Item(2).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²" & vbCrLf
                                msg = msg & "Cas 2: toiture inférieure - Sad1 = " & Roof.Item(2).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m² - Sad2 = " & Roof.Item(2).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                            End If
                        Case Else
                            msg = "Charge de projet: 2 cas de charge pour chaque Etat Limite." & vbCrLf
                            msg = msg & "  - Durable/transitoire :" & vbCrLf & "Cas 1: " & vbCrLf
                            For i = 0 To Roof.Count - 2 Step 2
                                'Toiture_Versants_Multiples(i)
                                msg = msg & " versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(0).ToString("#0.00") & " daN/m²." & vbCrLf
                            Next
                            msg = msg & "Cas 2: " & vbCrLf
                            For i = 0 To Roof.Count - 1 Step 2
                                Select Case i
                                    Case 0
                                        msg = msg & " versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(1).ToString("#0.00") & " daN/m²" & vbCrLf
                                        msg = msg & " versant droit - Sn2(µ1) = " & Roof.Item(1).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                        msg = msg & "               - Sn2(µ2) = " & Roof.Item(1).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                    Case Roof.Count - 2
                                        msg = msg & " versant gauche - Sn2(µ2) = " & Roof.Item(i).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                        msg = msg & "               - Sn2(µ1) = " & Roof.Item(i).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                        msg = msg & " versant droit - Sn1 = " & Roof.Item(i + 1).K_charge1.Item(1).ToString("#0.00") & " daN/m²" & vbCrLf
                                    Case Else
                                        msg = msg & " versant gauche - Sn2(µ1) = " & Roof.Item(i).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                        msg = msg & "               - Sn2(µ2) = " & Roof.Item(i).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                        msg = msg & " versant droit - Sn2(µ2) = " & Roof.Item(i + 1).K_charge1.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                        msg = msg & "               - Sn2(µ1) = " & Roof.Item(i + 1).K_charge2.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                End Select
                            Next
                            If Roof.Item(0).Sa < 1 Then
                                msg = msg & "  - Accidentel: sans objet"
                            Else
                                msg = msg & "  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)" & vbCrLf & vbCrLf & "Cas 1: " & vbCrLf
                                For i = 0 To Roof.Count - 1 Step 2
                                    msg = msg & " versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²." & vbCrLf
                                Next
                                msg = msg & "Cas 2: " & vbCrLf
                                For i = 0 To Roof.Count - 1 Step 2
                                    Select Case i
                                        Case 0
                                            msg = msg & " versant gauche - Sn1 = " & Roof.Item(0).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²" & vbCrLf
                                            msg = msg & " versant droit - Sn2(µ1) = " & Roof.Item(1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                            msg = msg & "               - Sn2(µ2) = " & Roof.Item(1).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                        Case Roof.Count - 2
                                            msg = msg & " versant gauche - Sn2(µ2) = " & Roof.Item(i).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                            msg = msg & "               - Sn2(µ1) = " & Roof.Item(i).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                            msg = msg & " versant droit - Sn1 = " & Roof.Item(i + 1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²" & vbCrLf
                                        Case Else
                                            msg = msg & " versant gauche - Sn2(µ1) = " & Roof.Item(i).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                            msg = msg & "               - Sn2(µ2) = " & Roof.Item(i).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                            msg = msg & " versant droit - Sn2(µ2) = " & Roof.Item(i + 1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                            msg = msg & "               - Sn2(µ1) = " & Roof.Item(i + 1).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m²." & vbCrLf
                                    End Select
                                Next

                            End If
                    End Select

                End If

                RtbResultats.Text = msg
        End Select
    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function
    Private Sub frmNeige_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        frmMenu.Visible = True
    End Sub
    Private Sub frmNeige_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        '1ier chargement
        Initialisation()
    End Sub
    Private Sub BtnMoins_Click(sender As Object, e As EventArgs) Handles BtnMoins.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblnbVersant.Text) - 1 'car la collection commence à 0
        Lecture_Pente(i, True)
        If i = 0 Then
            LblnbVersant.Text = "1"
            Affichage_Pente(0)
        Else
            LblnbVersant.Text = CStr(i)
            i = i - 1
            Affichage_Pente(i)
        End If

    End Sub
    Private Sub BtnPlus_Click(sender As Object, e As EventArgs) Handles BtnPlus.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblnbVersant.Text) - 1 'car la collection commence à 0
        Lecture_Pente(i, Verif)
        If Verif = False Then Exit Sub
        i = CInt(LblnbVersant.Text) + 1
        If Rbtn1Versant.Checked = True And i > 1 Then Exit Sub
        If Rbtn2Versant.Checked = True And i > 2 Then Exit Sub
        LblnbVersant.Text = CStr(i)

        If Roof.Count >= i Then
            Affichage_Pente(i - 1)
        Else
            Initialisation_Pente()
        End If
        TxtPente.Focus()
    End Sub
    Private Sub Affichage_Pente(ByVal i As Integer)
        CbPente.Text = CbPente.Items(0).ToString 'en °
        With Roof.Item(i)
            TxtPente.Text = .Pvers.ToString("#0.00")
            If .Acrotere = True Then ChkbAcrotere.Checked = True Else ChkbAcrotere.Checked = False
            If .Barre_A_Neige = True Then
                ChkbBarreNeige.Checked = True : Txtb.Enabled = True : Txtb.Text = .b.ToString("#0.00")
            Else
                ChkbBarreNeige.Checked = False : Txtb.Enabled = False : Txtb.Text = String.Empty
            End If
            If .hSaillie < 0.1 Then
                ChkbSaillie.Checked = False : TxthSaillie.Text = String.Empty : TxthSaillie.Enabled = False
            Else
                ChkbSaillie.Checked = True : TxthSaillie.Enabled = True : TxthSaillie.Text = .hSaillie.ToString("#0.00")
            End If
        End With
    End Sub
    Private Sub Initialisation_Pente()
        TxtPente.Text = String.Empty
        CbPente.Text = CbPente.Items(0).ToString 'en °
        ChkbAcrotere.Checked = False
        ChkbBarreNeige.Checked = False : Txtb.Enabled = False : Txtb.Text = String.Empty
        ChkbSaillie.Checked = False : TxthSaillie.Text = String.Empty : TxthSaillie.Enabled = False
    End Sub
    Private Sub Lecture_Pente(ByVal i As Integer, ByRef Verif As Boolean)
        Dim P1 As New Toiture
        With P1
            Select Case CbPente.SelectedIndex
                Case 0 ' (°)
                    If gestionderreur(TxtPente) = True Then .Pvers = CDbl(TxtPente.Text) Else Verif = False
                Case 1 '(%)
                    If gestionderreur(TxtPente) = True Then .Pvers = CDbl(TxtPente.Text) Else Verif = False
                    .Pvers = .Pvers / 100
                    .Pvers = Atan(.Pvers) 'en rad.
                    .Pvers = (.Pvers * 180) / PI 'en °
            End Select
            If ChkbAcrotere.Checked = True Then .Acrotere = True Else .Acrotere = False
            If ChkbBarreNeige.Checked = True Then
                .Barre_A_Neige = True
                If gestionderreur(Txtb) = True Then .b = CDbl(Txtb.Text) Else Verif = False
            Else
                .Barre_A_Neige = False
            End If
            If ChkbSaillie.Checked = True Then
                If gestionderreur(TxthSaillie) = True Then .hSaillie = CDbl(TxthSaillie.Text) Else Verif = False
            Else
                .hSaillie = 0
            End If
            If i + 1 > Roof.Count Then
                Roof.Add(P1)
            Else
                With Roof.Item(i)
                    .Pvers = P1.Pvers
                    .Acrotere = P1.Acrotere
                    .Barre_A_Neige = P1.Barre_A_Neige
                    .b = P1.b
                    .hSaillie = P1.hSaillie
                End With
            End If

        End With
    End Sub
#Region "gestion Textbox"
    Private Sub TextAltitude_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles TxtAltitude.KeyPress
        Call Gestion_Keypress(e, TxtAltitude, True, True)
    End Sub
    Private Sub TextPente_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPente.KeyPress
        Call Gestion_Keypress(e, TxtPente, False, False)
    End Sub
    Private Sub Txtb1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txtb1.KeyPress
        Call Gestion_Keypress(e, Txtb1, False, False)
    End Sub

    Private Sub Txtb2_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txtb2.KeyPress
        Call Gestion_Keypress(e, Txtb2, False, False)
    End Sub

    Private Sub Txth_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txth.KeyPress
        Call Gestion_Keypress(e, Txth, False, False)
    End Sub
#End Region

    Private Sub BtnMiseaZero_Click(sender As Object, e As EventArgs) Handles BtnMiseaZero.Click
        Roof.Clear()
        Initialisation()
    End Sub
    Private Sub Initialisation()
        Rbtn1Versant.Checked = True
        BtnPlus.Enabled = False : BtnMoins.Enabled = False
        RbtnB3No.Checked = True
        Txtb1.Text = String.Empty : Txtb1.Enabled = False
        Txtb2.Text = String.Empty : Txtb2.Enabled = False
        Txth.Text = String.Empty : Txth.Enabled = False
        TxtLproj.Text = String.Empty : TxtLproj.Enabled = False
        Txtb.Text = String.Empty : Txtb.Enabled = False
        TxthSaillie.Text = String.Empty : TxthSaillie.Enabled = False
        Initialisation_Pente()
    End Sub

    Private Sub BtnXlsOubatiN_Click(sender As Object, e As EventArgs) Handles BtnXlsOubatiN.Click
        Try
            Dim startInfo As New ProcessStartInfo("excel.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "oubati_v3-2.xlsx"
            Process.Start(startInfo)
        Catch exc As Exception
            Dim msg As String
            msg = "Erreur: " & exc.Message & vbCrLf & "Problème d'accés au fichier."
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
#Region "fichier d'aide"
    Private Sub BtnHlpRegNeige_Click(sender As Object, e As EventArgs) Handles BtnHlpRegNeige.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 1
        frm1.Show()
    End Sub

    Private Sub BtnHlpNeigeB3_Click(sender As Object, e As EventArgs) Handles BtnHlpNeigeB3.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 2
        frm1.Show()
    End Sub
    Private Sub BtnHlpDecrochage_Click(sender As Object, e As EventArgs) Handles BtnHlpDecrochage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 3
        frm1.Show()
    End Sub
#End Region

    Private Sub Rbtn1Versant_CheckedChanged(sender As Object, e As EventArgs) Handles Rbtn1Versant.CheckedChanged
        If Rbtn1Versant.Checked = True Then
            RbtnAvecDecrochage.Checked = False : RbtnSansDecrochage.Checked = False : GbVersantMultiple.Enabled = False
            Affichage_Image(1)
            LblnbVersant.Text = "1"
            BtnPlus.Enabled = False : BtnMoins.Enabled = False
            TxtPente.Text = String.Empty : TxtPente.Focus()
        End If
    End Sub
    Private Sub Rbtn2Versant_CheckedChanged(sender As Object, e As EventArgs) Handles Rbtn2Versant.CheckedChanged
        If Rbtn2Versant.Checked = True Then
            RbtnAvecDecrochage.Checked = False : RbtnSansDecrochage.Checked = False : GbVersantMultiple.Enabled = False
            Affichage_Image(2)
            LblnbVersant.Text = "1"
            BtnPlus.Enabled = True : BtnMoins.Enabled = True
            TxtPente.Text = String.Empty : TxtPente.Focus()
        End If
    End Sub
    Private Sub RbtnVersantMultiple_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnVersantMultiple.CheckedChanged
        If RbtnVersantMultiple.Checked = True Then
            GbVersantMultiple.Enabled = True
            Affichage_Image(3)
            LblnbVersant.Text = "1"
            BtnPlus.Enabled = True : BtnMoins.Enabled = True
            TxtPente.Text = String.Empty
        End If
    End Sub
    Private Sub RbtnSansDecrochage_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnSansDecrochage.CheckedChanged
        If RbtnSansDecrochage.Checked = True Then
            Affichage_Image(3)
            Txtb1.Text = String.Empty : Txtb1.Enabled = False
            Txtb2.Text = String.Empty : Txtb2.Enabled = False
            Txth.Text = String.Empty : Txth.Enabled = False
            TxtLproj.Text = String.Empty : TxtLproj.Enabled = False
        End If
    End Sub
    Private Sub RbtnAvecDecrochage_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnAvecDecrochage.CheckedChanged
        If RbtnAvecDecrochage.Checked = True Then
            Affichage_Image(4)
            Txtb1.Enabled = True
            Txtb2.Enabled = True
            Txth.Enabled = True
            TxtLproj.Enabled = True
            Txtb1.Focus()
        End If
    End Sub
    Private Sub Affichage_Image(ByVal n As Integer)
        'Dim xxx1 As String
        ''xxx1 = Directory.GetParent(Directory.GetCurrentDirectory).ToString() '"C:\Documents and Settings\philippe.fux\Mes documents\Projets Visual studio\poutre ba\images\"
        'xxx1 = IO.Directory.GetCurrentDirectory 'indique depuis quel répertoire courant s'execute PoutreBA.exe
        'xxx1 = xxx1 & "\Images"
        Pb1.Visible = True
        Try
            Select Case n
                Case 1
                    Pb1.Image = My.Resources._1_versant 'Image.FromFile(xxx1 + "\1_versant.png")
                    Pb2.Visible = False
                Case 2
                    Pb1.Image = My.Resources._2versants
                    Pb2.Visible = False
                Case 3
                    Pb1.Image = My.Resources.Versant_multiple ' "\Versant_multiple.png")
                    Pb2.Visible = False
                Case 4
                    Pb1.Image = My.Resources.Versant_multiple ' "\Versant_multiple.png")
                    Pb2.Visible = True
                    Pb2.Image = My.Resources.Avec_decrochage1 ' "\Avec_decrochage1.png")
            End Select
        Catch ex As Exception
            MessageBox.Show("Problème d'affichage des images" & ControlChars.CrLf & "Exception:" & ControlChars.CrLf & ex.Message, "Formulaire Charge", _
                            MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1)

        End Try
    End Sub

    Private Sub BtnEdit_Click(sender As Object, e As EventArgs) Handles BtnEdit.Click
        Try
            Select Case Aff.Editeur
                Case 1 'Editeur Interne
                    Dim frm1 As New frmEdit
                    frm1.Affichage_frmEdit(Fichier_NotedeCalcul)
                Case 2 'éditeur Word
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                    Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
            End Select
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher la note de calcul" & vbCrLf + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub

    Private Sub ChkbSaillie_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbSaillie.CheckedChanged
        If ChkbSaillie.Checked = True Then TxthSaillie.Enabled = True : TxthSaillie.Focus()
    End Sub

    Private Sub ChkbBarreNeige_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbBarreNeige.CheckedChanged
        If ChkbBarreNeige.Checked = True Then Txtb.Enabled = True : Txtb.Focus()
    End Sub

    Private Sub BtnFichier_Click(sender As Object, e As EventArgs) Handles BtnFichier.Click
        Dim filename As String
        Dim Verif As Boolean = True

        Try
            With OpenFileDialog1
                'pour éviter tout affichage initial dans la boite de dialogue
                .FileName = ""
                ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckFileExists = True
                ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True
                ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                .DefaultExt = "txt"
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowHelp = True
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ?
                ' Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        filename = .FileName
                        Call Lecture_chaine(filename, Verif)
                        If Verif = False Then Exit Sub
                        Call Affichage_Neige()
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MsgBox("Erreur lors de la lecture du fichier: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub Lecture_chaine(ByRef filename As String, ByRef Verif As Boolean)
        Dim myStreamReader As StreamReader
        Dim toto, titi(30) As String
        Dim i, j As Integer
        Verif = True
        'Dim Redacteur, Chantier As String
        'Redacteur = "A_faire" : Chantier = "A_faire"
        Try
            myStreamReader = File.OpenText(filename)
            toto = myStreamReader.ReadLine 'on n'affecte aucune valeur sur la première ligne
            'toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            'Redacteur = CStr(titi(1))
            'toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            'Chantier = CStr(titi(1))
            toto = myStreamReader.ReadLine     'données générales
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
            Snw.RegNeige = CInt(titi(1)) : Snw.Altitude = CInt(titi(2)) : Snw.B3 = CBool(titi(3))
            toto = myStreamReader.ReadLine     'toitures
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
            j = CInt(titi(1)) 'nb versant
            Roof.Clear()
            For i = 0 To 1 - 1
                Dim P1 As New Toiture
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                P1.Pvers = CDbl(titi(1)) : P1.Acrotere = CBool(titi(2)) : P1.Barre_A_Neige = CBool(titi(3)) : P1.b = CDbl(titi(4)) : P1.hSaillie = CDbl(titi(5))
                Roof.Add(P1)
                P1 = Nothing
            Next
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
            Snw.b1 = CDbl(titi(1)) : Snw.b2 = CDbl(titi(2)) : Snw.h = CDbl(titi(3)) : Snw.Lproj = CDbl(titi(4))

        Catch ex As Exception
            MsgBox("Erreur lors de la lecture du fichier: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
            Verif = False
        Finally
            If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
        End Try
    End Sub
    Private Sub LectureGen(ByVal toto As String, ByRef titi() As String)
        Dim blanc(45), i, j, position As Integer
        Dim tutu As String
        'toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        toto = toto.Replace(vbTab, " ") 'remplace tous les caractères de tabulation par un blanc
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
    Private Sub Affichage_neige()
        Dim i As Integer
        CBNeige.SelectedIndex = Snw.RegNeige - 1
        TxtAltitude.Text = CStr(Snw.Altitude)
        If Snw.B3 = True Then RbtnB3Oui.Checked = True Else RbtnB3Oui.Checked = False
        Affichage_Pente(0)
        If Snw.h > 0.05 Then
            'If RbtnAvecDecrochage.Checked = True Then
            'If gestionderreur(Txtb1) = True Then Snw.b1 = CDbl(Txtb1.Text) Else verif = False
            'If gestionderreur(Txtb2) = True Then Snw.b2 = CDbl(Txtb2.Text) Else verif = False
            'If gestionderreur(Txth) = True Then Snw.h = CDbl(Txth.Text) Else verif = False
            'If gestionderreur(TxtLproj) = True Then Snw.Lproj = CDbl(TxtLproj.Text) Else verif = False
        End If
    End Sub
    Private Sub BtnSauvegarde_Click(sender As Object, e As EventArgs) Handles BtnSauvegarde.Click
        Dim filename As String
        Dim Verif As Boolean = True

        Try
            With SaveFileDialog1
                .Title = "Enregistrer le projet sous ..."
                ' Si l'utilisateur ne spécifie pas d'extension et si la propriété AddExtension a la valeur True, utilise cette extension. La valeur par défaut est "".
                .DefaultExt = "txt"
                ' Ajoute l'extension par défaut si l'utilisateur a omis de la spécifier.
                ' La valeur par défaut est True.
                .AddExtension = True
                ' Vérifie si le chemin de sortie existe. Demande avant de créer un fichier ? Demande avant de remplacer le fichier ? 
                ' La valeur par défaut est True.
                .CheckPathExists = True
                ' La valeur par défaut est False.
                .CreatePrompt = False
                ' La valeur par défaut est True.
                .OverwritePrompt = True
                ' La valeur par défaut est True.
                .ValidateNames = True
                ' La valeur par défaut est False.
                .ShowHelp = True
                .InitialDirectory = Directory.GetCurrentDirectory.ToString() & "\data"
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .FilterIndex = 1
                .RestoreDirectory = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Lecture(Verif)
                        If Verif = False Then Exit Sub
                        filename = .FileName
                        Call Ecriture_Fichier(filename)
                    End If
                End If
            End With
            SaveFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MsgBox("Erreur lors de la sauvegarde: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub Ecriture_Fichier(ByVal filename As String)

        Dim myStreamWriter As StreamWriter
        'Dim Redacteur, Chantier As String
        'Redacteur = "A_faire" : Chantier = "A_faire"
        Dim i As Integer
        Try
            ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter = File.CreateText(filename)
            myStreamWriter.WriteLine("Fichier de sauvegarde de données pour le calcul de neige sur un bâtiment")
            'myStreamWriter.WriteLine(Redacteur)
            'myStreamWriter.WriteLine(Chantier)
            'données générales
            myStreamWriter.WriteLine("Données générales")
            myStreamWriter.WriteLine(Snw.RegNeige & " " & Snw.Altitude & " " & Snw.B3)
            'toitures
            myStreamWriter.WriteLine("toitures")
            myStreamWriter.WriteLine(Roof.Count) 'nbre de versant - commence à 0
            For i = 0 To Roof.Count - 1
                With Roof.Item(i)
                    myStreamWriter.WriteLine(.Pvers & " " & .Acrotere & " " & .Barre_A_Neige & " " & .b & " " & .hSaillie)
                End With
            Next
            myStreamWriter.WriteLine(Snw.b1 & " " & Snw.b2 & " " & Snw.h & " " & Snw.Lproj)

            myStreamWriter.Flush() ' Obligatoire - Vide le tampon pour être sûr que tout soit écrit dans le fichier

        Catch exc As Exception
            MsgBox("Le fichier n'a pas pu être ouvert ou écrit" + vbCrLf +
                "Vérifiez que le nom du fichier et son chemin d'accès soient exact" +
                vbCrLf + vbCrLf + "Exception: " + exc.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly,
                "Module écriture fichier")
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then myStreamWriter.Close()
        End Try

    End Sub
End Class
