﻿Imports System.IO
Imports System.Math
Public Class frmTourbillon
    Dim Fichier_NotedeCalcul As String
    Private Sub frmTourbillon_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        frmMenu.Visible = True
    End Sub
    Private Sub BtnCalcul_Click(sender As Object, e As EventArgs) Handles BtnCalcul.Click
        Dim Verif As Boolean = True
        Dim Ndc_Vent As String
        Dim b, d, h, Co, Edt1, Edt2, Vcrit, Vm As Double
        Dim RegVent, CatVent, Orocas, Cvt As Integer

        'writer de sortie du RTF
        Dim sw As New System.IO.StringWriter
        'crée un writer de RTF avec une police par défaut
        Dim rtf As New RtfAnsiTextWriter(sw, New Font(FontFamily.GenericSerif, 12, FontStyle.Regular))
        Dim rtff, msg As String
        Try
            Call Lecture_Formulaire(b, d, h, RegVent, CatVent, Cvt, Co, Orocas, Verif)
            If Verif = False Then
                MessageBox.Show("Une ou des données ne sont pas correctement renseignées. Elles doivent être corrigées pour démarrer le calcul.", "Calculette bâtiment: CsCd", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
            Call Calcul_detachement_tourbillonnaire(b, d, h, RegVent, CatVent, Co, Orocas, Cvt, Edt1, Edt2, Vcrit, Vm, Verif, rtf)
            If Verif = False Then Exit Sub
            'génère le RTF complet
            Ndc_Vent = "DeTour_" & Mise_en_Forme_date(CStr(DateTime.Now)) & ".rtf"
            Fichier_NotedeCalcul = Aff.msgResult & "\" & Ndc_Vent
            rtf.Generate() : rtff = sw.ToString : File.WriteAllText(Fichier_NotedeCalcul, rtff)
            Beep() 'signale la fin des calculs
            Affichage_Resultats(Edt1, Edt2, Vcrit, Vm) 'Affichage de la première page de résultats
            'RtbResultats.LoadFile(Fichier_NotedeCalcul)
        Catch ex As Exception
            msg = "Problème rencontré au cours du calcul" & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace
            MessageBox.Show(msg, "Calculette bâtiment: CsCd", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Lecture_Formulaire(ByRef b As Double, ByRef d As Double, ByRef h As Double, ByRef RegVent As Integer, ByRef CatVent As Integer, ByRef Cvt As Integer,
                           ByRef Co As Double, ByRef Orocas As Integer, ByRef Verif As Boolean)
        'géométrie du bâtiment: rectangulaire par défaut pour le moment

        If gestionderreur(txtLong) = True Then b = CDbl(txtLong.Text) Else Verif = False
        If gestionderreur(txtLarg) = True Then d = CDbl(txtLarg.Text) Else Verif = False
        If gestionderreur(txtHbat) = True Then h = CDbl(txtHbat.Text) Else Verif = False
        If RbtnCvtMaçonnerie.Checked = True Then Cvt = 1 'maçonnerie ou béton banché
        If RbtnCvtVoileBA.Checked = True Then Cvt = 2 'voile BA (béton banché ferraillé)
        If RbtnCvtOssatBA.Checked = True Then Cvt = 3 'portique BA
        If RbtnCvtOssatCM.Checked = True Then Cvt = 4 'portique CM

        If RbtnTerrainPlat.Checked = True Then Orocas = 0 : Co = 1
        If RbtnOroCas1.Checked = True Then
            Orocas = 1
            If gestionderreur(TextC0) = True Then Co = CDbl(TextC0.Text) Else Verif = False
        End If
        If RbtnOroCas2.Checked = True Then
            Orocas = 2
            If gestionderreur(TextC0) = True Then Co = CDbl(TextC0.Text) Else Verif = False
        End If
        Select Case CBVent.SelectedIndex
            Case 0 'région 1
                RegVent = 1
            Case 1 'région 2
                RegVent = 2
            Case 2 'région 3
                RegVent = 3
            Case 3 'région 4
                RegVent = 4
        End Select
        Select Case CBterrain.SelectedIndex 'rugosité du terrain
            Case 0 '0:
                CatVent = 1
            Case 1 'II
                CatVent = 2
            Case 2 ' IIIa
                CatVent = 3
            Case 3 'IIIb
                CatVent = 4
            Case 4 'IV
                CatVent = 5
        End Select

    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = String.Empty Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function
    Private Sub Affichage_Resultats(ByVal Edt1 As Double, ByVal Edt2 As Double, ByVal Vcrit As Double, ByVal Vm As Double)
        Lbl1.Visible = True : Lbl2.Visible = True : Lbl3.Visible = True
        Dim msg As String
        Lbl1.Text = "Rapport des dimensions transversales suivant dispositions Annexe E §E.1.2(1):"
        If Edt1 < 6 And Edt2 < 6 Then
            Lbl2.Text = "Rapport h/b (ou b/h) = " & Edt1.ToString("#0.00") & " < 6 - Aucun effet de détachement tourbillonnaire."
            Lbl3.Left = Lbl2.Location.X + Lbl2.Width + 100
            Lbl3.Text = "Rapport h/d (ou d/h) = " & Edt2.ToString("#0.00") & " < 6 - Aucun effet de détachement tourbillonnaire."
        Else
            If Edt1 < 6 Then
                msg = " < 6 - Aucun effet de détachement tourbillonnaire."
            Else
                msg = " > 6 - Effet de détachement tourbillonnaire à examiner."
            End If
            Lbl2.Text = "Rapport h/b (ou b/h) = " & Edt1.ToString("#0.00") & msg
            If Edt1 < 6 Then
                msg = " < 6 - Aucun effet de détachement tourbillonnaire."
            Else
                msg = " > 6 - Effet de détachement tourbillonnaire à examiner."
            End If
            Lbl3.Left = Lbl2.Location.X + Lbl2.Width + 100
            Lbl3.Text = "Rapport h/d (ou d/h) = " & Edt2.ToString("#0.00") & msg
            Lbl4.Visible = True
            If Vcrit > 1.25 * Vm Then
                msg = " m/s > Vitesse limite = 1,25.Vm (= " & (1.25 * Vm).ToString("#0.00") & " m/s) - Pas de vérification à faire vis à vis du détachement tourbillonnaire"
            Else
                msg = " m/s < Vitesse limite = 1,25.Vm (= " & (1.25 * Vm).ToString("#0.00") & " m/s) - Vérification à faire vis à vis du détachement tourbillonnaire"
            End If
            Lbl4.Text = "V critique = " & Vcrit.ToString("#0.00") & msg
        End If
    End Sub

    Private Sub BtnEdit_Click(sender As Object, e As EventArgs) Handles BtnEdit.Click
        Try
            Select Case Aff.Editeur
                Case 1 'Editeur Interne
                    Dim frm1 As New frmEdit
                    frm1.Affichage_frmEdit(Fichier_NotedeCalcul)
                Case 2 'éditeur Word
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                    Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
            End Select
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher la note de calcul" & vbCrLf + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub

    Private Sub BtnFichier_Click(sender As Object, e As EventArgs) Handles BtnFichier.Click
        Dim filename As String
        Dim Verif As Boolean = True
        Dim b, d, h, Co As Double
        Dim RegVent, CatVent, Cvt, Orocas As Integer
        Try
            With OpenFileDialog1
                'pour éviter tout affichage initial dans la boite de dialogue
                .FileName = ""
                ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckFileExists = True
                ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True
                ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                .DefaultExt = "txt"
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowHelp = True
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ?
                ' Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        filename = .FileName
                        Call Lecture_chaine(filename, b, d, h, RegVent, CatVent, Cvt, Co, Orocas, Verif)
                        If Verif = False Then Exit Sub
                        Call Affichage_Formulaire(b, d, h, RegVent, CatVent, Cvt, Co, Orocas)
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MsgBox("Erreur lors de la lecture du fichier: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub Lecture_chaine(ByRef filename As String, ByRef b As Double, ByRef d As Double, ByRef h As Double, ByRef RegVent As Integer, ByRef CatVent As Integer, ByRef Cvt As Integer,
                           ByRef Co As Double, ByRef Orocas As Integer, ByRef Verif As Boolean)
        Dim myStreamReader As StreamReader
        Dim toto, titi(30) As String
        Verif = True
        Try
            myStreamReader = File.OpenText(filename)
            toto = myStreamReader.ReadLine 'on n'affecte aucune valeur sur la première ligne
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Redacteur = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Chantier = CStr(titi(1))
            With Wnd
                toto = myStreamReader.ReadLine     'données générales
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                b = CDbl(titi(1)) : d = CDbl(titi(2)) : h = CDbl(titi(3))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                Cvt = CInt(titi(1))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                RegVent = CInt(titi(1)) : CatVent = CInt(titi(2))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                Orocas = CInt(titi(1)) : Co = CDbl(titi(2))
            End With
        Catch ex As Exception
            MsgBox("Erreur lors de la lecture du fichier: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
            Verif = False
        Finally
            If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
        End Try
    End Sub
    Private Sub LectureGen(ByVal toto As String, ByRef titi() As String)
        Dim blanc(45), i, j, position As Integer
        Dim tutu As String
        'toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        toto = toto.Replace(vbTab, " ") 'remplace tous les caractères de tabulation par un blanc
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
    Private Sub Affichage_Formulaire(ByVal b As Double, ByVal d As Double, ByVal h As Double, ByVal RegVent As Integer, ByVal CatVent As Integer, ByVal Cvt As Integer,
                           ByVal Co As Double, ByVal Orocas As Integer)
        txtLong.Text = b.ToString("#0.00")
        txtLarg.Text = d.ToString("#0.00")
        txtHbat.Text = h.ToString("#0.00")
        Select Case Cvt
            Case 1
                RbtnCvtMaçonnerie.Checked = True  'maçonnerie ou béton banché
            Case 2
                RbtnCvtVoileBA.Checked = True  'voile BA (béton banché ferraillé)
            Case 3
                RbtnCvtOssatBA.Checked = True  'portique BA
            Case 4
                RbtnCvtOssatCM.Checked = True  'portique CM
        End Select
        Select Case Orocas
            Case 0
                RbtnTerrainPlat.Checked = True : TextC0.Text = Co.ToString("#0.00")
            Case 1
                RbtnOroCas1.Checked = True : TextC0.Text = Co.ToString("#0.00")
            Case 2
                RbtnOroCas2.Checked = True : TextC0.Text = Co.ToString("#0.00")
        End Select

        Select Case RegVent
            Case 1 'région 1
                CBVent.SelectedIndex = 0
            Case 2 'région 2
                CBVent.SelectedIndex = 1
            Case 3 'région 3
                CBVent.SelectedIndex = 2
            Case 4 'région 4
                CBVent.SelectedIndex = 3
        End Select
        Select Case CatVent
            Case 1 '0:
                CBterrain.SelectedIndex = 0
            Case 2 'II
                CBterrain.SelectedIndex = 1
            Case 3 ' IIIa
                CBterrain.SelectedIndex = 2
            Case 4 'IIIb
                CBterrain.SelectedIndex = 3
            Case 5 'IV
                CBterrain.SelectedIndex = 4
        End Select
    End Sub
    Private Sub BtnSauvegarde_Click(sender As Object, e As EventArgs) Handles BtnSauvegarde.Click
        Dim filename As String
        Dim Verif As Boolean = True
        Dim b, d, h, Co As Double
        Dim RegVent, CatVent, Cvt, Orocas As Integer
        Try
            With SaveFileDialog1
                .Title = "Enregistrer le projet sous ..."
                ' Si l'utilisateur ne spécifie pas d'extension et si la propriété AddExtension a la valeur True, utilise cette extension. La valeur par défaut est "".
                .DefaultExt = "txt"
                ' Ajoute l'extension par défaut si l'utilisateur a omis de la spécifier.
                ' La valeur par défaut est True.
                .AddExtension = True
                ' Vérifie si le chemin de sortie existe. Demande avant de créer un fichier ? Demande avant de remplacer le fichier ? 
                ' La valeur par défaut est True.
                .CheckPathExists = True
                ' La valeur par défaut est False.
                .CreatePrompt = False
                ' La valeur par défaut est True.
                .OverwritePrompt = True
                ' La valeur par défaut est True.
                .ValidateNames = True
                ' La valeur par défaut est False.
                .ShowHelp = True
                .InitialDirectory = Directory.GetCurrentDirectory.ToString() & "\data"
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .FilterIndex = 1
                .RestoreDirectory = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Lecture_Formulaire(b, d, h, RegVent, CatVent, Cvt, Co, Orocas, Verif)
                        If Verif = False Then Exit Sub
                        filename = .FileName
                        Call Ecriture_Fichier(filename, b, d, h, RegVent, CatVent, Cvt, Co, Orocas)
                    End If
                End If
            End With
            SaveFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MsgBox("Erreur lors de la sauvegarde: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub Ecriture_Fichier(ByVal filename As String, ByVal b As Double, ByVal d As Double, ByVal h As Double, ByVal RegVent As Integer, ByVal CatVent As Integer,
                                 ByVal Cvt As Integer, ByVal Co As Double, ByVal Orocas As Integer)
        Dim myStreamWriter As StreamWriter
        Try
            myStreamWriter = File.CreateText(filename) ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter.WriteLine("Fichier de sauvegarde de données pour le calcul de CsCd ")
            myStreamWriter.WriteLine(Aff.Redacteur)
            myStreamWriter.WriteLine(Aff.Chantier)
            With Wnd
                'données générales
                myStreamWriter.WriteLine("Données générales")
                myStreamWriter.WriteLine(b & " " & d & " " & h)
                myStreamWriter.WriteLine(Cvt)
                myStreamWriter.WriteLine(RegVent & " " & CatVent)
                myStreamWriter.WriteLine(Orocas & " " & Co)
            End With
            myStreamWriter.Flush() ' Obligatoire - Vide le tampon pour être sûr que tout soit écrit dans le fichier

        Catch exc As Exception
            MsgBox("Le fichier n'a pas pu être ouvert ou écrit" + vbCrLf +
                "Vérifiez que le nom du fichier et son chemin d'accès soient exact" +
                vbCrLf + vbCrLf + "Exception: " + exc.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly,
                "Module écriture fichier")
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then myStreamWriter.Close()
        End Try

    End Sub

    Private Sub BtnZero_Click(sender As Object, e As EventArgs) Handles BtnZero.Click
        txtLong.Text = String.Empty
        txtLarg.Text = String.Empty
        txtHbat.Text = String.Empty
        RbtnCvtMaçonnerie.Checked = True  'maçonnerie ou béton banché
        RbtnTerrainPlat.Checked = True : TextC0.Text = "1"
        Lbl1.Visible = False : Lbl2.Visible = False : Lbl3.Visible = False : Lbl4.Visible = False
    End Sub
End Class