﻿Imports System.IO
Imports System.Math
Public Class frmVent
    Dim Fichier_NotedeCalcul As String
    Private Sub frmVent_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        frmMenu.Visible = True
    End Sub
    Private Sub BtnFichier_Click(sender As Object, e As EventArgs) Handles BtnFichier.Click
        Dim filename As String
        Dim Verif As Boolean = True

        Try
            With OpenFileDialog1
                'pour éviter tout affichage initial dans la boite de dialogue
                .FileName = ""
                ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckFileExists = True
                ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True
                ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                .DefaultExt = "txt"
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowHelp = True
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ?
                ' Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        filename = .FileName
                        Call Lecture_chaine(filename, Verif)
                        If Verif = False Then Exit Sub
                        Call Affichage_Formulaire()
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MsgBox("Erreur lors de la lecture du fichier: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub Lecture_chaine(ByRef filename As String, ByRef Verif As Boolean)
        Dim myStreamReader As StreamReader
        Dim toto, titi(30) As String
        Dim i, j As Integer
        Verif = True
        Try
            myStreamReader = File.OpenText(filename)
            toto = myStreamReader.ReadLine 'on n'affecte aucune valeur sur la première ligne
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Redacteur = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Chantier = CStr(titi(1))
            With Wnd
                toto = myStreamReader.ReadLine     'données générales
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                .GeomBat = CInt(titi(1)) : .Duree = CInt(titi(2))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                .LongBat = CDbl(titi(1)) : .LargBat = CDbl(titi(2)) : .Hbat = CDbl(titi(3)) : .GeomToiture = CInt(titi(4)) : .Cfr_Mur = CDbl(titi(5)) : .Cfr_Toit = CDbl(titi(6))
                toto = myStreamReader.ReadLine     'toitures
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                .Hp = CDbl(titi(1)) : .r = CDbl(titi(2)) : .alpha = CDbl(titi(3))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                .Pente_1Vers = CDbl(titi(1))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                .Pvg = CDbl(titi(1)) : .Pvd = CDbl(titi(2)) : .DecalFaitage = CDbl(titi(3))
                toto = myStreamReader.ReadLine     'Pression extérieure
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                .RegVent = CInt(titi(1)) : .CatVent = CInt(titi(2)) : .Cdir = CInt(titi(3)) : .Cseason = CInt(titi(4)) : .CsCd = CDbl(titi(5)) : .Zeref = CDbl(titi(6)) : .OroCas = CInt(titi(7)) : .Coro = CDbl(titi(8))
                toto = myStreamReader.ReadLine     'Pression intérieure
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                .ValCpi = CInt(titi(1)) : .SalpG = CDbl(titi(2)) : .SalpG = CDbl(titi(3)) : .SapigB = CDbl(titi(4)) : .SapigH = CDbl(titi(5))
                toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
                .CpiPlus = CDbl(titi(1)) : .CpiMoins = CDbl(titi(2))
            End With
        Catch ex As Exception
            MsgBox("Erreur lors de la lecture du fichier: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
            Verif = False
        Finally
            If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
        End Try
    End Sub
    Private Sub LectureGen(ByVal toto As String, ByRef titi() As String)
        Dim blanc(45), i, j, position As Integer
        Dim tutu As String
        'toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        toto = toto.Replace(vbTab, " ") 'remplace tous les caractères de tabulation par un blanc
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
    Private Sub Affichage_Formulaire()
        '------------------------------------------------------------------------------------------------------------------
        'onglet 1 vent 
        '------------------------------------------------------------------------------------------------------------------
        TxtChantier.Text = Aff.Chantier
        With Wnd
            Select Case .Duree 'durée du projet
                Case 2 '2 ans
                    CbDuree.Text = CbDuree.Items(0).ToString
                Case 5 '5 ans
                    CbDuree.Text = CbDuree.Items(1).ToString
                Case 10 ' 10 ans
                    CbDuree.Text = CbDuree.Items(2).ToString
                Case 25 '25 ans
                    CbDuree.Text = CbDuree.Items(3).ToString
                Case 50 '50 ans
                    CbDuree.Text = CbDuree.Items(4).ToString
                Case 100 '100 ans
                    CbDuree.Text = CbDuree.Items(5).ToString
            End Select
            'géométrie du bâtiment: rectangulaire par défaut pour le moment
            Wnd.GeomBat = 1
            RbtnGeomBatRectangulaire.Checked = True
            txtLong.Text = .LongBat.ToString("#0.00")
            txtLarg.Text = .LargBat.ToString("#0.00")
            txtHbat.Text = .Hbat.ToString("#0.00")
            Select Case .Cfr_Mur
                Case 0.01
                    CbFrotMur.Text = CbFrotMur.Items(0).ToString
                Case 0.02
                    CbFrotMur.Text = CbFrotMur.Items(1).ToString
                Case 0.04
                    CbFrotMur.Text = CbFrotMur.Items(2).ToString
            End Select
            Select Case .GeomToiture
                Case 1 'toiture terrasse
                    RbtnTerrasse.Checked = True
                    If Wnd.Hp = 0 And Wnd.r = 0 And Wnd.alpha = 0 Then
                        RbtnSansAcrotere.Checked = True
                    ElseIf .Hp > 0.05 Then
                        RbtnAcrotere.Checked = True
                        txtHp.Text = .Hp.ToString("#0.00")
                    ElseIf .r > 0.05 Then
                        RbtnRiveArrondie.Checked = True
                        Txtr.Text = .r.ToString("#0.00")
                    ElseIf .alpha > 0.05 Then
                        RbtnBrisisMansard.Checked = True
                        TxtMansard.Text = .alpha.ToString("#0.00")
                    End If
                    Select Case .Cfr_Toit
                        Case 0.01
                            CbFrotTerrasse.Text = CbFrotTerrasse.Items(0).ToString
                        Case 0.02
                            CbFrotTerrasse.Text = CbFrotTerrasse.Items(1).ToString
                        Case 0.04
                            CbFrotTerrasse.Text = CbFrotTerrasse.Items(2).ToString
                    End Select
                    .Pente_1Vers = .Pente_1Vers * 180 / PI   ' -> conversion en °
                    TxtPenteTerrasse.Text = .Pente_1Vers.ToString("#0.0")
                    CbPenteTerrasse.Text = CbPenteTerrasse.Items(0).ToString
                Case 2 'toiture 1 versant
                    Rbtn_1Versant.Checked = True
                    .Pente_1Vers = .Pente_1Vers * 180 / PI   ' -> conversion en °
                    Txt1Versant.Text = .Pente_1Vers.ToString("#0.0")
                    CbPente1V.Text = CbPente1V.Items(0).ToString
                    Select Case .Cfr_Toit
                        Case 0.01
                            CbFrot1Versant.Text = CbFrot1Versant.Items(0).ToString
                        Case 0.02
                            CbFrot1Versant.Text = CbFrot1Versant.Items(1).ToString
                        Case 0.04
                            CbFrot1Versant.Text = CbFrot1Versant.Items(2).ToString
                    End Select
                Case 3 'toiture 2 versants
                    Rbtn_2Versant.Checked = True
                    .Pvg = .Pvg * 180 / PI : .Pvd = .Pvd * 180 / PI   ' -> conversion en °
                    txtPvg.Text = .Pvg.ToString("#0.0") : txtPvd.Text = .Pvd.ToString("#0.0")
                    CbPente2Vg.Text = CbPente2Vg.Items(0).ToString
                    CbPente2Vd.Text = CbPente2Vd.Items(0).ToString
                    If Abs(.DecalFaitage) > 0.05 Then
                        ChkbDecalFaitage.Checked = True : TxtFaitage.Text = .DecalFaitage.ToString("#0.00")
                    End If
                    Select Case .Cfr_Toit
                        Case 0.01
                            CbFrot2Versant.Text = CbFrot2Versant.Items(0).ToString
                        Case 0.02
                            CbFrot2Versant.Text = CbFrot2Versant.Items(1).ToString
                        Case 0.04
                            CbFrot2Versant.Text = CbFrot2Versant.Items(2).ToString
                    End Select
                Case 4
                    RbtnVersantMulti.Checked = True
            End Select
        End With
        '------------------------------------------------------------------------------------------------------------------
        'onglet 2 vent 
        '------------------------------------------------------------------------------------------------------------------
        Select Case Wnd.RegVent
            Case 1 'région 1
                CBVent.SelectedIndex = 0
            Case 2 'région 2
                CBVent.SelectedIndex = 1
            Case 3 'région 3
                CBVent.SelectedIndex = 2
            Case 4 'région 4
                CBVent.SelectedIndex = 3
        End Select
        Select Case Wnd.CatVent
            Case 1 '0:
                CBterrain.SelectedIndex = 0
            Case 2 'II
                CBterrain.SelectedIndex = 1
            Case 3 ' IIIa
                CBterrain.SelectedIndex = 2
            Case 4 'IIIb
                CBterrain.SelectedIndex = 3
            Case 5 'IV
                CBterrain.SelectedIndex = 4
        End Select
        Select Case Wnd.Duree 'durée du projet
            Case 2 '2 ans
                CbDuree.SelectedIndex = 0
            Case 5 '5 ans
                CbDuree.SelectedIndex = 1
            Case 10 ' 10 ans
                CbDuree.SelectedIndex = 2
            Case 25 '25 ans
                CbDuree.SelectedIndex = 3
            Case 50 '50 ans
                CbDuree.SelectedIndex = 4
            Case 100 '100 ans
                CbDuree.SelectedIndex = 5
        End Select
        Select Case Wnd.Zeref 'influence avoisinant
            Case Is < 0.1 'pas d'influence
                RbtnNoBatGrand.Checked = True
                TextZe.Text = "0" : TextZe.Enabled = False
            Case Else
                RbtnBatGrand.Checked = True
                TextZe.Text = Wnd.Zeref.ToString("#0.00")
        End Select
        TextCsCd.Text = Wnd.CsCd.ToString("#0.00")
        TextCdir.Text = Wnd.Cdir.ToString("#0.00")
        TextCseason.Text = Wnd.Cseason.ToString("#0.00")
        Select Case Wnd.OroCas
            Case 0
                RbtnTerrainPlat.Checked = True
            Case 1
                RbtnOroCas1.Checked = True
                TextC0.Text = Wnd.Coro.ToString("#0.00")
            Case 2
                RbtnOroCas2.Checked = True
                TextC0.Text = Wnd.Coro.ToString("#0.00")
        End Select
        'If Ouvert = True Then
        '    RbtnOuvert.Checked = True
        'Else
        RbtnFerme.Checked = True
        Select Case Wnd.ValCpi
            Case 1 'Cpi inconnu et surface des ouvertures inconnues - Cpi prends 2 valeurs +0.2/-0.3
                RbtnCpiPermInconnu.Checked = True
                Wnd.SalpG = 0
                Wnd.SalpD = 0
                Wnd.SapigB = 0
                Wnd.SapigH = 0
            Case 2 'Cpi inconnu et surface des ouvertures connues - Cpi calculé par le logiciel
                RbtnCpiPermConnu.Checked = True
                TextSaLpg.Text = Wnd.SalpG.ToString("#0.000")
                TextSaLpd.Text = Wnd.SalpD.ToString("#0.000")
                TextSapigB.Text = Wnd.SapigB.ToString("#0.000")
                TextSapigH.Text = Wnd.SapigH.ToString("#0.000")
            Case 3 'Cpi renseigné directement
                RbtnCpiPermConnu.Checked = True
                TextCpiplus.Text = Wnd.CpiPlus.ToString("#0.000")
                TextCpiMoins.Text = Wnd.CpiMoins.ToString("#0.000")
        End Select

    End Sub
    Private Sub frmVent_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        '1ier chargement
        Initialisation()
        RbtnGeomMur.Enabled = False
        RbtnGeomToitureIsole.Enabled = False
        TxtChantier.Focus()
    End Sub
    Private Sub Initialisation()
        'pour éviter trop d'écriture, une partie des propriétés est directement renseignée dans le concepteur de vue
        'onglet caractéristiques géométriques
        TxtChantier.Text = Aff.Chantier.ToString
        CbDuree.Text = CbDuree.Items(4).ToString '50 ans
    End Sub
    Private Sub RbtnAcrotere_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnAcrotere.CheckedChanged
        If RbtnAcrotere.Checked = True Then
            txtHp.Enabled = True : txtHp.Focus()
            ChkbAcrotLongPan.Enabled = True : ChkbAcrotPignon.Enabled = True
            ChkbAcrotLongPan.Checked = True : ChkbAcrotPignon.Checked = True
        End If
    End Sub

    Private Sub RbtnSansAcrotere_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnSansAcrotere.CheckedChanged
        If RbtnSansAcrotere.Checked = True Then
            txtHp.Text = String.Empty : txtHp.Enabled = False
            Txtr.Text = String.Empty : Txtr.Enabled = False
            TxtMansard.Text = String.Empty : TxtMansard.Enabled = False
        End If
    End Sub

    Private Sub RbtnTerrasse_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnTerrasse.CheckedChanged
        If RbtnTerrasse.Checked = True Then
            RbtnAcrotere.Enabled = True : RbtnSansAcrotere.Enabled = True ': RbtnBrisisMansard.Enabled = True : RbtnRiveArrondie.Enabled = True
            RbtnSansAcrotere.Checked = True
            TxtPenteTerrasse.Enabled = True
            Txt1Versant.Text = String.Empty : Txt1Versant.Enabled = False
            txtPvg.Text = String.Empty : txtPvg.Enabled = False : txtPvd.Text = String.Empty : txtPvd.Enabled = False : TxtFaitage.Text = String.Empty : TxtFaitage.Enabled = False
            ChkbDecalFaitage.Enabled = False : ChkbDecalFaitage.Checked = False
        End If
    End Sub

    Private Sub Rbtn_1Versant_CheckedChanged(sender As Object, e As EventArgs) Handles Rbtn_1Versant.CheckedChanged
        If Rbtn_1Versant.Checked = True Then
            RbtnAcrotere.Enabled = False : RbtnSansAcrotere.Enabled = False : RbtnBrisisMansard.Enabled = False : RbtnRiveArrondie.Enabled = False
            RbtnSansAcrotere.Checked = False : RbtnAcrotere.Checked = False : RbtnBrisisMansard.Checked = False : RbtnRiveArrondie.Checked = False
            TxtPenteTerrasse.Text = String.Empty : TxtPenteTerrasse.Enabled = False
            Txt1Versant.Enabled = True
            txtPvg.Text = String.Empty : txtPvg.Enabled = False : txtPvd.Text = String.Empty : txtPvd.Enabled = False : TxtFaitage.Text = String.Empty : TxtFaitage.Enabled = False
            ChkbDecalFaitage.Enabled = False : ChkbDecalFaitage.Checked = False
        End If
    End Sub

    Private Sub Rbtn_2Versant_CheckedChanged(sender As Object, e As EventArgs) Handles Rbtn_2Versant.CheckedChanged
        If Rbtn_2Versant.Checked = True Then
            RbtnAcrotere.Enabled = False : RbtnSansAcrotere.Enabled = False : RbtnBrisisMansard.Enabled = False : RbtnRiveArrondie.Enabled = False
            RbtnSansAcrotere.Checked = False : RbtnAcrotere.Checked = False : RbtnBrisisMansard.Checked = False : RbtnRiveArrondie.Checked = False
            TxtPenteTerrasse.Text = String.Empty : TxtPenteTerrasse.Enabled = False
            Txt1Versant.Text = String.Empty : Txt1Versant.Enabled = False
            txtPvg.Enabled = True : CbPente2Vg.Enabled = True
            chkbPenteEgale.Enabled = True
            ChkbDecalFaitage.Enabled = True
        End If
    End Sub

    Private Sub BtnCalcul_Click(sender As Object, e As EventArgs) Handles BtnCalcul.Click
        Dim Verif As Boolean = True
        Dim Ndc_Vent As String
        'writer de sortie du RTF
        Dim sw As New System.IO.StringWriter
        'crée un writer de RTF avec une police par défaut
        Dim rtf As New RtfAnsiTextWriter(sw, New Font(FontFamily.GenericSerif, 12, FontStyle.Regular))
        Dim rtff, msg As String
        Try
            Call Lecture_Formulaire(Verif)
            If Verif = False Then
                MessageBox.Show("Une ou des données ne sont pas correctement renseignées. Elles doivent être corrigées pour démarrer le calcul.", "Calculette bâtiment: Vent", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
            Call Calcul_Vent(rtf, Verif)
            'génère le RTF complet
            Ndc_Vent = "Vent_" & Mise_en_Forme_date(CStr(DateTime.Now)) & ".rtf"
            Fichier_NotedeCalcul = Aff.msgResult & "\" & Ndc_Vent
            rtf.Generate() : rtff = sw.ToString : File.WriteAllText(Fichier_NotedeCalcul, rtff)
            Beep() 'signale la fin des calculs
            TC1.SelectTab(3) 'Affichage de la première page de résultats
            RtbResultats.LoadFile(Fichier_NotedeCalcul)
        Catch ex As Exception
            msg = "Problème rencontré au cours du calcul" & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace
            MessageBox.Show(msg, "Calculette bâtiment: Vent", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try

    End Sub
    Private Sub Lecture_Formulaire(ByRef Verif As Boolean)
        '-----------------------------------------------------------------------------------------------------------------------------------------
        'Lecture onglet 1 feuille Vent
        '-----------------------------------------------------------------------------------------------------------------------------------------
        If TxtChantier.Text = String.Empty Then
            EP1.SetError(TxtChantier, "le champ n'a pas été renseigné!!") : Verif = False
        Else
            Aff.Chantier = TxtChantier.Text
            EP1.SetError(TxtChantier, "") ' Clear the error.
        End If
        Select Case CbDuree.SelectedIndex 'durée du projet
            Case 0 '2 ans
                Wnd.Duree = 2
            Case 1 '5 ans
                Wnd.Duree = 5
            Case 2 ' 10 ans
                Wnd.Duree = 10
            Case 3 '25 ans
                Wnd.Duree = 25
            Case 4 '50 ans
                Wnd.Duree = 50
            Case 5 '100 ans
                Wnd.Duree = 100
        End Select
        'géométrie du bâtiment: rectangulaire par défaut pour le moment
        Wnd.GeomBat = 1
        If gestionderreur(txtLong) = True Then Wnd.LongBat = CDbl(txtLong.Text) Else Verif = False
        If gestionderreur(txtLarg) = True Then Wnd.LargBat = CDbl(txtLarg.Text) Else Verif = False
        If gestionderreur(txtHbat) = True Then Wnd.Hbat = CDbl(txtHbat.Text) Else Verif = False
        If RbtnTerrasse.Checked = True Then Wnd.GeomToiture = 1
        If Rbtn_1Versant.Checked = True Then Wnd.GeomToiture = 2
        If Rbtn_2Versant.Checked = True Then Wnd.GeomToiture = 3
        If RbtnVersantMulti.Checked = True Then Wnd.GeomToiture = 4
        Select Case CbFrotMur.SelectedIndex 'rugosité paroi
            Case 0 ' lisse
                Wnd.Cfr_Mur = 0.01
            Case 1 'rugueux
                Wnd.Cfr_Mur = 0.02
            Case 2 ' trés rugueux
                Wnd.Cfr_Mur = 0.04
        End Select
        Select Case Wnd.GeomToiture
            Case 1 'toiture terrasse
                Wnd.Hp = 0 : Wnd.r = 0 : Wnd.alpha = 0
                If gestionderreur(TxtPenteTerrasse) = True Then Wnd.Pente_1Vers = CDbl(TxtPenteTerrasse.Text) Else Verif = False
                Select Case CbPenteTerrasse.SelectedIndex
                    Case 1 'en %
                        Wnd.Pente_1Vers = Atan(Wnd.Pente_1Vers / 100) ' -> conversion en radian
                    Case 0 'en degré 
                        Wnd.Pente_1Vers = Wnd.Pente_1Vers * PI / 180 ' -> conversion en radian
                End Select
                If RbtnAcrotere.Checked = True Then
                    If gestionderreur(txtHp) = True Then Wnd.Hp = CDbl(txtHp.Text) Else Verif = False
                    If ChkbAcrotLongPan.Checked = True Then Wnd.Acrot_LongPan = True Else Wnd.Acrot_LongPan = False
                    If ChkbAcrotPignon.Checked = True Then Wnd.Acrot_Pignon = True Else Wnd.Acrot_Pignon = False
                ElseIf RbtnRiveArrondie.Checked = True Then
                    If gestionderreur(Txtr) = True Then Wnd.r = CDbl(Txtr.Text) Else Verif = False
                ElseIf RbtnBrisisMansard.Checked = True Then
                    If gestionderreur(TxtMansard) = True Then Wnd.alpha = CDbl(TxtMansard.Text) Else Verif = False
                End If
                Select Case CbFrotTerrasse.SelectedIndex 'rugosité paroi
                    Case 0 ' lisse
                        Wnd.Cfr_Toit = 0.01
                    Case 1 'rugueux
                        Wnd.Cfr_Toit = 0.02
                    Case 2 ' trés rugueux
                        Wnd.Cfr_Toit = 0.04
                End Select
            Case 2 'toiture 1 versant
                If gestionderreur(Txt1Versant) = True Then Wnd.Pente_1Vers = CDbl(Txt1Versant.Text) Else Verif = False
                Select Case CbPente1V.SelectedIndex
                    Case 1 'en %
                        Wnd.Pente_1Vers = Atan(Wnd.Pente_1Vers / 100) ' -> conversion en radian
                    Case 0 'en degré 
                        Wnd.Pente_1Vers = Wnd.Pente_1Vers * PI / 180 ' -> conversion en radian
                End Select
                Select Case CbFrot1Versant.SelectedIndex 'rugosité paroi
                    Case 0 ' lisse
                        Wnd.Cfr_Toit = 0.01
                    Case 1 'rugueux
                        Wnd.Cfr_Toit = 0.02
                    Case 2 ' trés rugueux
                        Wnd.Cfr_Toit = 0.04
                End Select
            Case 3 'toiture 2 versants
                If gestionderreur(txtPvg) = True Then Wnd.Pvg = CDbl(txtPvg.Text) Else Verif = False
                Select Case CbPente2Vg.SelectedIndex
                    Case 1 'en %
                        Wnd.Pvg = Atan(Wnd.Pvg / 100) ' -> conversion en radian
                    Case 0 'en degré 
                        Wnd.Pvg = Wnd.Pvg * PI / 180 ' -> conversion en radian
                End Select
                If gestionderreur(txtPvd) = True Then Wnd.Pvd = CDbl(txtPvd.Text) Else Verif = False
                Select Case CbPente2Vd.SelectedIndex
                    Case 1 'en %
                        Wnd.Pvd = Atan(Wnd.Pvd / 100) ' -> conversion en radian
                    Case 0 'en degré 
                        Wnd.Pvd = Wnd.Pvd * PI / 180 ' -> conversion en radian
                End Select
                If ChkbDecalFaitage.Checked = True Then
                    If gestionderreur(TxtFaitage) = True Then Wnd.DecalFaitage = CDbl(TxtFaitage.Text) Else Verif = False
                End If
                Select Case CbFrot2Versant.SelectedIndex 'rugosité paroi
                    Case 0 ' lisse
                        Wnd.Cfr_Toit = 0.01
                    Case 1 'rugueux
                        Wnd.Cfr_Toit = 0.02
                    Case 2 ' trés rugueux
                        Wnd.Cfr_Toit = 0.04
                End Select
        End Select
        '-----------------------------------------------------------------------------------------------------------------------------------------
        'Lecture onglet 2 feuille Vent
        '-----------------------------------------------------------------------------------------------------------------------------------------
        If RbtnTerrainPlat.Checked = True Then Wnd.OroCas = 0 : Wnd.Coro = 1
        If RbtnOroCas1.Checked = True Then
            Wnd.OroCas = 1
            If gestionderreur(TextC0) = True Then Wnd.Coro = CDbl(TextC0.Text) Else Verif = False
        End If
        If RbtnOroCas2.Checked = True Then
            Wnd.OroCas = 2
            If gestionderreur(TextC0) = True Then Wnd.Coro = CDbl(TextC0.Text) Else Verif = False
        End If
        Select Case CBVent.SelectedIndex
            Case 0 'région 1
                Wnd.RegVent = 1
            Case 1 'région 2
                Wnd.RegVent = 2
            Case 2 'région 3
                Wnd.RegVent = 3
            Case 3 'région 4
                Wnd.RegVent = 4
        End Select
        Select Case CBterrain.SelectedIndex 'rugosité du terrain
            Case 0 '0:
                Wnd.CatVent = 1
            Case 1 'II
                Wnd.CatVent = 2
            Case 2 ' IIIa
                Wnd.CatVent = 3
            Case 3 'IIIb
                Wnd.CatVent = 4
            Case 4 'IV
                Wnd.CatVent = 5
        End Select

        If gestionderreur(TextCsCd) = True Then Wnd.CsCd = CDbl(TextCsCd.Text) Else Verif = False
        If RbtnBatGrand.Checked = True Then
            If gestionderreur(TextZe) = True Then Wnd.Zeref = CDbl(TextZe.Text) Else Verif = False
        Else
            Wnd.Zeref = 0
        End If
        If gestionderreur(TextCdir) = True Then Wnd.Cdir = CDbl(TextCdir.Text) Else Verif = False
        If gestionderreur(TextCseason) = True Then Wnd.Cseason = CDbl(TextCseason.Text) Else Verif = False
        '-----------------------------------------------------------------------------------------------------------------------------------------
        'Lecture onglet 3 feuille Vent
        '-----------------------------------------------------------------------------------------------------------------------------------------
        If RbtnOuvert.Checked = True Then
            'Ouvert = True
        Else
            'Ouvert = False
            If RbtnCpiPermInconnu.Checked = True Then
                Wnd.ValCpi = 1
                Wnd.SalpG = 0
                Wnd.SalpD = 0
                Wnd.SapigB = 0
                Wnd.SapigH = 0
            End If
            If RbtnCpiPermConnu.Checked = True Then
                Wnd.ValCpi = 2
                If gestionderreur(TextSaLpg) = True Then Wnd.SalpG = CDbl(TextSaLpg.Text) Else Verif = False
                If gestionderreur(TextSaLpd) = True Then Wnd.SalpD = CDbl(TextSaLpd.Text) Else Verif = False
                If gestionderreur(TextSapigB) = True Then Wnd.SapigB = CDbl(TextSapigB.Text) Else Verif = False
                If gestionderreur(TextSapigH) = True Then Wnd.SapigH = CDbl(TextSapigH.Text) Else Verif = False
            End If
            If ChkBCpiAccidentel.Checked = True Then
                '    If gestionderreur(TextSa1) = True Then Sa1 = CDbl(TextSa1.Text)Else verif = False
                '    If gestionderreur(TextSa2) = True Then Sa2 = CDbl(TextSa2.Text)Else verif = False
                '    Empl = 1 ' a compléter
                'Else
                '    Sa1 = 0 : Sa2 = 0 : Empl = 0
            End If
            If RbtnCpi.Checked = True Then
                Wnd.ValCpi = 3
                If gestionderreur(TextCpiplus) = True Then Wnd.CpiPlus = CDbl(TextCpiplus.Text) Else Verif = False
                If gestionderreur(TextCpiMoins) = True Then Wnd.CpiMoins = CDbl(TextCpiMoins.Text) Else Verif = False
            End If
        End If
    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = String.Empty Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function
    Private Sub BtnSauvegarde_Click(sender As Object, e As EventArgs) Handles BtnSauvegarde.Click
        Dim filename As String
        Dim Verif As Boolean = True

        Try
            With SaveFileDialog1
                .Title = "Enregistrer le projet sous ..."
                ' Si l'utilisateur ne spécifie pas d'extension et si la propriété AddExtension a la valeur True, utilise cette extension. La valeur par défaut est "".
                .DefaultExt = "txt"
                ' Ajoute l'extension par défaut si l'utilisateur a omis de la spécifier.
                ' La valeur par défaut est True.
                .AddExtension = True
                ' Vérifie si le chemin de sortie existe. Demande avant de créer un fichier ? Demande avant de remplacer le fichier ? 
                ' La valeur par défaut est True.
                .CheckPathExists = True
                ' La valeur par défaut est False.
                .CreatePrompt = False
                ' La valeur par défaut est True.
                .OverwritePrompt = True
                ' La valeur par défaut est True.
                .ValidateNames = True
                ' La valeur par défaut est False.
                .ShowHelp = True
                .InitialDirectory = Directory.GetCurrentDirectory.ToString() & "\data"
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .FilterIndex = 1
                .RestoreDirectory = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Lecture_Formulaire(Verif)
                        If Verif = False Then Exit Sub
                        filename = .FileName
                        Call Ecriture_Fichier(filename)
                    End If
                End If
            End With
            SaveFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MsgBox("Erreur lors de la sauvegarde: " + vbCrLf + ex.Message & ex.StackTrace, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub
    Private Sub Ecriture_Fichier(ByVal filename As String)
        Dim myStreamWriter As StreamWriter
        Try
            myStreamWriter = File.CreateText(filename) ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter.WriteLine("Fichier de sauvegarde de données pour le calcul de vent sur un bâtiment")
            myStreamWriter.WriteLine(Aff.Redacteur)
            myStreamWriter.WriteLine(Aff.Chantier)
            With Wnd
                'données générales
                myStreamWriter.WriteLine("Données générales")
                myStreamWriter.WriteLine(.GeomBat & " " & .Duree)
                myStreamWriter.WriteLine(.LongBat & " " & .LargBat & " " & .Hbat & " " & .GeomToiture & " " & .Cfr_Mur & " " & .Cfr_Toit)
                'toitures
                myStreamWriter.WriteLine("toitures")
                myStreamWriter.WriteLine(.Hp & " " & .r & " " & .alpha)
                myStreamWriter.WriteLine(.Pente_1Vers)
                myStreamWriter.WriteLine(.Pvg & " " & .Pvd & " " & .DecalFaitage)
                'Pression extérieure
                myStreamWriter.WriteLine("Pression extérieure")
                myStreamWriter.WriteLine(.RegVent & " " & .CatVent & " " & .Cdir & " " & .Cseason & " " & .CsCd & " " & .Zeref & " " & .OroCas & " " & .Coro)
                'Pression intériure
                myStreamWriter.WriteLine("Pression intérieure")
                myStreamWriter.WriteLine(.ValCpi & " " & .SalpG & " " & .SalpD & " " & .SapigB & " " & .SapigH)
                myStreamWriter.WriteLine(.CpiPlus & " " & .CpiMoins)
            End With
            myStreamWriter.Flush() ' Obligatoire - Vide le tampon pour être sûr que tout soit écrit dans le fichier

        Catch exc As Exception
            MsgBox("Le fichier n'a pas pu être ouvert ou écrit" + vbCrLf +
                "Vérifiez que le nom du fichier et son chemin d'accès soient exact" +
                vbCrLf + vbCrLf + "Exception: " + exc.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly,
                "Module écriture fichier")
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then myStreamWriter.Close()
        End Try

    End Sub
#Region "Fichier d'aide"
    Private Sub BtnHlpRegVent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpRegVent.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 22
        frm1.Show()
    End Sub
    Private Sub BtnHlpCdir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpCdir.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 4
        frm1.Show()
    End Sub
    Private Sub BtnHlpCseason_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpCseason.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 5
        frm1.Show()
    End Sub
    Private Sub BtnHlpBatOuvert_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpBatOuvert.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 6
        frm1.Show()
    End Sub
    Private Sub BtnHlpOrographie_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpOrographie.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 8
        frm1.Show()
    End Sub
    Private Sub BtnHlpRugosite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpRugosite.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 9
        frm1.Show()
    End Sub
    Private Sub BtnHlpPerm7296Note2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpPerm7296Note2.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 17
        frm1.Show()
    End Sub
    Private Sub BtnHlpPermDominant_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpPermDominant.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 18
        frm1.Show()
    End Sub
    Private Sub BtnHlpCsCD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpCsCD.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 23
        frm1.Show()
    End Sub
    Private Sub BtnHlpConstrucAvoisinante_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpConstrucAvoisinante.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 24
        frm1.Show()
    End Sub
    Private Sub BtnHlpDuree_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHlpDuree.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 25
        frm1.Show()
    End Sub

    Private Sub BtnHlpCorrelation_Click(sender As Object, e As EventArgs) Handles BtnHlpCorrelation.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 7
        frm1.Show()
    End Sub
#End Region

#Region "gestion Textbox"
    Private Sub Txthbat_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles txtHbat.KeyPress
        Call Gestion_Keypress(e, txtHbat, True, False)
    End Sub
    Private Sub TxtLarg_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles txtLarg.KeyPress
        Call Gestion_Keypress(e, txtLarg, True, False)
    End Sub
    Private Sub TxtLong_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles txtLong.KeyPress
        Call Gestion_Keypress(e, txtLong, True, False)
    End Sub
    Private Sub TxtPvg_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles txtPvg.KeyPress
        Call Gestion_Keypress(e, txtPvg, False, False)
    End Sub
    Private Sub txtPvg_LostFocus(sender As Object, e As EventArgs) Handles txtPvg.LostFocus
        If chkbPenteEgale.Checked = True Then
            txtPvd.Text = txtPvg.Text
        End If
    End Sub
    Private Sub CbPente2Vg_LostFocus(sender As Object, e As EventArgs) Handles CbPente2Vg.LostFocus
        CbPente2Vd.Text = CbPente2Vd.Items(CbPente2Vg.SelectedIndex).ToString
    End Sub
#End Region
    Private Sub BtnxlsOubatiV_Click(sender As Object, e As EventArgs) Handles BtnxlsOubatiV.Click
        Try
            Dim startInfo As New ProcessStartInfo("excel.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "oubati_v3-2.xlsx"
            Process.Start(startInfo)
        Catch exc As Exception
            Dim msg As String
            msg = "Erreur: " & exc.Message & vbCrLf & "Problème d'accés au fichier."
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try
    End Sub
    Private Sub BtnEdit_Click(sender As Object, e As EventArgs) Handles BtnEdit.Click
        Try
            Select Case Aff.Editeur
                Case 1 'Editeur Interne
                    Dim frm1 As New frmEdit
                    frm1.Affichage_frmEdit(Fichier_NotedeCalcul)
                Case 2 'éditeur Word
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                    Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
            End Select
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher la note de calcul" & vbCrLf + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try
    End Sub

    Private Sub ChkbDecalFaitage_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbDecalFaitage.CheckedChanged
        If ChkbDecalFaitage.Checked = True Then
            TxtFaitage.Enabled = True : TxtFaitage.Focus()
        Else
            TxtFaitage.Enabled = False
        End If
    End Sub

    Private Sub chkbPenteEgale_CheckedChanged(sender As Object, e As EventArgs) Handles chkbPenteEgale.CheckedChanged
        If chkbPenteEgale.Checked = False Then
            txtPvd.Enabled = True : CbPente2Vd.Enabled = True : txtPvd.Focus()
        Else
            txtPvd.Enabled = False : CbPente2Vd.Enabled = False
        End If
    End Sub
    Private Sub RbtnOroCas1_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnOroCas1.CheckedChanged
        If RbtnOroCas1.Checked = True Then
            TextC0.Enabled = True : TextC0.Focus()
        End If
    End Sub
    Private Sub RbtnOroCas2_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnOroCas2.CheckedChanged
        If RbtnOroCas2.Checked = True Then
            TextC0.Enabled = True : TextC0.Focus()
        End If
    End Sub
    Private Sub RbtnTerrainPlat_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnTerrainPlat.CheckedChanged
        If RbtnTerrainPlat.Checked = True Then
            TextC0.Enabled = False : TextC0.Text = String.Empty
        End If
    End Sub

    Private Sub BtnVenturi_Click(sender As Object, e As EventArgs) Handles BtnVenturi.Click
        Try
            Dim startInfo As New ProcessStartInfo("excel.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "VENTURI_EC1_2011_V.2.01.xls"
            Process.Start(startInfo)
        Catch exc As Exception
            Dim msg As String
            msg = "Erreur: " & exc.Message & vbCrLf & "Problème d'accés au fichier."
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try
    End Sub


End Class