﻿Imports System.Math
Imports System.IO
Module Moteur_de_calcul
#Region "Neige"
    Public Sub Calcul_Neige(ByRef rtf As RtfAnsiTextWriter, ByRef Verif As Boolean) ', _
 
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.NewLine() : rtf.Bold = True
        rtf.Underline = True : rtf.WriteString("2 - Détermination des charges de neige") : rtf.Bold = False
        rtf.Underline = False : rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("Coefficient thermique Ct = 1  - bâtiment chauffé systématiquement isolé") : rtf.NewLine()
        rtf.WriteString("Coefficient d'exposition Ce = 1  - pas de protection particulière vis à vis de la neige") : rtf.NewLine()
        Snw.Neige_General() 'détermination sk, sna
        rtf.WriteString("Charge caractéristique de la neige au sol - Sk = " & Snw.Sk.ToString("#0.00") & " daN/m².") : rtf.NewLine()
        rtf.WriteString("Charge exceptionnelle de la neige")
        Select Case Snw.RegNeige
            Case 1 'A1
                rtf.WriteString(": sans objet pour la région A1") : rtf.NewLine()
            Case 5 'C1
                rtf.WriteString(": sans objet pour la région C1") : rtf.NewLine()
            Case 8 'E
                rtf.WriteString(": sans objet pour la région E") : rtf.NewLine()
            Case Else
                rtf.WriteString(" - Sa = " & Snw.Sna.ToString("#0.00") & " daN/m².") : rtf.NewLine()
        End Select
        rtf.WriteEndGroup()
        Select Case Roof.Count '=nbre de versant de toiture
            Case 1 'toiture à 1 versant
                Call Toiture_1_versant(0)
                Call Ecriture_Ndc_V_unique(0, rtf)
            Case 2 'toiture à 2 versants
                If Snw.h < 0.1 Then
                    Toiture_2_versants(0)
                    Toiture_2_versants(1)
                    Call Ecriture_Ndc_2_Versants(rtf)
                Else
                    Call Ecriture_Ndc_V_multiple_avec_attenant(rtf)
                End If
            Case Is > 2 'toiture à versants multiples
                If Snw.h < 0.1 Then
                    For i = 0 To Roof.Count - 1
                        Toiture_Versants_Multiples(i)
                    Next
                    Call Ecriture_Ndc_V_multiple_sans_attenant(rtf)
                Else
                    Call Ecriture_Ndc_V_multiple_avec_attenant(rtf)
                End If

        End Select
        rtf.WriteStartGroup() : rtf.FontSize = 12 : rtf.FontSize = 10
        rtf.NewLine() : rtf.WriteString("Rappel:") : rtf.NewLine()
        rtf.WriteString("La charge s'exerce verticalement et se rapporte à une projection horizontale de la surface de la toiture.") : rtf.NewLine()
        rtf.FontSize = 12 : rtf.NewLine() : rtf.Bold = True
        rtf.Underline = True : rtf.WriteString("3 - Détermination des charges locales de neige") : rtf.Bold = False
        rtf.Underline = False : rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("Application du §6 de l'EN1991-1-3") : rtf.NewLine()
        rtf.WriteString("Les situations de projet à considérer ci-aprés sont des situations durables/transitoires soit Etat Limite Ultime/Etat Limite de Service mais " & _
                        "pas d'Etat Limite Accidentel") : rtf.NewLine()
        rtf.Underline = True
        rtf.WriteString("3 - 1  Accumulation au droit de saillies ou d'obstacle") : rtf.Underline = False : rtf.NewLine()
        rtf.WriteEndGroup()
        Dim toto As Boolean = False
        For i = 1 To Roof.Count
            If Roof.Item(i - 1).hSaillie > 0.1 Then
                toto = True
                Call Calcul_Accumulation_Saillie(i - 1, rtf)
            End If
        Next
        If toto = False Then rtf.WriteStartGroup() : rtf.FontSize = 12 : rtf.FontSize = 10 : rtf.WriteString("Sans objet") : rtf.NewLine() : rtf.WriteEndGroup()
        rtf.WriteStartGroup() : rtf.FontSize = 12 : rtf.FontSize = 10 : rtf.Underline = True
        rtf.WriteString("3 - 2  Neige en débord de toiture") : rtf.Underline = False : rtf.NewLine()
        If Snw.Altitude < 900 Then
            rtf.WriteString("Sans objet - Altitude du projet < 900m") : rtf.NewLine() : rtf.WriteEndGroup()
        ElseIf Roof.Item(0).Acrotere = True And Roof.Item(Roof.Count - 1).Acrotere = True Then
            rtf.WriteString("Sans objet - Acrotère en rives") : rtf.NewLine() : rtf.WriteEndGroup()
        Else
            rtf.WriteEndGroup()
            Call Calcul_Neige_debord(rtf)
        End If
        rtf.WriteStartGroup() : rtf.FontSize = 12 : rtf.FontSize = 10 : rtf.Underline = True
        rtf.WriteString("3 - 3  Charges sur les barres et autres obstacles") : rtf.Underline = False : rtf.NewLine()
        rtf.WriteEndGroup()
        toto = False
        For i = 1 To Roof.Count
            If Roof.Item(i - 1).Barre_A_Neige = True Then
                toto = True
                Call Calcul_Charge_BarreaNeige(i - 1, rtf)
            End If
        Next
        rtf.WriteStartGroup() : rtf.FontSize = 12 : rtf.FontSize = 10
        If toto = True Then
            rtf.WriteString("Rappel: Fs est linéairement proportionnel à la distance entre barre. Plus la distance est grande, plus la force exercée sera importante.") : rtf.NewLine()
            rtf.WriteString("Le logiciel évalue uniquement l'effort le plus important.") : rtf.NewLine()
        Else
            rtf.WriteString("Sans objet")
        End If
        rtf.WriteEndGroup()
    End Sub
    Private Sub Ecriture_Ndc_V_unique(ByVal i As Integer, ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String
        Dim myImage As Image
        ' Dim Img As FileStream
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10
        Try
            'msg = "\Images\Charge_Snw_1Vers.bmp"
            'Img = New FileStream(Directory.GetCurrentDirectory.ToString() & msg, FileMode.Open)
            'myImage = Image.FromStream(Img)
            'Img.Close()
            myImage = My.Resources.Charge_Snw_1Vers
            rtf.InsertImage(myImage)
            myImage.Dispose()
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu charger l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
        rtf.NewLine()
        msg = String.Empty
        If Roof.Item(i).Acrotere = True Then msg = "/avec acrotère"
        If Roof.Item(i).Barre_A_Neige = True Then msg = msg & "/avec barre à neige ou équivalent"
        rtf.WriteString("Coefficient de forme - µ1 = " & µ1(i).ToString("#0.00") & "  " & msg) : rtf.NewLine()
        rtf.WriteString("Charge de projet: 1 seul cas de charge pour chaque Etat Limite.") : rtf.NewLine()
        rtf.WriteString("  - Durable/transitoire - Sn = " & Roof.Item(i).Sn.ToString("#0.00") & " daN/m².") : rtf.NewLine()
        If Roof.Item(i).Sa < 1 Then
            rtf.WriteString("  - Accidentel: sans objet") : rtf.NewLine()
        Else
            rtf.WriteString("  - Accidentel - Sad = " & Roof.Item(i).Sa.ToString("#0.00") & " daN/m².") : rtf.NewLine()
        End If
        rtf.WriteEndGroup()
    End Sub
    Private Sub Ecriture_Ndc_2_Versants(ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String
        Dim myImage As Image
        ' Dim Img As FileStream
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10
        msg = String.Empty
        If Roof.Item(0).Acrotere = True Then msg = "/avec acrotère"
        If Roof.Item(0).Barre_A_Neige = True Then msg = msg & "/avec barre à neige ou équivalent"
        rtf.WriteString("Coefficient de forme versant gauche - µ1 = " & µ1(0).ToString("#0.00") & "  " & msg) : rtf.NewLine()
        msg = String.Empty
        If Roof.Item(1).Acrotere = True Then msg = "/avec acrotère"
        If Roof.Item(1).Barre_A_Neige = True Then msg = msg & "/avec barre à neige ou équivalent"
        rtf.WriteString("Coefficient de forme versant droit - µ1 = " & µ1(1).ToString("#0.00") & "  " & msg) : rtf.NewLine()
        rtf.WriteString("Charge de projet: 3 cas de charge pour chaque Etat Limite.") : rtf.NewLine()
        rtf.WriteString("  - Durable/transitoire :") : rtf.NewLine()
        rtf.WriteString("Cas 1: disposition de charge sans accumulation") : rtf.NewLine()
        rtf.WriteString(" - versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(0).ToString("#0.00") & " daN/m².") : rtf.NewLine()
        Try
            'msg = "\Images\Charge_Snw_2Vers_cas1.bmp"
            'Img = New FileStream(Directory.GetCurrentDirectory.ToString() & msg, FileMode.Open)
            'myImage = Image.FromStream(Img)
            'Img.Close()
            myImage = My.Resources.Charge_Snw_2Vers_cas1
            rtf.InsertImage(myImage)
            myImage.Dispose()
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu charger l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
        rtf.NewLine()
        rtf.WriteString("Cas 2: disposition de charge avec accumulation") : rtf.NewLine()
        rtf.WriteString(" - versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(1).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
        Try
            'msg = "\Images\Charge_Snw_2Vers_cas2.bmp"
            'Img = New FileStream(Directory.GetCurrentDirectory.ToString() & msg, FileMode.Open)
            'myImage = Image.FromStream(Img)
            'Img.Close()
            myImage = My.Resources.Charge_Snw_2Vers_cas2
            rtf.InsertImage(myImage)
            myImage.Dispose()
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu charger l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
        rtf.NewLine()
        rtf.WriteString("Cas 3: disposition de charge avec accumulation") : rtf.NewLine()
        rtf.WriteString(" - versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(2).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1.Item(2).ToString("#0.00") & " daN/m².") : rtf.NewLine()
        Try
            'msg = "\Images\Charge_Snw_2Vers_cas3.bmp"
            'Img = New FileStream(Directory.GetCurrentDirectory.ToString() & msg, FileMode.Open)
            'myImage = Image.FromStream(Img)
            'Img.Close()
            myImage = My.Resources.Charge_Snw_2Vers_cas3
            rtf.InsertImage(myImage)
            myImage.Dispose()
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu charger l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
        rtf.NewLine()
        If Roof.Item(0).Sa < 1 Then
            rtf.WriteString("  - Accidentel: sans objet") : rtf.NewLine()
        Else
            rtf.WriteString("  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)") : rtf.NewLine()
            rtf.WriteString("Cas 1: disposition de charge sans accumulation") : rtf.NewLine()
            rtf.WriteString(" - versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m².") : rtf.NewLine()
            rtf.WriteString("Cas 2: disposition de charge avec accumulation") : rtf.NewLine()
            rtf.WriteString(" - versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
            rtf.WriteString("Cas 3: disposition de charge avec accumulation") : rtf.NewLine()
            rtf.WriteString(" - versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(2).ToString("#0.00") & " daN/m²  /  versant droit - Sad2 = " & Roof.Item(1).K_charge1_ad.Item(2).ToString("#0.00") & " daN/m².") : rtf.NewLine()
        End If
        rtf.WriteEndGroup()
    End Sub
    Private Sub Ecriture_Ndc_V_multiple_sans_attenant(ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String
        Dim myImage As Image
        '  Dim Img As FileStream
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10
        Try
            'msg = "\Images\charge_Vmultiple.png"
            'Img = New FileStream(Directory.GetCurrentDirectory.ToString() & msg, FileMode.Open)
            'myImage = Image.FromStream(Img)
            'Img.Close()
            myImage = My.Resources.charge_Vmultiple
            rtf.InsertImage(myImage)
            myImage.Dispose()
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu charger l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
        rtf.NewLine()
        msg = String.Empty
        rtf.WriteString("Charge de projet: 2 cas de charge pour chaque Etat Limite.") : rtf.NewLine()
        rtf.WriteString("  - Durable/transitoire :") : rtf.NewLine()
        rtf.WriteString("Cas 1: disposition de charge sans accumulation") : rtf.NewLine()
        For i = 0 To Roof.Count - 1 Step 2
            'Toiture_Versants_Multiples(i)
            rtf.WriteString(" versant gauche - Sn1 = " & Roof.Item(i).K_charge1.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(i + 1).K_charge1.Item(0).ToString("#0.00") & " daN/m².") : rtf.NewLine()
        Next
        rtf.WriteString("Cas 2: disposition de charge avec accumulation") : rtf.NewLine()
        For i = 0 To Roof.Count - 1 Step 2
            Select Case i
                Case 0
                    rtf.WriteString(" versant gauche - Sn1 = " & Roof.Item(0).K_charge1.Item(1).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                    rtf.WriteString(" versant droit - Sn2(µ1) = " & Roof.Item(1).K_charge1.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                    rtf.WriteString("               - Sn2(µ2) = " & Roof.Item(1).K_charge2.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                Case Roof.Count - 2
                    rtf.WriteString(" versant gauche - Sn2(µ2) = " & Roof.Item(i).K_charge1.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                    rtf.WriteString("               - Sn2(µ1) = " & Roof.Item(i).K_charge2.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                    rtf.WriteString(" versant droit - Sn1 = " & Roof.Item(i + 1).K_charge1.Item(1).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                Case Else
                    rtf.WriteString(" versant gauche - Sn2(µ1) = " & Roof.Item(i).K_charge1.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                    rtf.WriteString("               - Sn2(µ2) = " & Roof.Item(i).K_charge2.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                    rtf.WriteString(" versant droit - Sn2(µ2) = " & Roof.Item(i + 1).K_charge1.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                    rtf.WriteString("               - Sn2(µ1) = " & Roof.Item(i + 1).K_charge2.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
            End Select
        Next
        If Roof.Item(0).Sa < 1 Then
            rtf.WriteString("  - Accidentel: sans objet") : rtf.NewLine()
        Else
            rtf.WriteString("  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)") : rtf.NewLine()
            rtf.WriteString("Cas 1: disposition de charge sans accumulation") : rtf.NewLine()
            For i = 0 To Roof.Count - 1 Step 2
                rtf.WriteString(" versant gauche - Sad1 = " & Roof.Item(0).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²  /  versant droit - Sn2 = " & Roof.Item(1).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m².") : rtf.NewLine()
            Next
            rtf.WriteString("Cas 2: disposition de charge avec accumulation") : rtf.NewLine()
            For i = 0 To Roof.Count - 1 Step 2
                Select Case i
                    Case 0
                        rtf.WriteString(" versant gauche - Sn1 = " & Roof.Item(0).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString(" versant droit - Sn2(µ1) = " & Roof.Item(1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                        rtf.WriteString("               - Sn2(µ2) = " & Roof.Item(1).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                    Case Roof.Count - 2
                        rtf.WriteString(" versant gauche - Sn2(µ2) = " & Roof.Item(i).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                        rtf.WriteString("               - Sn2(µ1) = " & Roof.Item(i).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                        rtf.WriteString(" versant droit - Sn1 = " & Roof.Item(i + 1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                    Case Else
                        rtf.WriteString(" versant gauche - Sn2(µ1) = " & Roof.Item(i).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                        rtf.WriteString("               - Sn2(µ2) = " & Roof.Item(i).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                        rtf.WriteString(" versant droit - Sn2(µ2) = " & Roof.Item(i + 1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                        rtf.WriteString("               - Sn2(µ1) = " & Roof.Item(i + 1).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
                End Select
            Next
        End If
        rtf.WriteEndGroup()
    End Sub
    Private Sub Ecriture_Ndc_V_multiple_avec_attenant(ByRef rtf As RtfAnsiTextWriter)
        Dim i As Integer
        Select Case Roof.Count
            Case 2
                i = 0
                Call Toiture_1_versant(i)
                Call Ecriture_Ndc_V_unique(i, rtf)
                Call Toiture_Attenante(Roof.Count - 1, rtf)
            Case 3
                Toiture_2_versants(0)
                Toiture_2_versants(1)
                Call Ecriture_Ndc_2_Versants(rtf)
                Call Toiture_Attenante(Roof.Count - 1, rtf)
            Case Else
                rtf.WriteStartGroup()
                rtf.NewLine() : rtf.WriteString("Non implémenté") : rtf.NewLine()
                rtf.WriteEndGroup()
        End Select
    End Sub
    Private Sub Ecriture_Ndc_attenant(ByVal µsn As Double, ByVal µsa As Double, ByVal µw As Double, ByVal µrn As Double, ByVal µra As Double, ByVal ls As Double,
                                      ByVal Image_Ndc As Integer, ByVal Glissement As Boolean, ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String
        Dim myImage As Image = My.Resources.wind_flag_storm 'par défaut
        ' Dim Img As FileStream
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10
        Try
            'msg = "\Images\" & Image_Ndc
            'Img = New FileStream(Directory.GetCurrentDirectory.ToString() & msg, FileMode.Open)
            'myImage = Image.FromStream(Img)
            'Img.Close()
            Select Case Image_Ndc
                Case 1 ' "Decrochage_supLs.png"
                    myImage = My.Resources.Decrochage_supLs
                Case 2  ' "Decrochage_infLs.png"
                    myImage = My.Resources.Decrochage_infLs
            End Select
            rtf.InsertImage(myImage)
            myImage.Dispose()
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu charger l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
        rtf.NewLine()
        rtf.WriteString("Charge de projet: 2 cas de charge pour chaque Etat Limite.") : rtf.NewLine()
        rtf.WriteString("Longueur d'accumulation - ls = " & ls.ToString("#0.00") & " m") : rtf.NewLine()
        rtf.WriteString("Coefficient de forme - µw = " & µw.ToString("#0.00") & " - Effet du vent") : rtf.NewLine()
        If Glissement = True Then
            rtf.WriteString("Coefficient de forme - µs = " & µsn.ToString("#0.00") & " - Glissement de la neige") : rtf.NewLine()
        Else
            rtf.WriteString("Coefficient de forme - µs = sans objet - Pas de glissement de la neige de la toiture supérieure vers la toiture inférieure") : rtf.NewLine()
        End If
        If Snw.b2 >= ls Then
            rtf.WriteString("Coefficient de forme - µ1 = " & µrn.ToString("#0.00")) : rtf.NewLine()
        Else
            rtf.WriteString("Coefficient de forme extrémité - µ = " & µrn.ToString("#0.00")) : rtf.NewLine()
        End If
        rtf.WriteString("  - Durable/transitoire :") : rtf.NewLine()
        rtf.WriteString("Cas 1: disposition de charge sans accumulation") : rtf.NewLine()
        rtf.WriteString(" Sn = " & Roof.Item(Roof.Count - 1).K_charge1.Item(0).ToString("#0.00") & " daN/m²") : rtf.NewLine()
        rtf.WriteString("Cas 2: disposition de charge avec accumulation") : rtf.NewLine()
        rtf.WriteString(" Maxi - Sn = " & Roof.Item(Roof.Count - 1).K_charge1.Item(1).ToString("#0.00") & " daN/m²") : rtf.NewLine()
        rtf.WriteString(" mini - Sn = " & Roof.Item(Roof.Count - 1).K_charge2.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
        If Roof.Item(0).Sa < 1 Then
            rtf.WriteString("  - Accidentel: sans objet") : rtf.NewLine()
        Else
            rtf.WriteString("  - Accidentel: (la numérotation des cas est identique à celle présentée ci-avant)") : rtf.NewLine()
            If Glissement = True Then rtf.WriteString("Coefficient de forme - µs = " & µsa.ToString("#0.00")) : rtf.NewLine()
            If Snw.b2 >= ls Then
                rtf.WriteString("Coefficient de forme - µ1 = " & µra.ToString("#0.00")) : rtf.NewLine()
            Else
                rtf.WriteString("Coefficient de forme extrémité - µ = " & µra.ToString("#0.00")) : rtf.NewLine()
            End If
            rtf.WriteString("Cas 1: disposition de charge sans accumulation") : rtf.NewLine()
            rtf.WriteString(" Sad = " & Roof.Item(Roof.Count - 1).K_charge1_ad.Item(0).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Cas 2: disposition de charge avec accumulation") : rtf.NewLine()
            rtf.WriteString(" Maxi - Sad = " & Roof.Item(Roof.Count - 1).K_charge1_ad.Item(1).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString(" mini - Sad = " & Roof.Item(Roof.Count - 1).K_charge2_ad.Item(1).ToString("#0.00") & " daN/m².") : rtf.NewLine()
        End If
        rtf.WriteString("Les cas de charges présentés ci-dessus sont à combiner avec les cas de charges de la toiture adjacent. Ainsi, le cas 2 ci-dessus doit se combiner" &
                        " avec le cas 1 de la toiture adjacente et ainsi de suite ...") : rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub
    Private Sub Toiture_1_versant(ByVal i As Integer)
        With Roof.Item(i)
            .Sn = µ1(i) * .Ce * .Ct * Snw.Sk
            .Sa = µ1(i) * .Ce * .Ct * Snw.Sna
            .K_charge1.Add(.Sn) : .K_charge2.Add(.Sn)
        End With

    End Sub
    Private Sub Toiture_2_versants(ByVal i As Integer)
        Dim j As Integer
        With Roof.Item(i)
            .Sn = µ1(i) * .Ce * .Ct * Snw.Sk
            .Sa = µ1(i) * .Ce * .Ct * Snw.Sna
            For j = 1 To 3
                Select Case j
                    Case 1
                        .K_charge1.Add(.Sn) : .K_charge2.Add(.Sn) : .K_charge1_ad.Add(.Sa) : .K_charge2_ad.Add(.Sa)
                    Case 2
                        .K_charge1.Add(If(i = 0, 0.5 * .Sn, .Sn)) : .K_charge2.Add(If(i = 0, 0.5 * .Sn, .Sn))
                        .K_charge1_ad.Add(If(i = 0, 0.5 * .Sa, .Sa)) : .K_charge2_ad.Add(If(i = 0, 0.5 * .Sa, .Sa))
                    Case 3
                        .K_charge1.Add(If(i = 0, .Sn, 0.5 * .Sn)) : .K_charge2.Add(If(i = 0, .Sn, 0.5 * .Sn))
                        .K_charge1_ad.Add(If(i = 0, .Sa, 0.5 * .Sa)) : .K_charge2_ad.Add(If(i = 0, .Sa, 0.5 * .Sa))
                End Select
            Next
        End With
    End Sub
    Private Sub Toiture_Versants_Multiples(ByVal i As Integer)
        Dim j, k As Integer
        With Roof.Item(i)
            .Sn = µ1(i) * .Ce * .Ct * Snw.Sk
            .Sa = µ1(i) * .Ce * .Ct * Snw.Sna
            Select Case i
                Case 0 Or Roof.Count - 1
                    For j = 1 To 2
                        .K_charge1.Add(.Sn)
                        .K_charge2.Add(.Sn)
                    Next
                Case Else
                    j = DivRem(i, 2, k) 'si i nbre pair, k=0
                    For j = 1 To 2
                        Select Case k
                            Case 0 'toiture droite de la noue
                                Select Case j
                                    Case 1
                                        .K_charge1.Add(.Sn) : .K_charge2.Add(.Sn)
                                    Case 2
                                        .Sn = µ2(i, False) * .Ce * .Ct * Snw.Sk
                                        .K_charge1.Add(.Sn)
                                        .Sn = µ1(i + 1) * .Ce * .Ct * Snw.Sk
                                        .K_charge2.Add(.Sn)
                                End Select
                            Case 1 'toiture gauche
                                Select Case j
                                    Case 1
                                        .K_charge1.Add(.Sn) : .K_charge2.Add(.Sn)
                                    Case 2
                                        .Sn = µ1(i - 1) * .Ce * .Ct * Snw.Sk
                                        .K_charge1.Add(.Sn)
                                        .Sn = µ2(i, True) * .Ce * .Ct * Snw.Sk
                                        .K_charge2.Add(.Sn)
                                End Select
                            Case Else
                                Stop
                        End Select
                    Next
            End Select

        End With
    End Sub
    Private Sub Toiture_Attenante(ByVal i As Integer, ByRef rtf As RtfAnsiTextWriter)
        Dim Cmax, ls, µsn, µsa, µw, µrn, µra, µls, Lim_µw As Double
        Dim Image_Ndc As Integer
        Dim Glissement As Boolean
        Select Case Roof.Item(i).Pvers
            Case Is < -2
                rtf.WriteStartGroup()
                rtf.NewLine() : rtf.WriteString("Non implémenté") : rtf.NewLine()
                rtf.WriteEndGroup()
            Case Is <= 2
                With Roof.Item(i)
                    'Calcul du cas (i)
                    .Sn = µ1(i) * .Ce * .Ct * Snw.Sk
                                .Sa = µ1(i) * .Ce * .Ct * Snw.Sna
                                .K_charge1.Add(.Sn) : .K_charge2.Add(.Sn) : .K_charge1_ad.Add(.Sa) : .K_charge2_ad.Add(.Sa)
                    'Calcul du cas (ii)
                    µw = (Snw.b1 + Snw.b2) / (Snw.h * 2)
                                Lim_µw = (200 * Snw.h) / Snw.Sk
                                If Lim_µw < 0.8 Then Lim_µw = 0.8
                                If Lim_µw > 2.8 Then Lim_µw = 2.8
                                If µw > Lim_µw Then µw = Lim_µw
                                ls = 2 * Snw.h
                                If ls < 5 Then ls = 5
                                If ls > 15 Then ls = 15
                                'caractéristique
                                If Roof.Item(i - 1).Pvers <= 15 Then
                                    µsn = 0 : Glissement = False
                                Else
                                    Glissement = True
                                    µsn = µ1(i - 1) * Snw.Lproj / ls
                                End If
                                If ls <= Snw.b2 Then
                                    Image_Ndc = 1 ' "Decrochage_supLs.png"
                                    .K_charge1.Add((µsn + µw) * .Ce * .Ct * Snw.Sk) : .K_charge2.Add(µ1(i) * .Ce * .Ct * Snw.Sk)
                                    µrn = µ1(i)
                                Else
                                    Image_Ndc = 2 ' "Decrochage_infLs.png"
                                    µls = (ls - Snw.b2) * (µsn + µw - 0.8) / ls
                                    .K_charge1.Add((µsn + µw) * .Ce * .Ct * Snw.Sk) : .K_charge2.Add((µls + 0.8) * .Ce * .Ct * Snw.Sk)
                                    µrn = µls + 0.8
                                End If
                                'accidentel
                                If Roof.Item(i - 1).Pvers <= 15 Then
                                    µsa = 0
                                Else
                                    Cmax = µ1(i - 1) * .Ce * .Ct * Snw.Sna * Snw.Lproj * 1 / 200 'charge impérativement en kN - pour une bande de largeur 1m
                                    µsa = µ1(i - 1) * Snw.Lproj / ls
                                End If
                                If ls <= Snw.b2 Then
                                    .K_charge1_ad.Add((µsa + µw) * .Ce * .Ct * Snw.Sna) : .K_charge2_ad.Add(µ1(i) * .Ce * .Ct * Snw.Sna)
                                    µra = µ1(i)
                                Else
                                    µls = (ls - Snw.b2) * (µsa + µw - 0.8) / ls
                                    .K_charge1_ad.Add((µsa + µw) * .Ce * .Ct * Snw.Sna) : .K_charge2_ad.Add((µls + 0.8) * .Ce * .Ct * Snw.Sna)
                                    µra = µls + 0.8
                                End If
                    '  End Select
                    ' Next
                End With
                Ecriture_Ndc_attenant(µsn, µsa, µw, µrn, µra, ls, Image_Ndc, Glissement, rtf)
            Case Else
                Call Toiture_1_versant(i)
                Call Ecriture_Ndc_V_unique(i, rtf)

        End Select
    End Sub
    Private Sub Calcul_Accumulation_Saillie(ByVal i As Integer, ByRef rtf As RtfAnsiTextWriter)
        Dim ls, µ1s, µ2s, S1, S2 As Double '
        ls = 2 * Roof.Item(i).hSaillie
        If ls < 5 Then ls = 5
        If ls > 15 Then ls = 15
        µ2s = 200 * Roof.Item(i).hSaillie / (0.8 * Snw.Sk)
        If µ2s < 0.8 Then µ2s = 0.8
        If µ2s > 2 Then µ2s = 2
        µ1s = 0.8 * µ2s
        S1 = µ1s * Roof.Item(i).Ce * Roof.Item(i).Ct * Snw.Sk
        S2 = µ2s * Roof.Item(i).Ce * Roof.Item(i).Ct * Snw.Sk
        Dim msg As String
        Dim myImage As Image
        '  Dim Img As FileStream
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10
        Try
            'msg = "\Images\Saillie.png"
            'Img = New FileStream(Directory.GetCurrentDirectory.ToString() & msg, FileMode.Open)
            'myImage = Image.FromStream(Img)
            'Img.Close()
            myImage = My.Resources.Saillie
            rtf.InsertImage(myImage)
            myImage.Dispose()
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu charger l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
        rtf.NewLine()
        rtf.WriteString("Versant " & (i + 1).ToString & " :") : rtf.NewLine()
        rtf.WriteString("Coefficient de forme - µ1 = " & µ1s.ToString("#0.00")) : rtf.NewLine()
        rtf.WriteString("Coefficient de forme - µ2 = " & µ1s.ToString("#0.00")) : rtf.NewLine()
        rtf.WriteString("Longueur d'accumulation - ls = " & ls.ToString("#0.00") & " m") : rtf.NewLine()
        rtf.WriteString("Charge locale pour ce versant:") : rtf.NewLine()
        rtf.WriteString("   - Sn1 = " & S1.ToString("#0.00") & " daN/m².") : rtf.NewLine()
        rtf.WriteString("   - Sn2 = " & S2.ToString("#0.00") & " daN/m².") : rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub
    Private Sub Calcul_Neige_debord(ByRef rtf As RtfAnsiTextWriter)
        Dim d, s, Se, k, γ As Double
        Dim msg As String
        Dim myImage As Image
        '   Dim Img As FileStream
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10
        Try
            'msg = "\Images\neige_debord.png"
            'Img = New FileStream(Directory.GetCurrentDirectory.ToString() & msg, FileMode.Open)
            'myImage = Image.FromStream(Img)
            'Img.Close()
            myImage = My.Resources.neige_debord
            rtf.InsertImage(myImage)
            myImage.Dispose()
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu charger l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MessageBox.Show(msg, "Calculette bâtiment", MessageBoxButtons.AbortRetryIgnore, MessageBoxIcon.Exclamation)
        End Try
        rtf.NewLine()
        rtf.WriteString("Rive 1 :") : rtf.NewLine()
        s = Roof.Item(0).K_charge1.Item(0)
        rtf.WriteString("Cas de charge non accumulée le plus sévère - s = " & s.ToString("#0.00") & " daN/m2.") : rtf.NewLine()
        γ = 300 : d = s / γ
        k = 3 / d
        If k > d * γ Then k = d * γ
        rtf.WriteString("Densité de la neige - γ = " & γ.ToString("#0.00") & " daN/m3") : rtf.NewLine()
        rtf.WriteString("Epaisseur de la neige en bordure - d = " & d.ToString("#0.00") & " m") : rtf.NewLine()
        rtf.WriteString("Coefficient de debord - k = " & k.ToString("#0.00")) : rtf.NewLine()
        Se = k * s ^ 2 / γ
        rtf.WriteString("Charge suspendue - Se = " & Se.ToString("#0.00") & " daN/m.") : rtf.NewLine()
        rtf.WriteString("Rive 2 :") : rtf.NewLine()
        s = Roof.Item(Roof.Count - 1).K_charge1.Item(0)
        rtf.WriteString("Cas de charge non accumulée le plus sévère - s = " & s.ToString("#0.00") & " daN/m2.") : rtf.NewLine()
        d = s / γ : k = 3 / d
        If k > d * γ Then k = d * γ
        rtf.WriteString("Epaisseur de la neige en bordure - d = " & d.ToString("#0.00") & " m") : rtf.NewLine()
        rtf.WriteString("Coefficient de debord - k = " & k.ToString("#0.00")) : rtf.NewLine()
        Se = k * s ^ 2 / γ
        rtf.WriteString("Charge suspendue - Se = " & Se.ToString("#0.00") & " daN/m.") : rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub
    Private Sub Calcul_Charge_BarreaNeige(ByVal i As Integer, ByRef rtf As RtfAnsiTextWriter)
        Dim Fs, s As Double
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10
        With Roof.Item(i)

            rtf.WriteString("Versant " & (i + 1).ToString & " :") : rtf.NewLine()
            s = .K_charge1.Item(0)
            rtf.WriteString("Cas de charge non accumulée le plus sévère - s = " & s.ToString("#0.00") & " daN/m2.") : rtf.NewLine()
            rtf.WriteString("Distance la plus grande entre 2 barres à neige ou faitage - b = " & .b.ToString("#0.00") & " m (distance mesurée horizontalement)") : rtf.NewLine()
            Fs = s * .b * Sin(Abs(.Pvers) * PI / 180)
            rtf.WriteString("Force exercée dans le sens du glissement sur la barre à neige - Fs = " & Fs.ToString("#0.00") & " daN/m.") : rtf.NewLine()
        End With
        rtf.WriteEndGroup()
    End Sub
    Private Function µ1(ByVal i As Integer) As Double
        Select Case Roof.Item(i).Pvers
            Case Is <= 30
                µ1 = 0.8
            Case Is <= 60
                µ1 = 0.8 * (60 - Roof.Item(i).Pvers) / 30
            Case Else
                µ1 = 0
        End Select
        If Roof.Item(i).Acrotere = True Or Roof.Item(i).Barre_A_Neige = True Then µ1 = 0.8
    End Function
    Private Function µ2(ByVal i As Integer, ByVal Gauche As Boolean) As Double
        Dim pente As Double
        pente = If(Gauche = True, (Roof.Item(i).Pvers + Roof.Item(i + 1).Pvers) / 2, (Roof.Item(i - 1).Pvers + Roof.Item(i).Pvers) / 2)
        Select Case pente
            Case Is <= 30
                µ2 = 0.8 + 0.8 * pente / 30
            Case Is <= 60
                µ2 = 1.6
            Case Else
                µ2 = 2 'par référence à ce qui existait dans les NV65
        End Select

    End Function

#End Region
#Region "Vent"
    Public Sub Calcul_Vent(ByRef rtf As RtfAnsiTextWriter, ByRef Verif As Boolean)

        Dim num_façade As Integer
        Dim SaMax, Satotal, Satotal1, d, mu, Cpe, Cpmod, Cpi1, Cpi2, Tab_Vent(85) As Double

        With Wnd
            .Initialisation()
            '--------------------------------------------
            'calcul des Coefficients de pression interne
            '-------------------------------------------
            'Cpmod = coefficient correcteur suivant équation (7.1) ou (7.2)
            'Cpe = valeur résultante du calcul soit par application de §7.2.9(5) ou §7.2.9(6)
            'Par convention, et pour être cohérent avec le reste du programme, indice 1 pour surpression intérieure et indice 2 pour dépression intérieure
            'Cpidg(1)   vent droite->gauche + surpression -> pousse sur les parois extérieures (façades et toitures)
            'Cpidg(2)   vent droite->gauche + dépression -> aspire les parois extérieures (façades et toitures)
            Select Case .ValCpi
                Case 1 'valeur de cpi prise par défaut suivant note 2 du §7.2.9(6)
                    .CpiPlus = 0.2 '   Cpidg(1) = 0.2 : Cpigd(1) = 0.2 : Cpipig(1) = 0.2 'pression intérieure positive = surpression -> pousse sur les parois extérieures (façades et toitures)
                    .CpiMoins = -0.3 '   Cpidg(2) = -0.3 : Cpigd(2) = -0.3 : Cpipig(2) = -0.3 'pression intérieure négative = dépression -> aspire les parois extérieures (façades et toitures)
                Case 2 'valeurs de Cpi déterminés par le calcul
                    'vérification de l'existence d'une façade dominante
                    '  --> si oui, calcul de Cpi par §7.2.9(5)
                    '  --> si non, calcul de Cpi par §7.2.9(6)
                    SaMax = .SalpG : num_façade = 1
                    If SaMax < .SalpD Then SaMax = .SalpD : num_façade = 2
                    If SaMax < .SapigB Then SaMax = .SapigB : num_façade = 3
                    If SaMax < .SapigH Then SaMax = .SapigH : num_façade = 4
                    Satotal = .SalpG + .SalpD + .SapigB + .SapigH - SaMax
                    'Détermination de l'existence ou pas de face dominante 
                    If SaMax > 2 * Satotal Then
                        'une face dominante
                        'calcul de Cpi par §7.2.9(5)
                        If SaMax >= 3 * Satotal Then
                            Cpmod = 0.9
                        Else
                            Cpmod = 0.75 + 0.15 * ((SaMax - 2 * Satotal) / (Satotal))
                        End If
                        Select Case num_façade
                            Case 1, 2 'face dominante = vent sur longpan
                                '--> Vent sur long-pan gauche ou droit -> Cpe identique
                                d = .LargBat 'dimension du pignon
                            Case 3, 4 'face dominante = vent sur pignon
                                d = .LongBat  'rapport hauteur bat/longueur totale du bâtiment, ce dernier devenant le pignon
                        End Select
                        Select Case .Hbat / d 'rapport hauteur bat/pignon                               
                            Case Is <= 0.25
                                Cpe = 0.7
                            Case Is >= 1
                                Cpe = 0.8
                            Case Else ' 0,25<Hbat / d<1
                                Cpe = 0.7 + 0.1 * ((.Hbat - 0.25) / 0.75)
                        End Select
                        If Cpmod > 0 Then
                            'le vent crée une surpression intérieure dans le bâtiment
                            .CpiPlus = Cpmod * Cpe
                            .CpiMoins = 0
                        Else
                            'le vent crée une dépression intérieure dans le bâtiment
                            .CpiPlus = 0
                            .CpiMoins = Cpmod * Cpe
                        End If
                    Else
                        'pas de face dominante
                        'calcul de Cpi par §7.2.9(6)
                        'vent Gauche -> droite
                        Satotal1 = .SalpD + .SapigB + .SapigH
                        mu = Satotal1 / Satotal
                        d = .LargBat 'dimension du pignon = profondeur
                        Cpmod = Cpi_muhd(mu, .Hbat, d)
                        If Cpmod > 0 Then
                            'le vent crée une surpression intérieure dans le bâtiment
                            .CpiPlus = Cpmod
                            .CpiMoins = 0
                        Else
                            'le vent crée une dépression intérieure dans le bâtiment
                            .CpiPlus = 0
                            .CpiMoins = Cpmod
                        End If
                        'vent droite -> gauche
                        Satotal1 = .SalpG + .SapigB + .SapigH
                        mu = Satotal1 / Satotal
                        Cpmod = Cpi_muhd(mu, .Hbat, d)
                        If Cpmod > 0 Then
                            'le vent crée une surpression intérieure dans le bâtiment
                            .CpiPlus = Cpmod
                            .CpiMoins = 0
                        Else
                            'le vent crée une dépression intérieure dans le bâtiment
                            .CpiPlus = 0
                            .CpiMoins = Cpmod
                        End If
                        'vent sur pignon
                        'la combinaison se limite uniquement à une surpression intérieure, la dépression ne conduisant pas à une 
                        'combinaison plus défavorable
                        Satotal1 = .SalpG + .SalpD + .SapigH 'façade pignon bas
                        mu = Satotal1 / Satotal
                        Cpi1 = Cpi_muhd(mu, .Hbat, .LongBat)
                        Satotal1 = .SalpG + .SalpD + .SapigB 'façade pignon haut
                        mu = Satotal1 / Satotal
                        Cpi2 = Cpi_muhd(mu, .Hbat, .LongBat)
                        MsgBox("Voir calcul pignon")
                        Stop
                        If Cpi1 > 0 And Cpi2 < 0 Then
                            Cpmod = Cpi1
                        ElseIf Cpi1 < 0 And Cpi2 > 0 Then
                            Cpmod = Cpi2
                        ElseIf Cpi1 > 0 And Cpi2 > 0 Then
                            If Cpi1 > Cpi2 Then
                                '  Cpipig(1) = Cpi1
                            Else
                                '  Cpipig(1) = Cpi2
                            End If
                        End If
                        ' Cpipig(2) = 0
                    End If
                Case 3 'Cpi renseigné directement
                    'pression intérieure positive = surpression -> pousse sur les parois extérieures (façades et toitures)
                    'pression intérieure négative = dépression -> aspire les parois extérieures (façades et toitures)
            End Select
            Call Ecriture_Hypothese_Note_de_calcul_Vent(rtf)
            '------------------------------------------------------------------------------------------------
            'Calcul des forces de pression extérieure sur façades combinées aux forces de pression interne
            '------------------------------------------------------------------------------------------------
            Call Pression_façade(Tab_Vent, Verif, rtf)
            If Verif = False Then Exit Sub
            '--------------------------------------------------------------------------------------------------
            'calcul des forces de pression externes sur couverture combinées aux forces de pression interne
            '--------------------------------------------------------------------------------------------------
            Call Pression_Couverture(Tab_Vent, Verif, rtf)
            '--------------------------------------------------------------------------------------------------
            'Cumul des forces de pressions externes et internes
            '--------------------------------------------------------------------------------------------------
            rtf.WriteStartGroup()
            rtf.NewLine() : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("5 - Cumul des pressions externes et internes - Efforts du vent appliqués sur les parois") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine()
            rtf.NewLine()
            rtf.FontSize = 12 : rtf.FontSize = 10
            rtf.WriteString("Rappel de la signification des signes:") : rtf.NewLine()
            Try
                Dim myImage As Image ' Create Image Element
                myImage = My.Resources.vent_signe
                rtf.InsertImage(myImage)
            Catch ex As Exception
                Dim msg As String
                msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
            End Try
            rtf.WriteString("Ce cumul de pression prend en compte le défaut de corrélation pour les pressions sur façade ainsi que l'influence du coefficient structural CsCd.") : rtf.NewLine()
            rtf.WriteString("Les valeurs de pressions sont prises positives lorsqu'elles poussent vers l'extérieur de la structure et négatives lorsqu'elles pèsent " &
                            " sur la structure") : rtf.NewLine()
            rtf.WriteEndGroup()
            Select Case .GeomToiture '= géométrie du hall
                Case 1 ' "toiture terrasse - pente< 5° (= 8,75%)  
                    Call Affichage_tableau_1Versant(Tab_Vent, rtf)
                    If .Acrot_LongPan = True Or .Acrot_Pignon = True Then Call Acrotere(rtf)
                Case 2 '"toiture à 1 versant 
                    Call Affichage_tableau_1Versant(Tab_Vent, rtf)
                Case 3 'toiture à 2 versants 
                    Call Affichage_tableau_vent_2Versants(Tab_Vent, rtf)
                Case 4 'bâtiment constitué de 2 halls,toiture à 1 versant mais toiture sous forme de sheds multiples -> EN 1994-1-4 §7.2.7 

            End Select
            '--------------------------------------------------------------------------------------------------
            'Calcul des forces de frottement
            '--------------------------------------------------------------------------------------------------
            Call Force_Frottement(Verif, rtf)
            '--------------------------------------------------------------------------------------------------
            'Calcul de l'effet du détachement tourbillonnaire
            '--------------------------------------------------------------------------------------------------
            rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("7 - Calcul de l'effet du détachement tourbillonnaire") : rtf.NewLine() : rtf.NewLine()
            rtf.FontSize = 9 : rtf.WriteString("Valable uniquement pour la façade au vent") : rtf.Bold = False : rtf.Underline = False
            rtf.NewLine() : rtf.NewLine()
            Dim Edt1, Edt2 As Double
            If .Hbat > .LongBat Then Edt1 = .Hbat / .LongBat Else Edt1 = .LongBat / .Hbat
            If .Hbat > .LargBat Then Edt2 = .Hbat / .LargBat Else Edt2 = .LargBat / .Hbat
            rtf.WriteString("Rapport des dimensions transversales suivant dispositions Annexe E §E.1.2(1):") : rtf.NewLine()
            rtf.WriteString("Rapport h/b (ou b/h) = " & Edt1.ToString("#0.00"))
            If Edt1 < 6 Then
                rtf.WriteString(" < 6 - Aucun effet de détachement tourbillonnaire.") : rtf.NewLine()
            Else
                rtf.WriteString(" > 6 - Effet de détachement tourbillonnaire à examiner.") : rtf.NewLine()
            End If
            rtf.WriteString("Rapport h/d (ou d/h) = " & Edt2.ToString("#0.00"))
            If Edt2 < 6 Then
                rtf.WriteString(" < 6 - Aucun effet de détachement tourbillonnaire.") : rtf.NewLine()
            Else
                rtf.WriteString(" > 6 - Effet de détachement tourbillonnaire à examiner.") : rtf.NewLine()
            End If
        End With
    End Sub
    Private Sub Ecriture_Hypothese_Note_de_calcul_Vent(ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String
        rtf.WriteStartGroup()
        rtf.NewParagraph(RtfAnsiTextWriter.Align.Center) : rtf.Bold = True : rtf.FontSize = 18 : rtf.Underline = True
        rtf.WriteString("Action du vent suivant Eurocode 1")
        rtf.NewLine()
        rtf.Bold = False : rtf.FontSize = 10 : rtf.Underline = False : rtf.NewParagraph(RtfAnsiTextWriter.Align.Left)
        rtf.WriteString("Note de calcul du : ") : msg = Mise_en_Forme_date(CStr(DateTime.Now)) : rtf.WriteString(msg) : rtf.NewLine()
        rtf.WriteString("Rédacteur : " & Aff.Redacteur) : rtf.NewLine()
        rtf.WriteString("Chantier : " & Aff.Chantier) : rtf.NewLine()
        rtf.WriteString("Logiciel : calculette bâtiment  -  version 1.0  2015 - 2016") : rtf.NewLine()
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("1 - Rappel des hypothèses")
        rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("1 - 1  Codes de calcul") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine()
        rtf.WriteString("-  EN 1991-1-4:2005 et annexe nationale 2007") : rtf.NewLine()
        rtf.Bold = True : rtf.Underline = True : rtf.WriteString("1 - 2  Caractéristiques géométrique") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine()
        With Wnd
            rtf.WriteString("Bâtiment à plan rectangulaire avec ")
            Select Case .GeomToiture
                Case 1
                    rtf.WriteString("toiture terrasse - pente< 5° (= 8,75%).") : rtf.NewLine()
                Case 2
                    rtf.WriteString("toiture à 1 versant.") : rtf.NewLine()
                Case 3
                    rtf.WriteString("toiture à 2 versants.") : rtf.NewLine()
                Case 4
                    rtf.WriteString("toitures multiples (shed).") : rtf.NewLine()
            End Select
            rtf.WriteString("Bâtiment non sensible aux effets de torsion: procédures du §7.1.2 <Pressions et forces asymétriques ou en opposition> sans objet") : rtf.NewLine()
            rtf.WriteString("Elancement h/d = " & (.Hbat / .LargBat).ToString("#0.00") & "< 4 - Le bâtiment n'est pas sensible aux excitations par la turbulence de sillage (condition du " &
                            "§6.3.3).") : rtf.NewLine()
            rtf.WriteString("Rapports Max(h/b ou b/h) = " & Max(.Hbat / .LongBat, .LongBat / .Hbat).ToString("#0.00") & "< 6 et Max(h/d ou d/h) = " &
                            Max(.Hbat / .LargBat, .LargBat / .Hbat).ToString("#0.00") & "< 6 - Le bâtiment n'est pas sensible aux effets de détachement tourbillonnaire (condition du " &
                            "§E.1.2).") : rtf.NewLine()
            rtf.WriteString("Longueur b: " & .LongBat.ToString("#0.00") & "m - largeur d: " & .LargBat.ToString("#0.00") & " m - hauteur h: " & .Hbat.ToString("#0.00") & "m - ")
            Select Case .GeomToiture
                Case 1
                    If .Hp = 0 Then
                        rtf.WriteString("sans acrotère") : rtf.NewLine()
                    End If
                Case 2
                    rtf.WriteString("pente: " & (.Pente_1Vers * 180 / PI).ToString("#0.00") & "°.") : rtf.NewLine()
                Case 3
                    rtf.WriteString("pente gauche: " & (.Pvg * 180 / PI).ToString("#0.00") & "°, pente droite: " & (.Pvd * 180 / PI).ToString("#0.00") & "°, ")
                    If .DecalFaitage < 0.05 Then
                        rtf.WriteString("sans décalage de faitage.") : rtf.NewLine()
                    Else
                        rtf.WriteString("avec décalage de faitage = " & .DecalFaitage.ToString("#0.00") & " m.") : rtf.NewLine()
                    End If
                Case 4
                    rtf.WriteString("toitures multiples (shed)") : rtf.NewLine()
            End Select
        End With
        rtf.Bold = True : rtf.Underline = True : rtf.WriteString("1 - 3  Caractéristiques géographiques") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine()
        With Wnd
            rtf.WriteString("Région d'implantation: " & CStr(.RegVent)) : rtf.NewLine()
            rtf.WriteString("Coefficient de direction: " & .Cdir.ToString("#0.00")) : rtf.NewLine()
            rtf.WriteString("Coefficient de saisonnalité: " & .Cseason.ToString("#0.00")) : rtf.NewLine()
            Select Case .CatVent 'rugosité du terrain
                Case 1 '0:
                    rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie 0 ") : rtf.NewLine()
                Case 2 'II
                    rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie II") : rtf.NewLine()
                Case 3 ' IIIa
                    rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IIIa") : rtf.NewLine()
                Case 4 'IIIb
                    rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IIIb") : rtf.NewLine()
                Case 5 'IV
                    rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IV") : rtf.NewLine()
            End Select
            rtf.WriteString("Coefficient structural CsCd: " & .CsCd.ToString("#0.00")) : rtf.NewLine()
            rtf.WriteString("Durée d'utilisation de la structure suivant EN 1990: " & .Duree.ToString("#") & " ans.") : rtf.NewLine()
            rtf.WriteString("Influence de construction avoisinante de grande dimension: " & "Sans objet") : rtf.NewLine()
            rtf.NewLine()
            rtf.WriteString("Soit une valeur de base de la vitesse de référence du vent Vb0: " & .Vb0.ToString("#") & " m/s  (tableau 4.2 de l'Annexe Nationale)") : rtf.NewLine() ' Vb0
            rtf.WriteString(" x Coefficient de direction : " & .Cdir.ToString("#0.00"))
            rtf.WriteString("  x Coefficient de saisonnalité : " & .Cseason.ToString("#0.00"))
            rtf.WriteString("  x Coefficient de probabilité : " & .Cprob.ToString("#0.00")) : rtf.NewLine()
            rtf.WriteString("= Vitesse de référence du vent Vb: " & .Vb.ToString("#0.00") & " m/s") : rtf.NewLine()
            rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("2 - Détermination des coefficients de pression interne") : rtf.Bold = False : rtf.Underline = False : rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
            Select Case .ValCpi
                Case 1 'valeur de cpi prise par défaut suivant note 2 du §7.2.9(6)
                    rtf.WriteString("valeur de cpi prise par défaut suivant note 2 du §7.2.9(6)") : rtf.NewLine()
                    rtf.WriteString("Pression intérieure positive = surpression -> pousse sur les parois extérieures (façades et toitures)") : rtf.NewLine()
                    rtf.WriteString("Cpi = +" & .CpiPlus.ToString("0.00")) : rtf.NewLine()
                    rtf.WriteString("pression intérieure négative = dépression -> aspire les parois extérieures (façades et toitures) ") : rtf.NewLine()
                    rtf.WriteString("Cpi = " & .CpiMoins.ToString("0.00")) : rtf.NewLine() : rtf.NewLine()
                    rtf.WriteString("Les valeurs de Cpi sont indépendantes de la façade sur laquelle souffle le vent. Elles sont donc combinées avec les valeurs de Cpe sans se " &
                                    "préoccuper si le vent souffle de la droite vers la gauche, de la gauche vers la droite, sur un longpan, sur un pignon, etc. ...") : rtf.NewLine()
                Case 2 'valeurs de Cpi déterminés par le calcul
                    rtf.WriteString("valeurs de Cpi déterminés par le calcul ") : rtf.NewLine()
                    rtf.WriteString("vérification de l'existence d'une façade dominante ") : rtf.NewLine()
                    rtf.WriteString("--> si oui, calcul de Cpi par §7.2.9(5) ") : rtf.NewLine()
                    rtf.WriteString(" --> si non, calcul de Cpi par §7.2.9(6) ") : rtf.NewLine()
                    rtf.WriteString("Pression intérieure positive = surpression -> pousse sur les parois extérieures (façades et toitures)") : rtf.NewLine()
                    rtf.WriteString("Cpi = +" & .CpiPlus.ToString("0.00")) : rtf.NewLine()
                    rtf.WriteString("pression intérieure négative = dépression -> aspire les parois extérieures (façades et toitures) ") : rtf.NewLine()
                    rtf.WriteString("Cpi = " & .CpiMoins.ToString("0.00")) : rtf.NewLine()
                'A compléter            
                Case 3 'Cpi renseigné directement
                    rtf.WriteString("Cpi renseigné directement ") : rtf.NewLine()
                    rtf.WriteString("Pression intérieure positive = surpression -> pousse sur les parois extérieures (façades et toitures)") : rtf.NewLine()
                    rtf.WriteString("Cpi = +" & .CpiPlus.ToString("0.00")) : rtf.NewLine()
                    rtf.WriteString("pression intérieure négative = dépression -> aspire les parois extérieures (façades et toitures) ") : rtf.NewLine()
                    rtf.WriteString("Cpi = " & .CpiMoins.ToString("0.00")) : rtf.NewLine()
            End Select
            rtf.WriteEndGroup()
        End With
    End Sub
    Private Sub Affichage_tableau_1Versant(ByVal Tab_Vent() As Double, ByRef rtf As RtfAnsiTextWriter)
        Dim i As Integer
        rtf.WriteStartGroup()
        'tableau
        rtf.NewParagraph() '()
        rtf.FontSize = 12 : rtf.FontSize = 9  'taille en 12 puis en 8 pour que le tableau soit en 8 sinon cela ne marche pas, ne me demadez pas pourquoi, j'y comprends rien moi-même
        'Ligne 1  ligne_Entete_Vent sur long Pan
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        If Tab_Vent(53) = 3 Then
            'pour la zone J
            rtf.DeclareCell(8000)
        Else
            rtf.DeclareCell(7200)
        End If
        rtf.BeginCell(True) : rtf.WriteString("Vent sur Long Pan  (daN/m²)") : rtf.EndCell()
        rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone A") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone B") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone C") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone D") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone E") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone F") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone G") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone H") : rtf.EndCell()
        If Wnd.GeomToiture = 1 Then rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone I") : rtf.EndCell()
        rtf.EndRow()
        'ligne 3
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Surpression") : rtf.EndCell()
        For i = 1 To 5 'Zone A à E surp
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            Select Case i
                Case 1, 4, 5 'zone A, D et E
                    rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
                Case 2, 3 'Zones B et C
                    If Tab_Vent(i) = 1000 Then rtf.WriteString("SO") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End Select
            rtf.EndCell()
        Next
        For i = 6 To 8 'Zone F à H -   surp
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(i).ToString("##0.00")) : rtf.EndCell()
        Next
        If Wnd.GeomToiture = 1 Then rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(9).ToString("##0.00")) : rtf.EndCell()
        rtf.EndRow()
        'ligne 4
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Dépression") : rtf.EndCell()
        For i = 11 To 15 'zones A, B, C, D, E - Dépression
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            Select Case i
                Case 11, 14, 15 'zone A, D et E
                    rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
                Case 12, 13 'Zones B et C
                    If Tab_Vent(i) = 1000 Then rtf.WriteString("SO") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End Select
            rtf.EndCell()
        Next
        For i = 26 To 28 'zones F, G ,H 
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(i).ToString("##0.00")) : rtf.EndCell()
        Next
        If Wnd.GeomToiture = 1 Then rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(29).ToString("##0.00")) : rtf.EndCell()
        rtf.EndRow() : rtf.WriteEndGroup()
        rtf.WriteStartGroup()
        'tableau
        rtf.NewParagraph() '()
        rtf.FontSize = 12 : rtf.FontSize = 9  'taille en 12 puis en 8 pour que le tableau soit en 8 sinon cela ne marche pas, ne me demadez pas pourquoi, j'y comprends rien moi-même
        'Ligne 1  ligne_Entete_Vent sur pignon
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7200) : rtf.BeginCell(True) : rtf.WriteString("Vent sur pignon  (daN/m²)") : rtf.EndCell()
        rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone A") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone B") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone C") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone D") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone E") : rtf.EndCell()
        If Wnd.GeomToiture = 1 Then
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone F") : rtf.EndCell()
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone G") : rtf.EndCell()
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone H") : rtf.EndCell()
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone I") : rtf.EndCell()
        Else
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone Fup") : rtf.EndCell()
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone Flow") : rtf.EndCell()
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone G") : rtf.EndCell()
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone H") : rtf.EndCell()
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone I") : rtf.EndCell()
        End If

        rtf.EndRow()
        'ligne 3
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Surpression") : rtf.EndCell()
        For i = 21 To 25 'Zone A à E + Surpression
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            Select Case i
                Case 21, 24, 25 'zone A, D et E
                    rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
                Case 22, 23 'Zones B et C
                    If Tab_Vent(i) = 1000 Then rtf.WriteString("SO") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End Select
            rtf.EndCell()
        Next
        For i = 46 To 49 'Zone F à I + Surpression
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(i).ToString("##0.00")) : rtf.EndCell()
        Next
        If Wnd.GeomToiture = 2 Then rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(50).ToString("##0.00")) : rtf.EndCell()
        rtf.EndRow()
        'ligne 4
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Dépression") : rtf.EndCell()
        For i = 31 To 35 'Zone A à E + Dépression
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            Select Case i
                Case 31, 34, 35 'zone A, D et E
                    rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
                Case 32, 33 'Zones B et C
                    If Tab_Vent(i) = 1000 Then rtf.WriteString("SO") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End Select
            rtf.EndCell()
        Next
        For i = 56 To 59 ''Zone F à I + dépression
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(i).ToString("##0.00")) : rtf.EndCell()
        Next
        If Wnd.GeomToiture = 2 Then rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(60).ToString("##0.00")) : rtf.EndCell()
        rtf.EndRow()
        rtf.WriteEndGroup()
    End Sub
    Private Sub Affichage_tableau_vent_2Versants(ByVal Tab_Vent() As Double, ByRef rtf As RtfAnsiTextWriter)
        Dim i, j As Integer
        'tableau
        rtf.WriteStartGroup()
        rtf.FontSize = 12 : rtf.FontSize = 10  'taille en 12 puis en 8 pour que le tableau soit en 8 sinon cela ne marche pas, ne me demadez pas pourquoi, j'y comprends rien moi-même
        rtf.WriteString("Vent sur façade LongPan (Zone D): " & Wnd.Profil_LongPan.ToString() & " profil(s) de pression appliqué(s)") : rtf.NewLine()
        rtf.WriteEndGroup()
        rtf.WriteStartGroup()
        rtf.NewParagraph() '()
        rtf.FontSize = 12 : rtf.FontSize = 9
        'Ligne 1  ligne_Entete_Vent sur long Pan
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(8000) : rtf.BeginCell(True) : rtf.WriteString("Vent sur Long Pan - pression totale exercée sur la zone correspondante  (daN/m²)") : rtf.EndCell()
        rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Surpression") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone A") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone B") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone C") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone D") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone E") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone F") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone G") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone H") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone I") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone J") : rtf.EndCell()
        rtf.EndRow()
        'ligne 3
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Val Max") : rtf.EndCell()
        For i = 1 To 5 'Zone A à E surp
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            Select Case i
                Case 1, 4, 5 'zone A, D et E
                    rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
                Case 2, 3 'Zones B et C
                    If Tab_Vent(i) = 1000 Then rtf.WriteString("S.O.") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End Select
            rtf.EndCell()
        Next
        For i = 6 To 10 'Zone F à J - val Max surp
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(i).ToString("##0.00")) : rtf.EndCell()
        Next
        rtf.EndRow()
        'ligne 4
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Val min") : rtf.EndCell()
        For i = 1 To 5 'A, B, C, D, E - Sans objet - Pas de 2ième valeur
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            If i = 4 And Wnd.Profil_LongPan >= 2 Then rtf.WriteString(Tab_Vent(61).ToString("##0.00")) Else rtf.WriteString("S.O.")
            rtf.EndCell()
        Next
        For i = 16 To 20
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            If Tab_Vent(i) = 1000 Then
                rtf.WriteString("S.O.")
            Else
                rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End If
            rtf.EndCell()
        Next
        rtf.EndRow()
        'ligne 4 intermédiaire
        For i = 2 To Wnd.Profil_LongPan
            If i = 6 Then Exit For
            rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
            For j = 1 To 10 'A, B, C, D, E - Sans objet - Pas de 2ième valeur
                rtf.DeclareCell(800) : rtf.BeginCell(True)
                If j = 4 Then rtf.WriteString(Tab_Vent(60 + i).ToString("##0.00")) Else rtf.WriteString("S.O.")
                rtf.EndCell()
            Next
            rtf.EndRow()
        Next
        'ligne 5
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Dépression") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone A") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone B") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone C") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone D") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone E") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone F") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone G") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone H") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone I") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone J") : rtf.EndCell()
        rtf.EndRow()
        'ligne 6
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Val Max") : rtf.EndCell()
        For i = 11 To 15 'zones A, B, C, D, E - Dépression
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            Select Case i
                Case 11, 14, 15 'zone A, D et E
                    rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
                Case 12, 13 'Zones B et C
                    If Tab_Vent(i) = 1000 Then rtf.WriteString("S.O.") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End Select
            rtf.EndCell()
        Next
        For i = 26 To 30 'zones F, G ,H, I
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(i).ToString("##0.00")) : rtf.EndCell()
        Next
        rtf.EndRow()
        'ligne 7
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Val min") : rtf.EndCell()
        For i = 1 To 5 'A, B, C, D, E
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            If i = 4 And Wnd.Profil_LongPan >= 2 Then rtf.WriteString(Tab_Vent(66).ToString("##0.00")) Else rtf.WriteString("S.O.")
            rtf.EndCell()
        Next
        For i = 36 To 40
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            If Tab_Vent(i) = 1000 Then rtf.WriteString("S.O.") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            rtf.EndCell()
        Next
        rtf.EndRow()
        'ligne 7 intermédiaire
        For i = 2 To Wnd.Profil_LongPan
            If i = 6 Then Exit For
            rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
            For j = 1 To 10 'A, B, C, D, E - Sans objet - Pas de 2ième valeur
                rtf.DeclareCell(800) : rtf.BeginCell(True)
                If j = 4 Then rtf.WriteString(Tab_Vent(65 + i).ToString("##0.00")) Else rtf.WriteString("S.O.")
                rtf.EndCell()
            Next
            rtf.EndRow()
        Next
        rtf.WriteEndGroup()
        rtf.WriteStartGroup()
        rtf.FontSize = 10 : rtf.NewLine()
        rtf.WriteString("Pour les zones ne possédant pas de valeurs de CPe double, la valeur unique figurent sur la ligne des valeurs maximales et il est indiqué S.O.(Sans Objet) pour la " &
                        "ligne valeurs minimales.") : rtf.NewLine()
        rtf.NewLine()
        rtf.WriteString("Vent sur façade pignon (Zone D): " & Wnd.Profil_Pignon.ToString() & " profil(s) de pression appliqué(s)") : rtf.NewLine()
        rtf.WriteEndGroup()
        rtf.WriteStartGroup()
        'tableau
        rtf.NewParagraph() '()
        rtf.FontSize = 12 : rtf.FontSize = 9  'taille en 12 puis en 8 pour que le tableau soit en 8 sinon cela ne marche pas, ne me demadez pas pourquoi, j'y comprends rien moi-même
        'Ligne 1  ligne_Entete_Vent sur pignon
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7200) : rtf.BeginCell(True) : rtf.WriteString("Vent sur pignon - pression totale exercée sur la zone correspondante  (daN/m²)") : rtf.EndCell()
        rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone A") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone B") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone C") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone D") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone E") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone F") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone G") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone H") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Zone I") : rtf.EndCell()
        rtf.EndRow()
        'ligne 3
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Surpression") : rtf.EndCell()
        For i = 21 To 25 'Zone A à E + Surpression
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            Select Case i
                Case 21, 24, 25 'zone A, D et E
                    rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
                Case 22, 23 'Zones B et C
                    If Tab_Vent(i) = 1000 Then rtf.WriteString("S.O.") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End Select
            rtf.EndCell()
        Next
        For i = 46 To 49 'Zone F à I + Surpression
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(i).ToString("##0.00")) : rtf.EndCell()
        Next
        rtf.EndRow()
        'ligne 3 intermédiaire
        For i = 2 To Wnd.Profil_Pignon
            If i = 6 Then Exit For
            rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
            For j = 1 To 9 'A, B, C, D, E - Sans objet - Pas de 2ième valeur
                rtf.DeclareCell(800) : rtf.BeginCell(True)
                If j = 4 Then rtf.WriteString(Tab_Vent(73 + i).ToString("##0.00")) Else rtf.WriteString(" ")
                rtf.EndCell()
            Next
            rtf.EndRow()
        Next
        'ligne 4
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Dépression") : rtf.EndCell()
        For i = 31 To 35 'Zone A à E + Dépression
            rtf.DeclareCell(800) : rtf.BeginCell(True)
            Select Case i
                Case 31, 34, 35 'zone A, D et E
                    rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
                Case 32, 33 'Zones B et C
                    If Tab_Vent(i) = 1000 Then rtf.WriteString("S.O.") Else rtf.WriteString(Tab_Vent(i).ToString("##0.00"))
            End Select
            rtf.EndCell()
        Next
        For i = 56 To 59 ''Zone F à I + dépression
            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(Tab_Vent(i).ToString("##0.00")) : rtf.EndCell()
        Next
        rtf.EndRow()
        'ligne 4 intermédiaire
        For i = 2 To Wnd.Profil_Pignon
            If i = 6 Then Exit For
            rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
            For j = 1 To 9 'A, B, C, D, E - Sans objet - Pas de 2ième valeur
                rtf.DeclareCell(800) : rtf.BeginCell(True)
                If j = 4 Then rtf.WriteString(Tab_Vent(79 + i).ToString("##0.00")) Else rtf.WriteString(" ")
                rtf.EndCell()
            Next
            rtf.EndRow()
        Next
        rtf.WriteEndGroup()
    End Sub
    Private Sub Pression_façade(ByRef Tab_Vent() As Double, ByRef Verif As Boolean, ByRef rtf As RtfAnsiTextWriter)
        '--> vent sur long-pan (=// aux halls)
        'Variables: d= longueur du pignon (=longueur de la façade // au vent)
        '           h = hauteur du bâtiment 
        '           FA = effort global du vent sur la zone A suivant figure 7.5 de EC1
        '           Cpidg(1)   vent droite->gauche + surpression -> pousse sur les parois extérieures (façades et toitures)
        '           Cpidg(2)   vent droite->gauche + dépression -> aspire les parois extérieures (façades et toitures)

        Dim Correlation, Cpe10A, Cpe10B, Cpe10C, Cpe10D, Cpe10E, d, E, h_façade, h_limA, h_limB, LA, LB, LC, Qvent, Riv_G, Riv_D, SA, SB, Zref, Zeb As Double ' Ze3, Ze1, Ze2,
        Dim msg As String
        Dim i, i1, j As Integer 'Profil,
        Dim Façade_droite As Boolean = False
        rtf.WriteStartGroup()
        With Wnd
            .Ze.Clear() : .Ze_Mur.Clear() 'effacement de toutes les variables
            rtf.NewLine() : rtf.Bold = True : rtf.Underline = True : rtf.FontSize = 12
            rtf.WriteString("3 - Détermination de l'effort externe du vent sur les façades") : rtf.NewLine() : rtf.NewLine()
            rtf.FontSize = 10
            rtf.WriteString("3 - 1 Vent sur Longpan - Sens du vent: Gauche vers la Droite") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine()
            rtf.NewLine() : rtf.Italic = True : rtf.Underline = True
            rtf.WriteString("3 - 1 - 1 - Calcul de la pression dynamique de pointe Qp appliquée à la façade") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            '--> Vent sur long-pan gauche ou droit, les Cpe restent identiques
            d = .LargBat 'dimension du pignon
            Select Case .GeomToiture
                Case 1 'toiture terrasse
                    h_façade = .Hbat
                Case 2 'toiture 1 versant
                    'rive basse
                    h_façade = .Hbat - d * Tan(Abs(.Pente_1Vers))
                    rtf.WriteString("Calcul établi pour la façade rive basse - Hauteur façade: " & h_façade.ToString("#0.00") & " m.") : rtf.NewLine()
                Case 3 'toiture 2 versants
                    If .DecalFaitage < 0.05 And .Pvg = .Pvd Then
                        h_façade = .Hbat - ((d * Tan(Abs(.Pvg))) / 2) 'bâtiment symétrique
                    Else
                        'calcul de la rive gauche
                        Riv_G = .Hbat - (((d / 2) - .DecalFaitage) * Tan(Abs(.Pvg))) 'bâtiment Non symétrique
                        Riv_D = .Hbat - (((d / 2) - .DecalFaitage) * Tan(Abs(.Pvd))) 'bâtiment Non symétrique
                        h_façade = Riv_G
                    End If
                    rtf.WriteString("Calcul établi pour la façade long pan gauche - Hauteur façade: " & h_façade.ToString("#0.00") & " m.") : rtf.NewLine()
            End Select
            'Détermination des hauteurs de références
            If .Zeref > 0.1 Then
                .Ze.Add(.Zeref)
            Else
                .Ze.Add(.Hbat)
            End If
            Select Case .Hbat
                Case Is < .LongBat 'hauteur du batiment<longueur de la façade
                    .Ze_Mur.Add(h_façade) ': .Ze.Add(.Hbat) ': Profil = 1 ': Ze2 = 0 ': Ze3 = 0
                Case Is < 2 * .LongBat 'longueur de la façade<hauteur du batiment<2xlongueur de la façade
                    .Ze_Mur.Add(.LongBat) : .Ze_Mur.Add(h_façade) ': .Ze.Add(.Hbat) ': Profil = 10 ': Ze3 = 0
                    msg = "La hauteur du bâtiment (= " & .Hbat.ToString("#0.000") & " m) est supérieure à la longueur de la façade (= " & .LongBat.ToString("#0.000") & " m). Cela " & vbCrLf &
                          "produit un profil avec deux pressions dynamiques sur la façade. Or le logiciel  n'est pas validé pour ce cas de figure." & vbCrLf &
                        "Voulez-vous continuer le calcul? (Oui/Non)"
                    If MsgBox(msg, MsgBoxStyle.Question Or MsgBoxStyle.YesNo, "Routine Eurocode. Sub Vent") = MsgBoxResult.No Then
                        Verif = False : rtf.WriteEndGroup() : Exit Sub
                    End If
                Case Else 'bâtiment de type tour - gratte-ciel
                    '  .Ze.Add(.Hbat)
                    .Ze_Mur.Add(.LongBat)
                    Zeb = .Ze_Mur(0)
                    Do
                        Zref = .Hbat - Zeb - .LongBat ': Profil = 20  ' : Ze3 = .Hbat
                        If Zref > .LongBat Then
                            Zeb = Zeb + .LongBat
                            .Ze_Mur.Add(Zeb)
                        ElseIf Zref > 0 Then
                            .Ze_Mur.Add(Zeb + Zref)
                            .Ze_Mur.Add(h_façade)
                            Exit Do
                        End If
                        i = i + 1
                        If i = 100 Then Exit Do 'pour éviter une boucle infinie
                    Loop
                    msg = "La hauteur du bâtiment (= " & .Hbat.ToString("#0.000") & " m) est supérieure à 2 fois la longueur de la façade (= " & .LongBat.ToString("#0.000") & " m)." & vbCrLf &
                           "Cela produit un profil avec plusieurs pressions dynamiques sur la façade. Or le logiciel  n'est pas validé pour ce cas de figure." & vbCrLf &
                                      "Voulez-vous continuer le calcul? (Oui/Non)"
                    If MsgBox(msg, MsgBoxStyle.Question Or MsgBoxStyle.YesNo, "Routine Eurocode. Sub Vent") = MsgBoxResult.No Then
                        Verif = False : rtf.WriteEndGroup() : Exit Sub
                    End If
            End Select

            'Calcul de la pression dynamique de pointe pour la hauteur de référence: Qp
            'A calculer au moins une fois pour déterminer les éléments généraux
            Qvent = Qp(.Ze(0)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
            rtf.Underline = True
            rtf.WriteString("Eléments généraux:") : rtf.Underline = False : rtf.NewLine()
            Select Case .CatVent 'rugosité du terrain
                Case 1 '0:
                    rtf.WriteString("Rugosité du terrain : catégorie 0 ") : rtf.NewLine()
                    rtf.WriteString("Longueur de rugosité Z0 = 0,005m - Hauteur minimale Zmin = 1m") : rtf.NewLine()
                Case 2 'II
                    rtf.WriteString("Rugosité du terrain : catégorie II") : rtf.NewLine()
                    rtf.WriteString("Longueur de rugosité Z0 = 0,05m - Hauteur minimale Zmin = 2m") : rtf.NewLine()
                Case 3 ' IIIa
                    rtf.WriteString("Rugosité du terrain : catégorie IIIa") : rtf.NewLine()
                    rtf.WriteString("Longueur de rugosité Z0 = 0,2m - Hauteur minimale Zmin = 5m") : rtf.NewLine()
                Case 4 'IIIb
                    rtf.WriteString("Rugosité du terrain : catégorie IIIb") : rtf.NewLine()
                    rtf.WriteString("Longueur de rugosité Z0 = 0,5m - Hauteur minimale Zmin = 9m") : rtf.NewLine()
                Case 5 'IV
                    rtf.WriteString("Rugosité du terrain : catégorie IV") : rtf.NewLine()
                    rtf.WriteString("Longueur de rugosité Z0 = 1m - Hauteur minimale Zmin = 15m") : rtf.NewLine()
            End Select
            rtf.WriteString("Facteur de terrain Kr : " & .Kr.ToString("###0.000")) : rtf.NewLine()
            Select Case .OroCas
                Case 0 ' terrain plat pour l'Orographie
                    rtf.WriteString("Orographie: terrain plat - ")
                    .Coro = 1
                Case 1 'cas I pour l'Orographie
                    rtf.WriteString("Orographie: cas I - ")
                Case 2 ' cas II pour l'Orographie 
                    rtf.WriteString("Orographie: cas II - ")
            End Select
            rtf.WriteString("coefficient d'Orographie C0 : " & .Coro.ToString("##0.000")) : rtf.NewLine()
            rtf.WriteString("Coefficient de turbulence Ki : " & .Ki.ToString("##0.000")) : rtf.NewLine()

            rtf.Underline = True
            rtf.WriteString("Eléments liés à la façade:") : rtf.Underline = False : rtf.NewLine()
            If .Zeref > 0.1 Then
                rtf.WriteString("Hauteur de référence Ze fonction de construction voisine de grande dimension et de hauteur bien plus élevée (§4.3.4 de l'EN1991-1-4). ") : rtf.NewLine()
                rtf.WriteString(" - 1 seule hauteur de référence: " & .Zeref.ToString("#0.000") & " m.") : rtf.NewLine()
                rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
            Else
                rtf.WriteString("Hauteur de référence Ze fonction des dimensions de la façade. ") : rtf.NewLine()
                Select Case .Ze_Mur.Count
                    Case 1
                        rtf.WriteString("h<=b - 1 seule hauteur de référence: " & .Ze_Mur(0).ToString("#0.000") & " m (= Hauteur de la façade - cas 1 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                        Qvent = Qp(.Ze_Mur(0)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                        rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
                    Case 2
                        rtf.WriteString("b<h<=2.b - 2 hauteurs de référence: " & .Ze_Mur(0).ToString("#0.000") & " m, et " & .Ze_Mur(1).ToString("#0.000") & " m (= cas 2 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la première hauteur de référence Ze = longueur façade: " & .Ze_Mur(0).ToString("##0.000") & " m.") : rtf.NewLine()
                        Qvent = Qp(.Ze_Mur(0)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                        rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.00") & " daN/m²") : rtf.NewLine()
                        rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la deuxième hauteur de référence Ze = hauteur bâtiment: " & .Ze_Mur(1).ToString("##0.000") & " m.") : rtf.NewLine()
                        Qvent = Qp(.Ze_Mur(1)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                        rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.00") & " daN/m²") : rtf.NewLine()
                    Case Is > 2
                        rtf.WriteString("h>2.b - Plusieurs hauteurs de référence (= cas 3 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                        For i = 0 To .Ze.Count - 1
                            rtf.WriteString("Pression dynamique de pointe pour la hauteur n°" & (i + 1).ToString() & " de référence Ze: " & .Ze_Mur(i).ToString("##0.000") & " m.") : rtf.NewLine()
                            Qvent = Qp(.Ze_Mur(i)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                            rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                            rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
                            rtf.NewLine()
                        Next

                End Select
            End If
            rtf.NewLine()


            Select Case .Hbat / d 'rapport hauteur bat/pignon
                Case Is > 5
                    Cpe10D = 0.8 : Cpe10E = -0.7
                Case Is <= 0.25
                    Cpe10D = 0.7 : Cpe10E = -0.3
                Case Is >= 1 '1=<..Hbat / d=<5
                    Cpe10D = 0.8
                    Cpe10E = -0.5 - 0.2 * ((.Hbat / d - 1) / 4)
                Case Else ' 0,25<.Hbat / d<1
                    Cpe10D = 0.7 + 0.1 * ((.Hbat / d - 0.25) / 0.75)
                    Cpe10E = -0.3 - 0.2 * ((.Hbat / d - 0.25) / 0.75)
            End Select
            E = .LongBat  'Vent sur le longpan
            If E > 2 * .Hbat Then E = 2 * .Hbat
            Select Case E
                Case Is < d
                    LA = E / 5 : LB = E * 4 / 5 : LC = d - E
                Case Is >= 5 * d
                    LA = E : LB = 0 : LC = 0
                Case Else 'd<e<5 * d
                    LA = E / 5 : LB = d - E / 5 : LC = 0
            End Select
            Select Case .GeomToiture
                Case 1 'toiture terrasse
                    h_façade = .Hbat
                    SA = LA * h_façade : SB = LB * h_façade
                Case 2 '1 versant
                    h_façade = .Hbat - d * Tan(.Pente_1Vers)
                    h_limA = h_façade + LA * Tan(.Pente_1Vers) : h_limB = h_façade + (LA + LB) * Tan(.Pente_1Vers)
                    SA = LA * h_façade + (LA * (h_limA - h_façade) / 2) : SB = LB * h_limA + (LB * (h_limB - h_limA) / 2)
                Case 3 '2 versants
                    h_façade = .Hbat - ((d / 2 + .DecalFaitage) * Tan(.Pvg))
                    If LA < (d / 2 + .DecalFaitage) And LA + LB < (d / 2 + .DecalFaitage) Then
                        h_limA = h_façade + LA * Tan(.Pvg) : h_limB = h_façade + (LA + LB) * Tan(.Pvg)
                        SA = LA * h_façade + (LA * (h_limA - h_façade) / 2) : SB = LB * h_limA + (LB * (h_limB - h_limA) / 2)
                    ElseIf LA < (d / 2 + .DecalFaitage) And LA + LB > (d / 2 + .DecalFaitage) Then
                        h_limA = h_façade + LA * Tan(.Pvg) : SA = LA * h_façade + (LA * (h_limA - h_façade) / 2)
                        h_limB = .Hbat - ((d / 2 + .DecalFaitage) - (LA + LB) * Tan(.Pvd))
                        SB = ((d / 2 + .DecalFaitage) - LA) * h_limA + ((d / 2 + .DecalFaitage) - LA) * (.Hbat - h_limA) / 2 + ((LA + LB - (d / 2 + .DecalFaitage)) * h_limB + ((LA + LB - (d / 2 + .DecalFaitage)) * (.Hbat - h_limB) / 2))
                    Else
                        SA = 100 : SB = 100 'a faire
                    End If
            End Select
            'valeurs de CpeA et CpeB
            If SA <= 10 Then Cpe10A = -1.4 + 0.2 * Log10(SA) Else Cpe10A = -1.2
            If SB <= 10 Then Cpe10B = -1.1 + 0.3 * Log10(SB) Else Cpe10B = -0.8
            Cpe10C = -0.5
            'prise en compte du défaut de corrélation
            Select Case .Hbat / d 'rapport hauteur bat/longueur totale du pignon
                Case Is >= 5
                    Correlation = 1
                Case Is <= 1
                    Correlation = 0.85
                Case Else
                    Correlation = 0.85 + 0.15 * (((.Hbat / d) - 1) / 4)
            End Select
            If frmVent.ChkbCorrelation.Checked = True Then Correlation = 1 'non prise en compte du coefficient de correlation
            rtf.Italic = True : rtf.Underline = True
            rtf.WriteString("3 - 1 - 2  Calcul des pressions du vent sur les murs par zones") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            rtf.WriteString("La pression externe présentée ci-dessous pour chaque zone, ne prend pas en compte la pression interne, le défaut de corrélation et le coefficient " &
                            "structural CsCd. Il s'agit d'une pression brute.") : rtf.NewLine()
            Try
                Dim myImage As Image ' Create Image Element
                myImage = My.Resources.vent_façade_plan
                rtf.InsertImage(myImage)
            Catch ex As Exception
                msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
            End Try
            rtf.WriteString("Dimension: e = " & E.ToString("#0.000") & " m.") : rtf.NewLine()
            rtf.WriteString("Défaut de corrélation applicables sur les zones ci-dessous: " & Correlation.ToString("#0.000")) : rtf.NewLine()
            Qvent = Qp(.Ze_Mur(0)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
            If .Ze_Mur.Count = 1 Then
                rtf.WriteString("Zone D - Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            Else
                rtf.WriteString("Pression pour la 1ière hauteur de profil: Zone D - Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            End If
            If .Ze_Mur.Count = 2 Then
                Qvent = Qp(.Ze_Mur(1)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                rtf.WriteString("Pression pour la 2ième hauteur de profil: Zone D - Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            ElseIf .Ze_Mur.Count > 2 Then
                j = 1
                For i = 1 To .Ze.Count - 1
                    j = j + 1
                    Qvent = Qp(.Ze_Mur(i)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                    rtf.WriteString("Pression pour la hauteur de profil n°" & j.ToString() & ": Zone D - Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                Next
            End If
            Qvent = Qp(.Ze(0)) / 10 'hauteur du bâtiment ou Zeref pour totes les autres zones
            rtf.WriteString("Zone E: Cpe = " & Cpe10E.ToString("#0.000") & " - Pression: " & (Cpe10E * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Façades parallèle au vent sur lesquelles le défaut de corrélation ne s'applique pas: ") : rtf.NewLine()
            rtf.WriteString("Zone A: Cpe = " & Cpe10A.ToString("#0.000") & " - longueur de la Zone A: " & LA.ToString("#0.000") & " m - Aire: " & SA.ToString("0.00") & " m² - Pression: " & (Cpe10A * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            If LB = 0 Then
                rtf.WriteString("Pas de Zone B.") : rtf.NewLine()
                rtf.WriteString("Pas de Zone C.") : rtf.NewLine()
                Try
                    Dim myImage As Image ' Create Image Element
                    myImage = My.Resources.vent_façade_elevationA
                    rtf.InsertImage(myImage)
                Catch ex As Exception
                    msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                    MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
                End Try
            Else
                rtf.WriteString("Zone B: Cpe = " & Cpe10B.ToString("#0.000") & " - longueur de la Zone B: " & LB.ToString("#0.000") & " m - Aire: " & SB.ToString("0.00") & " m² - Pression: " & (Cpe10B * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                If LC = 0 Then
                    rtf.WriteString("Pas de zone C") : rtf.NewLine()
                    Try
                        Dim myImage As Image ' Create Image Element
                        myImage = My.Resources.vent_façade_elevationAB
                        rtf.InsertImage(myImage)
                    Catch ex As Exception
                        msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                        MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
                    End Try
                Else
                    rtf.WriteString("Zone C: Cpe = " & Cpe10C.ToString("#0.000") & " - longueur de la Zone C: " & LC.ToString("#0.000") & " m - Pression: " & (Cpe10C * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                    Try
                        Dim myImage As Image ' Create Image Element
                        myImage = My.Resources.vent_façade_elevationABC
                        rtf.InsertImage(myImage)
                    Catch ex As Exception
                        msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                        MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
                    End Try
                End If
            End If
            'détermination des valeurs de pressions par zones pour affichage dans la note de calcul
            '           Cpidg(1)   vent droite->gauche + surpression -> pousse sur les parois extérieures (façades et toitures)
            '           Cpidg(2)   vent droite->gauche + dépression -> aspire les parois extérieures (façades et toitures)
            Select Case .ValCpi
                Case 1, 3 'valeur de Cpi indépendantes de Cpe
                    ' surpression
                    'Cas vent G/D Surpression - cas 1 du vent
                    Tab_Vent(1) = (.CsCd * Cpe10A - .CpiPlus) * Qvent 'Tab_Vent(64)
                    If LB = 0 Then Tab_Vent(2) = 1000 Else Tab_Vent(2) = (.CsCd * Cpe10B - .CpiPlus) * Qvent '65
                    If LC = 0 Then Tab_Vent(3) = 1000 Else Tab_Vent(3) = (.CsCd * Cpe10C - .CpiPlus) * Qvent '66
                    Tab_Vent(5) = (.CsCd * Correlation * Cpe10E - .CpiPlus) * Qvent '68
                    ' dépression
                    'Cas vent G/D Dépression - cas 2 du vent
                    Tab_Vent(11) = (.CsCd * Cpe10A - .CpiMoins) * Qvent '73
                    If LB = 0 Then Tab_Vent(12) = 1000 Else Tab_Vent(12) = (.CsCd * Cpe10B - .CpiMoins) * Qvent '74
                    If LC = 0 Then Tab_Vent(13) = 1000 Else Tab_Vent(13) = (.CsCd * Cpe10C - .CpiMoins) * Qvent '75
                    Tab_Vent(15) = (.CsCd * Correlation * Cpe10E - .CpiMoins) * Qvent '77
                    For i = 1 To .Ze_Mur.Count
                        Qvent = Qp(.Ze_Mur(i - 1)) / 10
                        Select Case i
                            Case 1
                                Tab_Vent(4) = (.CsCd * Correlation * Cpe10D - .CpiPlus) * Qvent
                                Tab_Vent(14) = (.CsCd * Correlation * Cpe10D - .CpiMoins) * Qvent '95
                            Case Else
                                Tab_Vent(59 + i) = (.CsCd * Correlation * Cpe10D - .CpiPlus) * Qvent
                                Tab_Vent(64 + i) = (.CsCd * Correlation * Cpe10D - .CpiMoins) * Qvent '95
                                If i = 6 Then Exit For 'limitation à 6 valeurs
                        End Select
                    Next
                Case 2

            End Select
            '-------------------------------------------------------------------------------------------------------------------------------------------------------------------
            '--> vent sur  Longpan - Sens du vent: Droite vers la gauche
            rtf.NewLine() : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("3 - 2 Vent sur Longpan - Sens du vent: Droite vers la Gauche") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine()
            .Profil_LongPan = .Ze_Mur.Count
            Select Case .GeomToiture
                Case 1 'toiture terrasse
                    rtf.WriteString("Toiture terrasse = même hauteur de façade quelque soit le long pan - Mêmes pressions que celles calculées au chapitre précédent - Voir ci-avant. ") : rtf.NewLine()
                Case 2 'toiture 1 versant
                    'rive haute
                    h_façade = .Hbat
                    rtf.WriteString("Calcul établi pour la façade rive haute - Hauteur façade: " & h_façade.ToString("#0.00") & " m.") : rtf.NewLine()
                    Façade_droite = True
                Case 3 'toiture 2 versants
                    If .DecalFaitage < 0.05 And .Pvg = .Pvd Then
                        rtf.WriteString("Bâtiment symétrique - Mêmes pressions que celles calculées au chapitre précédent - Voir ci-avant. ") : rtf.NewLine() 'bâtiment symétrique
                    Else
                        'calcul de la rive droite
                        h_façade = Riv_D
                        rtf.WriteString("Calcul établi pour la façade long pan droit - Hauteur façade: " & h_façade.ToString("#0.00") & " m.") : rtf.NewLine()
                        Façade_droite = True
                    End If
            End Select
            If Façade_droite = True Then
                rtf.WriteString("Il n'est calculé que les effets du vent sur la façade sous le vent (Zone D). Pour les autres zones, les caractéristiques dimensionnelles et de " &
                                "pression sont identiques à celles figurant au chapitre précédent.") : rtf.NewLine()
                rtf.NewLine() : rtf.Italic = True : rtf.Underline = True
                rtf.WriteString("3 - 2 - 1 - Calcul de la pression dynamique de pointe Qp appliquée à la façade sous le vent (Zone D)") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
                Select Case .Ze_Mur.Count
                    Case 1 '1 seule hauteur
                        .Ze_Mur.Add(h_façade)
                    Case 2 '2 hauteur
                        .Ze_Mur.Add(.LongBat) : .Ze_Mur.Add(h_façade)
                    Case Else 'plusieurs hauteurs'bâtiment de type tour - gratte-ciel
                        .Ze_Mur.Add(.LongBat)
                        Zeb = .Ze_Mur(0)
                        Do
                            Zref = .Hbat - Zeb - .LongBat ': Profil = 20  ' : Ze3 = .Hbat
                            If Zref > .LongBat Then
                                Zeb = Zeb + .LongBat
                                .Ze_Mur.Add(Zeb)
                            ElseIf Zref > 0 Then
                                .Ze_Mur.Add(Zeb + Zref)
                                .Ze_Mur.Add(h_façade)
                                Exit Do
                            End If
                            i = i + 1
                            If i = 100 Then Exit Do 'pour éviter une boucle infinie
                        Loop
                End Select
                rtf.WriteString("Eléments liés à la façade:") : rtf.Underline = False : rtf.NewLine()
                If .Zeref > 0.1 Then
                    rtf.WriteString("Hauteur de référence Ze fonction de construction voisine de grande dimension et de hauteur bien plus élevée (§4.3.4 de l'EN1991-1-4). ") : rtf.NewLine()
                    rtf.WriteString("Pression dynamique de pointe identique au chapitre précédent car dépendant uniquement de Zeref. Calcul de pression identique.") : rtf.NewLine()
                Else
                    rtf.WriteString("Hauteur de référence Ze fonction des dimensions de la façade. ") : rtf.NewLine()
                    Select Case .Ze_Mur.Count - .Profil_LongPan
                        Case 1
                            Qvent = Qp(.Ze_Mur(.Profil_LongPan)) / 10
                            rtf.WriteString("h<=b - 1 seule hauteur de référence: " & .Ze_Mur(.Profil_LongPan).ToString("#0.000") & " m (= Hauteur de la façade - cas 1 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                            Qvent = Qp(.Ze_Mur(.Profil_LongPan)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                            rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                            rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
                        Case 2
                            rtf.WriteString("b<h<=2.b - 2 hauteurs de référence: " & .Ze_Mur(.Profil_LongPan).ToString("#0.000") & " m, et " & .Ze_Mur(.Profil_LongPan + 1).ToString("#0.000") & " m (= cas 2 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                            rtf.WriteString("Pression dynamique de pointe pour la première hauteur de référence Ze = longueur façade: " & .Ze_Mur(0).ToString("##0.000") & " m.") : rtf.NewLine()
                            Qvent = Qp(.Ze_Mur(.Profil_LongPan)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                            rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                            rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.00") & " daN/m²") : rtf.NewLine()
                            rtf.NewLine()
                            rtf.WriteString("Pression dynamique de pointe pour la deuxième hauteur de référence Ze = hauteur bâtiment: " & .Ze_Mur(1).ToString("##0.000") & " m.") : rtf.NewLine()
                            Qvent = Qp(.Ze_Mur(.Profil_LongPan + 1)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                            rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                            rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.00") & " daN/m²") : rtf.NewLine()
                        Case Is > 2
                            rtf.WriteString("h>2.b - Plusieurs hauteurs de référence (= cas 3 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                            i1 = 0
                            For i = .Profil_LongPan To .Ze.Count - 1
                                i1 = i1 + 1
                                rtf.WriteString("Pression dynamique de pointe pour la hauteur n°" & (i1).ToString() & " de référence Ze: " & .Ze_Mur(i).ToString("##0.000") & " m.") : rtf.NewLine()
                                Qvent = Qp(.Ze_Mur(i)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                                rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                                rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                                rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                                rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
                                rtf.NewLine()
                            Next
                    End Select
                    rtf.Italic = True : rtf.Underline = True
                    rtf.WriteString("3 - 2 - 2  Calcul des pressions du vent sur la façade sous le vent (Zone D)") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
                    rtf.WriteString("La pression externe indiquée ne prend pas en compte la pression interne, le défaut de corrélation et le coefficient " &
                            "structural CsCd. Il s'agit d'une pression brute.") : rtf.NewLine()
                    If .Ze_Mur.Count = 1 Then
                        rtf.WriteString("Zone D - Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                    Else
                        Qvent = Qp(.Ze_Mur(.Profil_LongPan)) / 10
                        rtf.WriteString("Pression pour la 1ière hauteur de profil: Zone D - Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                    End If
                    If .Ze_Mur.Count = 2 Then
                        Qvent = Qp(.Ze_Mur(.Profil_LongPan + 1)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                        rtf.WriteString("Pression pour la 2ième hauteur de profil: Zone D - Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                    ElseIf .Ze_Mur.Count > 2 Then
                        For i = .Profil_LongPan To .Ze.Count - 1
                            Qvent = Qp(.Ze_Mur(i)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                            rtf.WriteString("Pression pour la hauteur de profil n°" & j.ToString() & ": Zone D - Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        Next
                    End If
                End If
            End If
            rtf.NewLine()
            '______________________________________________________________________________________________________________________________________________________________________
            '
            '--> vent sur pignon (=perpendiculaire aux halls), Zone A uniquement, c'est la plus défavorable
            '
            rtf.NewLine() : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("3 - 3  Vent sur Pignon") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine()
            rtf.NewLine() : rtf.Italic = True : rtf.Underline = True
            rtf.WriteString("3 - 3 - 1 - Calcul de la pression dynamique de pointe Qp appliquée sur le pignon") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            'Détermination des hauteurs de références
            j = .Ze_Mur.Count
            Select Case .Hbat
                Case Is < .LargBat 'hauteur du batiment<longueur de la façade
                    .Ze_Mur.Add(.Hbat) ': Profil = 1
                Case Is < 2 * .LargBat 'longueur de la façade<hauteur du batiment<2xlongueur de la façade
                    .Ze_Mur.Add(.LargBat) : .Ze_Mur.Add(.Hbat) ': Profil = 10
                    msg = "La hauteur du bâtiment (= " & .Hbat.ToString("#0.000") & " m) est supérieure à la longueur de la façade (= " & .LargBat.ToString("#0.000") & " m). Cela " & vbCrLf &
                          "produit un profil avec deux pressions dynamiques sur la façade. Or le logiciel  n'est pas validé pour ce cas de figure." & vbCrLf &
                        "Voulez-vous continuer le calcul? (Oui/Non)"
                    If MsgBox(msg, MsgBoxStyle.Question Or MsgBoxStyle.YesNo, "Routine Eurocode. Sub Vent") = MsgBoxResult.No Then
                        Verif = False : rtf.WriteEndGroup() : Exit Sub
                    End If
                Case Else 'bâtiment de type tour - gratte-ciel
                    .Ze_Mur.Add(.LargBat)
                    Zeb = .LargBat
                    Do
                        Zref = .Hbat - Zeb - .LargBat ': Profil = 20
                        If Zref > .LargBat Then
                            Zeb = Zeb + .LargBat
                            .Ze_Mur.Add(Zeb)
                        ElseIf Zref > 0 Then
                            .Ze_Mur.Add(Zeb + Zref)
                            .Ze_Mur.Add(.Hbat)
                            Exit Do
                        End If
                        i = i + 1
                        If i = 100 Then Exit Do 'pour éviter une boucle infinie
                    Loop
                    msg = "La hauteur du bâtiment (= " & .Hbat.ToString("#0.000") & " m) est supérieure à 2 fois la longueur de la façade (= " & .LargBat.ToString("#0.000") & " m)." & vbCrLf &
                           "Cela produit un profil avec plusieurs pressions dynamiques sur la façade. Or le logiciel  n'est pas validé pour ce cas de figure." & vbCrLf &
                                      "Voulez-vous continuer le calcul? (Oui/Non)"
                    If MsgBox(msg, MsgBoxStyle.Question Or MsgBoxStyle.YesNo, "Routine Eurocode. Sub Vent") = MsgBoxResult.No Then
                        Verif = False : rtf.WriteEndGroup() : Exit Sub
                    End If
            End Select

            rtf.Underline = True
            rtf.WriteString("Eléments généraux:") : rtf.Underline = False : rtf.NewLine()
            rtf.WriteString("Voir chapitre ci-avant. ") : rtf.NewLine()
            rtf.NewLine() : rtf.Underline = True
            rtf.WriteString("Eléments liés à la façade:") : rtf.Underline = False : rtf.NewLine()
            If .Zeref > 0.1 Then
                rtf.WriteString("Hauteur de référence Ze fonction de construction voisine de grande dimension et de hauteur bien plus élevée (§4.3.4 de l'EN1991-1-4). ") : rtf.NewLine()
                rtf.WriteString(" - 1 seule hauteur de référence: " & .Zeref.ToString("#0.000") & " m.") : rtf.NewLine()
                rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
            Else
                rtf.WriteString("Hauteur de référence Ze fonction des dimensions de la façade. ") : rtf.NewLine()
                Select Case .Ze_Mur.Count - j
                    Case 1
                        rtf.WriteString("h<=b - 1 seule hauteur de référence: " & .Ze_Mur(.Ze_Mur.Count - 1).ToString("#0.000") & " m (= Hauteur de la façade - cas 1 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                        Qvent = Qp(.Ze_Mur(.Ze_Mur.Count - 1)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                        rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
                    Case 2
                        rtf.WriteString("b<h<=2.b - 2 hauteurs de référence: " & .Ze_Mur(.Ze_Mur.Count - 2).ToString("#0.000") & " m, et " & .Ze_Mur(.Ze_Mur.Count - 1).ToString("#0.000") & " m (= cas 2 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la première hauteur de référence Ze = longueur façade: " & .Ze_Mur(.Ze_Mur.Count - 2).ToString("##0.000") & " m.") : rtf.NewLine()
                        Qvent = Qp(.Ze_Mur(.Ze_Mur.Count - 2)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                        rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
                        rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la deuxième hauteur de référence Ze = hauteur bâtiment: " & .Ze_Mur(.Ze_Mur.Count - 1).ToString("##0.000") & " m.") : rtf.NewLine()
                        Qvent = Qp(.Ze_Mur(.Ze_Mur.Count - 1)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                        rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                        rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                        rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
                    Case Is > 2
                        rtf.WriteString("h>2.b - Plusieurs hauteurs de référence (= cas 3 figure 7.4 EN1991-1-4 §7.2.2)") : rtf.NewLine()
                        i1 = 0
                        For i = j To .Ze_Mur.Count - 1
                            i1 = i1 + 1
                            rtf.WriteString("Pression dynamique de pointe pour la hauteur n°" & (i1).ToString() & " de référence Ze: " & .Ze_Mur(i).ToString("##0.000") & " m.") : rtf.NewLine()
                            Qvent = Qp(.Ze_Mur(i)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                            rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                            rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                            rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.000") & " daN/m²") : rtf.NewLine()
                            rtf.NewLine()
                        Next

                End Select
            End If
            rtf.NewLine()
            .Profil_Pignon = .Ze_Mur.Count - j

            E = d  'Vent sur le Pignon, d =longueur du pignon
            If E > 2 * .Hbat Then E = 2 * .Hbat
            Select Case E
                Case Is < .LongBat
                    LA = E / 5 : LB = E * 4 / 5 : LC = .LongBat - E
                Case Is >= 5 * .LongBat
                    LA = E : LB = 0 : LC = 0
                Case Else 'd<e<5 * d
                    LA = E / 5 : LB = d - E / 5 : LC = 0
            End Select

            Select Case .Hbat / .LongBat 'rapport hauteur bat/longueur totale du bâtiment, ce dernier devenant le pignon
                Case Is > 5
                    Cpe10D = 0.8 : Cpe10E = -0.7
                Case Is <= 0.25
                    Cpe10D = 0.7 : Cpe10E = -0.3
                Case Is >= 1 '1=<.Hbat / d=<5
                    Cpe10D = 0.8
                    Cpe10E = -0.5 - 0.2 * ((.Hbat / .LongBat - 1) / 4)
                Case Else ' 0,25<.Hbat / d<1
                    Cpe10D = 0.7 + 0.1 * ((.Hbat / .LongBat - 0.25) / 0.75)
                    Cpe10E = -0.3 - 0.2 * ((.Hbat / .LongBat - 0.25) / 0.75)
            End Select
            'valeurs de CpeA et CpeB
            SA = LA * h_façade : SB = LB * h_façade
            If SA <= 10 Then Cpe10A = -1.4 + 0.2 * Log10(SA) Else Cpe10A = -1.2
            If SB <= 10 Then Cpe10B = -1.1 + 0.3 * Log10(SB) Else Cpe10B = -0.8
            Cpe10C = -0.5
            Select Case .Hbat / .LongBat 'prise en compte du défaut de corrélation
                Case Is >= 5
                    Correlation = 1
                Case Is <= 1
                    Correlation = 0.85
                Case Else
                    Correlation = 0.85 + 0.15 * (((.Hbat / .LongBat) - 1) / 4)
            End Select
            rtf.Italic = True : rtf.Underline = True
            rtf.WriteString("3 - 3 - 2 - Calcul des pressions du vent sur les murs par zones") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            rtf.WriteString("Dimension: e = " & E.ToString("#0.000") & " m.") : rtf.NewLine()
            rtf.WriteString("Défaut de corrélation: " & Correlation.ToString("#0.000")) : rtf.NewLine()
            Qvent = Qp(.Ze_Mur(.Ze_Mur.Count - .Profil_Pignon)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
            If .Profil_Pignon <= 2 Then
                rtf.WriteString("Zone D: Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            Else
                rtf.WriteString("Pression pour la 1ière hauteur de profil Zone D: Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            End If
            If .Profil_Pignon = 2 Then
                Qvent = Qp(.Ze_Mur(.Ze_Mur.Count - 1)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                rtf.WriteString("Pression pour la 2ième hauteur de profil Zone D: Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            ElseIf .Profil_Pignon > 2 Then
                i1 = 1
                For i = j + 1 To .Ze_Mur.Count - 1
                    i1 = i1 + 1
                    Qvent = Qp(.Ze_Mur(i)) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
                    rtf.WriteString("Pression pour la hauteur de profil n°" & i1.ToString() & " - Zone D: Cpe = " & Cpe10D.ToString("#0.000") & " - Pression: " & (Cpe10D * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                Next
            End If
            rtf.WriteString("Zone E: Cpe = " & Cpe10E.ToString("#0.000") & " - Pression: " & (Cpe10E * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Façades parallèle au vent sur lesquelles le défaut de corrélation ne s'applique pas: ") : rtf.NewLine()
            rtf.WriteString("Zone A: Cpe = " & Cpe10A.ToString("#0.000") & " - longueur de la Zone A: " & LA.ToString("#0.000") & " m  - Aire: " & SA.ToString("0.00") & " m² - Pression: " & (Cpe10A * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            If LB = 0 Then
                rtf.WriteString("Pas de Zone B.") : rtf.NewLine()
                rtf.WriteString("Pas de Zone C.") : rtf.NewLine()
            Else
                rtf.WriteString("Zone B: Cpe = " & Cpe10B.ToString("#0.000") & " - longueur de la Zone B: " & LB.ToString("#0.000") & " m - Aire: " & SB.ToString("0.00") & " m² - Pression: " & (Cpe10B * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                If LC = 0 Then
                    rtf.WriteString("Pas de zone C") : rtf.NewLine()
                Else
                    rtf.WriteString("Zone C: Cpe = " & Cpe10C.ToString("#0.000") & " - longueur de la Zone C: " & LC.ToString("#0.000") & " m - Pression: " & (Cpe10C * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                End If
            End If

            ''Cas vent sur pignon surpression - cas 5 du vent
            'détermination des valeurs de pressions par zones pour affichage dans la note de calcul
            '           Cpidg(1)   vent droite->gauche + surpression -> pousse sur les parois extérieures (façades et toitures)
            '           Cpidg(2)   vent droite->gauche + dépression -> aspire les parois extérieures (façades et toitures)
            Select Case .ValCpi
                Case 1, 3 'valeur de Cpi indépendantes de Cpe
                    Tab_Vent(21) = (.CsCd * Cpe10A - .CpiPlus) * Qvent '82
                    If LB = 0 Then Tab_Vent(22) = 1000 Else Tab_Vent(22) = (.CsCd * Cpe10B - .CpiPlus) * Qvent '83
                    If LC = 0 Then Tab_Vent(23) = 1000 Else Tab_Vent(23) = (.CsCd * Cpe10C - .CpiPlus) * Qvent '84
                    Tab_Vent(25) = (.CsCd * Correlation * Cpe10E - .CpiPlus) * Qvent '86
                    Tab_Vent(31) = (.CsCd * Cpe10A - .CpiMoins) * Qvent '91
                    If LB = 0 Then Tab_Vent(32) = 1000 Else Tab_Vent(32) = (.CsCd * Cpe10B - .CpiMoins) * Qvent '92
                    If LC = 0 Then Tab_Vent(33) = 1000 Else Tab_Vent(33) = (.CsCd * Cpe10C - .CpiMoins) * Qvent '93
                    Tab_Vent(35) = (.CsCd * Correlation * Cpe10E - .CpiMoins) * Qvent '96
                    i1 = 0
                    For i = j To .Ze_Mur.Count - 1
                        Qvent = Qp(.Ze_Mur(i)) / 10   '      For i = .Profil_LongPan To .Ze.Count - 1
                        i1 = i1 + 1
                        Select Case i1
                            Case 1
                                Tab_Vent(24) = (.CsCd * Correlation * Cpe10D - .CpiPlus) * Qvent
                                Tab_Vent(34) = (.CsCd * Correlation * Cpe10D - .CpiMoins) * Qvent '95
                            Case Else
                                Tab_Vent(73 + i1) = (.CsCd * Correlation * Cpe10D - .CpiPlus) * Qvent
                                Tab_Vent(79 + i1) = (.CsCd * Correlation * Cpe10D - .CpiMoins) * Qvent '95
                                If i1 = 6 Then Exit For 'limitation à 6 valeurs
                        End Select
                    Next
                Case 2

            End Select
        End With
        rtf.WriteEndGroup()
    End Sub
    Private Sub Pression_Couverture(ByRef Tab_Vent() As Double, ByRef Verif As Boolean, ByRef rtf As RtfAnsiTextWriter)

        Dim Qvent As Double
        With Wnd
            'Calcul de la pression dynamique de pointe pour la hauteur de référence: Qp  
            'Que ce soit une toiture-terrasse, à 1 ou 2 versants ou 2 versants multiples (shed), Ze référence = Hauteur du bâtiment

            Qvent = Qp(.Ze.Count - 1) / 10 'Qp est en Pa, les calculs sont en daN donc la pression doit être en daN/m²
            'transformation de pente de rad en ° et calcul de la pente la plus forte
            rtf.WriteStartGroup()
            rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("4 -  Détermination de l'effort externe du vent sur la toiture") : rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
            rtf.WriteString("4 - 1  Calcul de la pression dynamique de pointe appliquée à la toiture") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            If .GeomToiture < 4 Then 'And .Ze = .Hbat
                rtf.WriteString("Identique à la pression dynamique de pointe appliquée sur la dernière hauteur de référence de la façade. Voir §4.1") : rtf.NewLine()
            Else
                rtf.WriteString("Hauteur de référence Ze: " & .Ze(.Ze.Count - 1).ToString("#0.00 ") & " m.") : rtf.NewLine()
                rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Ze: Cr = " & .Cr.ToString("##0.000")) : rtf.NewLine()
                rtf.WriteString("Indice de turbulence pour la hauteur de référence Ze: Iv = " & .Iv.ToString("##0.000")) : rtf.NewLine()
                rtf.WriteString("Vitesse moyenne du vent pour la hauteur de référence Ze: Vm = " & .Vm.ToString("##0.000") & " m/s") : rtf.NewLine()
                rtf.WriteString("Pression dynamique de pointe pour la hauteur de référence Ze: Qp = " & Qvent.ToString("##0.00") & " daN/m²") : rtf.NewLine()
            End If

            rtf.NewLine() : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("4 - 2  Calcul des pressions du vent sur la couverture par zones") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            rtf.WriteString("Géométrie de la toiture: ")
            Select Case .GeomToiture
                Case 1
                    rtf.WriteString("toiture terrasse - pente< 5° (= 8,75%)") : rtf.NewLine()
                Case 2
                    rtf.WriteString("toiture à 1 versant") : rtf.NewLine()
                Case 3
                    rtf.WriteString("toiture à 2 versants") : rtf.NewLine()
                Case 4
                    rtf.WriteString("bâtiment constitué de 2 halls,toiture à 1 versant mais toiture sous forme de sheds multiples -> EN 1994-1-4 §7.2.7  ") : rtf.NewLine()

            End Select
            rtf.WriteString("Par convention, les pressions exerçant un effort de soulèvement sont prises négatives.") : rtf.NewLine()
            rtf.WriteString("La pression externe calculée pour chaque zone ne prend pas en compte la pression interne et le coefficient structural CsCd. Il s'agit d'une pression brute") : rtf.NewLine()
            rtf.WriteString("Les aires indiquées ci-après sont les surfaces réelles et non projetées ( = prise en compte de la pente).") : rtf.NewLine()
            rtf.WriteEndGroup()
            Select Case .GeomToiture
                Case 1 'toiture terrasse
                    Call Vent_ToitureTerrasse(Qvent, Tab_Vent, rtf)
                Case 2 'toiture 1 versant
                    Toiture1versant(Qvent, Tab_Vent, rtf, Verif)
                Case 3 'toiture 2 versants
                    Call Toiture2versant(Qvent, Tab_Vent, rtf, Verif)
                    'nbhall, Pvg, Pvd, LargHall, Trav, elem, Hacrot, Hbat, LongueurTot, Hjarret, nbFaitage, geom, nbAppentiG, nbAppentiD,
                    '                     CsCd, Cpigd, Cpidg, Cpipig, Pcont, Qvent, pVent, xV1, xV2, nb_Cpe, Verif)
                    If Verif = False Then Exit Sub
                Case 4 'toitures versants multiple
                    'For i = 1 To nbhall
                    '    If Abs(Pvg(i) * 180 / PI) > Abs(Pvd(i) * 180 / PI) Then
                    '        pente1 = Abs(Pvg(i) * 180 / PI)
                    '    Else
                    '        pente1 = Abs(Pvd(i) * 180 / PI)
                    '    End If
                    '    If pente1 > pente Then pente = pente1
                    'Next
                    'Call Toiture2versant_Multiple(nbhall, Pvg, Pvd, LargHall, Trav, elem, Hbat, LongueurTot, nbFaitage, CsCd, Cpigd, Cpidg, Cpipig,
                    '                                   Pcont, Qvent, pVent, xV1, nb_Cpe, Verif)
            End Select
        End With
    End Sub

    Private Sub Toiture1versant(ByVal Qvent As Double, ByVal Tab_Vent() As Double, ByRef rtf As RtfAnsiTextWriter, ByRef Verif As Boolean)
        Dim Cpe10Fup, Cpe10Flow, Cpe10F1, Cpe10F2, Cpe10G, Cpe10G1, Cpe10G2, Cpe10H, Cpe10H1, Cpe10H2, Cpe10I, SF, SG, SH, SI As Double
        Dim nb_Cpe As Integer
        Dim Lb, Ld, e As Double
        With Wnd
            'suivant LongPan
            Lb = .LongBat : Ld = .LargBat
            If Lb > 2 * .Hbat Then e = 2 * .Hbat Else e = Lb
            rtf.WriteStartGroup()
            rtf.NewLine() : rtf.Underline = True : rtf.Italic = True
            rtf.WriteString("4 - 2 - 1   Vent sur Longpan - Rive basse - Θ = 0°") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            Try
                Dim myImage As Image ' Create Image Element
                myImage = My.Resources.vent_T1vers_rivebasse
                rtf.InsertImage(myImage)
            Catch ex As Exception
                Dim msg As String
                msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
            End Try
            rtf.WriteString("Zones géométriques: e/4 = " & (e / 4).ToString("#0.000") & " m; e/10 = " & (e / 10).ToString("#0.000") & " m.") : rtf.NewLine()
            SF = e / 4 * e / 10 : SG = (e / 10 * Lb) - 2 * SF : SH = (Ld * Lb) - SG - 2 * SF
            SF = SF / Cos(.Pente_1Vers) : SG = SG / Cos(.Pente_1Vers) : SH = SH / Cos(.Pente_1Vers)
            Try
                Dim myImage As Image   ' Create Image Element
                myImage = My.Resources.vent_T1vers_LP
                rtf.InsertImage(myImage)
            Catch ex As Exception
                Dim msg As String
                msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
            End Try

            Call Pression_Rive_Basse(.Pente_1Vers, SF, SG, SH, Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, nb_Cpe, Verif)
            If nb_Cpe = 2 Then
                rtf.WriteString("Angle de pente < 45°: 2 valeurs de pression = pression positive et pression négative (cf tab 7.3a de l'EN 1991-1-4)") : rtf.NewLine()
                rtf.WriteString("a - pression positive soit pression sur la toiture") : rtf.NewLine()
                rtf.WriteString("Zone F: Cpe = " & Cpe10F2.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                rtf.WriteString("Zone G: Cpe = " & Cpe10G2.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                rtf.WriteString("Zone H: Cpe = " & Cpe10H2.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

                rtf.WriteString("b - pression négative soit soulèvement de la toiture") : rtf.NewLine()
                rtf.WriteString("Zone F: Cpe = " & Cpe10F1.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                rtf.WriteString("Zone G: Cpe = " & Cpe10G1.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                rtf.WriteString("Zone H: Cpe = " & Cpe10H1.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

            Else
                rtf.WriteString("Angle de pente > 45°: 1 seule valeur de pression = pression positive soit pression sur la toiture (cf tab 7.3a de l'EN 1991-1-4)") : rtf.NewLine()
                rtf.WriteString("Zone F: Cpe = " & Cpe10F2.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                rtf.WriteString("Zone G: Cpe = " & Cpe10G2.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                rtf.WriteString("Zone H: Cpe = " & Cpe10H2.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

            End If
            rtf.NewLine() : rtf.Underline = True : rtf.Italic = True
            rtf.WriteString("4 - 2 - 2   Vent sur Longpan - Rive haute - Θ = 180°") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            Try
                Dim myImage As Image ' Create Image Element
                myImage = My.Resources.vent_T1vers_rivehaute
                rtf.InsertImage(myImage)
            Catch ex As Exception
                Dim msg As String
                msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
            End Try
            rtf.WriteString("Zones géométriques: idetiques à celles figurant au chapitre précédent, voir image et valeurs numériques au §5-2-1 ci-avant.") : rtf.NewLine()
            Call Pression_Rive_Haute(.Pente_1Vers, SF, SG, SH, Cpe10F1, Cpe10G1, Cpe10H1)
            rtf.WriteString("Zone F: Cpe = " & Cpe10F1.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone G: Cpe = " & Cpe10G1.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone H: Cpe = " & Cpe10H1.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            'suivant Pignon
            Lb = .LargBat : Ld = .LongBat
            If Lb > 2 * .Hbat Then e = 2 * .Hbat Else e = Lb
            rtf.NewLine() : rtf.Underline = True : rtf.Italic = True
            rtf.WriteString("4 - 2 - 3   Vent sur Pignon") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            rtf.WriteString("Caractéristiques géométriques: e/4 = " & (e / 4).ToString("#0.000") & " m; e/10 = " & (e / 10).ToString("#0.000") & " m; e/2 =" & (e / 2).ToString("#0.000") & " m.") : rtf.NewLine()
            SF = e / 4 * e / 10 : SG = (e / 10 * Lb) - 2 * SF : SH = (e / 2 * Lb) - SG - 2 * SF : SI = Lb * Ld - (SH + SG + 2 * SF)
            SF = SF / Cos(.Pente_1Vers) : SG = SG / Cos(.Pente_1Vers) : SH = SH / Cos(.Pente_1Vers) : SI = SI / Cos(.Pente_1Vers)
            Try
                Dim myImage As Image ' Create Image Element
                myImage = My.Resources.vent_T1vers_Pignon
                rtf.InsertImage(myImage)
            Catch ex As Exception
                Dim msg As String
                msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
            End Try
            Call Pression_Pignon(.Pente_1Vers, SF, SG, SH, SI, Cpe10Fup, Cpe10Flow, Cpe10G, Cpe10H, Cpe10I)
            rtf.WriteString("Zone Fup: Cpe = " & Cpe10Fup.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10Fup * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone Flow: Cpe = " & Cpe10Flow.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10Flow * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone G: Cpe = " & Cpe10G.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone H: Cpe = " & Cpe10H.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone I: Cpe = " & Cpe10I.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

            rtf.WriteEndGroup()
            'pour injection dans tableau
            'longpan
            'surpression
            Tab_Vent(6) = (.CsCd * Cpe10F2 + .CpiPlus) * Qvent
            Tab_Vent(7) = (.CsCd * Cpe10G2 + .CpiPlus) * Qvent
            Tab_Vent(8) = (.CsCd * Cpe10H2 + .CpiPlus) * Qvent
            'Dépression
            Tab_Vent(26) = (.CsCd * Cpe10F2 + .CpiMoins) * Qvent
            Tab_Vent(27) = (.CsCd * Cpe10G2 + .CpiMoins) * Qvent
            Tab_Vent(28) = (.CsCd * Cpe10H2 + .CpiMoins) * Qvent
            If nb_Cpe = 2 Then
                'surpression
                Tab_Vent(16) = (.CsCd * Cpe10F1 + .CpiPlus) * Qvent
                Tab_Vent(17) = (.CsCd * Cpe10G1 + .CpiPlus) * Qvent
                Tab_Vent(18) = (.CsCd * Cpe10H1 + .CpiPlus) * Qvent
                'Dépression
                Tab_Vent(36) = (.CsCd * Cpe10F1 + .CpiMoins) * Qvent
                Tab_Vent(37) = (.CsCd * Cpe10G1 + .CpiMoins) * Qvent
                Tab_Vent(38) = (.CsCd * Cpe10H1 + .CpiMoins) * Qvent
            End If
            'Pignon
            'surpression
            Tab_Vent(46) = (.CsCd * Cpe10Fup + .CpiPlus) * Qvent
            Tab_Vent(47) = (.CsCd * Cpe10Flow + .CpiPlus) * Qvent
            Tab_Vent(48) = (.CsCd * Cpe10G + .CpiPlus) * Qvent
            Tab_Vent(49) = (.CsCd * Cpe10H + .CpiPlus) * Qvent
            Tab_Vent(50) = (.CsCd * Cpe10I + .CpiPlus) * Qvent
            'Dépression
            Tab_Vent(56) = (.CsCd * Cpe10Fup + .CpiMoins) * Qvent
            Tab_Vent(57) = (.CsCd * Cpe10Flow + .CpiMoins) * Qvent
            Tab_Vent(58) = (.CsCd * Cpe10G + .CpiMoins) * Qvent
            Tab_Vent(59) = (.CsCd * Cpe10H + .CpiMoins) * Qvent
            Tab_Vent(60) = (.CsCd * Cpe10I + .CpiMoins) * Qvent
        End With

    End Sub
    Private Sub Pression_Rive_Basse(ByVal Pente As Double, ByVal SF As Double, ByVal SG As Double, ByVal SH As Double, ByRef Cpe10F1 As Double, ByRef Cpe10F2 As Double,
                                    ByRef Cpe10G1 As Double, ByRef Cpe10G2 As Double, ByRef Cpe10H1 As Double, ByRef Cpe10H2 As Double, ByRef nb_Cpe As Integer, ByRef Verif As Boolean)
        Dim Cpe1F, Cpe1G, Cpe1H As Double
        'rappel: pente en radian, à transformer en °
        Pente = Pente * 180 / PI ' rad -> °
        If Pente < 0 Then
            MsgBox("Erreur logiciel - Accés au sous-prog <Pression_Rive_Basse> alors que la pente est négative !!!", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "sous-prog <Pression_Rive_Basse>")
            Verif = False : Exit Sub
        End If
        Select Case Pente
            Case Is >= 75
                nb_Cpe = 1
                Cpe10F1 = 0.8 : Cpe10G1 = 0.8 : Cpe10H1 = 0.8
            Case Is >= 60
                nb_Cpe = 1
                Cpe10F1 = Cpe_1vers(Pente, 60, 75, 0.7, 0.8) : Cpe10G1 = Cpe_1vers(Pente, 60, 75, 0.7, 0.8) : Cpe10H1 = Cpe_1vers(Pente, 60, 75, 0.7, 0.8)
            Case Is >= 45
                nb_Cpe = 1
                Cpe10F1 = 0.7 : Cpe10G1 = 0.7 : Cpe10H1 = Cpe_1vers(Pente, 45, 60, 0.6, 0.7)
            Case Is >= 30
                nb_Cpe = 2
                Cpe10F2 = 0.7 : Cpe10G2 = 0.7 : Cpe10H2 = Cpe_1vers(Pente, 30, 45, 0.4, 0.6)
                Cpe10G1 = Cpe_1vers(Pente, 30, 45, -0.5, 0) : Cpe10H1 = Cpe_1vers(Pente, 30, 45, -0.2, 0)
                Cpe10F1 = Cpe_1vers(Pente, 30, 45, -0.5, 0)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 30, 45, -1.5, 0)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = Cpe_1vers(Pente, 30, 45, -1.5, 0)
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 15
                nb_Cpe = 2
                Cpe10F2 = Cpe_1vers(Pente, 15, 30, 0.2, 0.7) : Cpe10G2 = Cpe_1vers(Pente, 15, 30, 0.2, 0.7) : Cpe10H2 = Cpe_1vers(Pente, 15, 30, 0.2, 0.4)
                Cpe10F1 = Cpe_1vers(Pente, 15, 30, -0.9, -0.5) : Cpe10G1 = Cpe_1vers(Pente, 15, 30, -0.8, -0.5) : Cpe10H1 = Cpe_1vers(Pente, 15, 30, -0.3, -0.2)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 15, 30, -2, -1.5)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = -1.5
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
            Case Else ' >= 5°
                nb_Cpe = 2
                Cpe10F2 = Cpe_1vers(Pente, 5, 15, 0, 0.2) : Cpe10G2 = Cpe_1vers(Pente, 5, 15, 0, 0.2) : Cpe10H2 = Cpe_1vers(Pente, 5, 15, 0, 0.2)
                Cpe10F1 = Cpe_1vers(Pente, 5, 15, -1.7, -0.9) : Cpe10G1 = Cpe_1vers(Pente, 5, 15, -1.2, -0.8) : Cpe10H1 = Cpe_1vers(Pente, 5, 15, -0.6, -0.3)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 5, 15, -2.5, -2)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = Cpe_1vers(Pente, 5, 15, -2, -1.5)
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = Cpe_1vers(Pente, 5, 15, -1.2, -0.3)
                    Cpe10H1 = Cpe1H - (Cpe1H - Cpe10H1) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
        End Select
    End Sub
    Private Sub Pression_Rive_Haute(ByVal Pente As Double, ByVal SF As Double, ByVal SG As Double, ByVal SH As Double, ByRef Cpe10F1 As Double, ByRef Cpe10G1 As Double,
                                    ByRef Cpe10H1 As Double)
        Dim Cpe1F, Cpe1G, Cpe1H As Double
        Pente = Abs(Pente) * 180 / PI ' rad -> °
        Select Case Pente
            Case Is >= 75
                Cpe10F1 = -0.5 : Cpe10G1 = -0.5 : Cpe10H1 = -0.5
                If SF < 10 Then
                    Cpe1F = -1
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 60
                Cpe10F1 = -0.5 : Cpe10G1 = -0.5 : Cpe10H1 = -0.5
                If SF < 10 Then
                    Cpe1F = -1
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 45
                Cpe10F1 = Cpe_1vers(Pente, 45, 60, -0.6, -0.5) : Cpe10G1 = -0.5 : Cpe10H1 = Cpe_1vers(Pente, 45, 60, -0.7, -0.5)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 45, 60, -1.3, -1)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 30
                Cpe10F1 = Cpe_1vers(Pente, 30, 45, -1.1, -0.6) : Cpe10G1 = Cpe_1vers(Pente, 30, 45, -0.8, -0.5) : Cpe10H1 = Cpe_1vers(Pente, 30, 45, -0.8, -0.7)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 30, 45, -2.3, -1.3)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = Cpe_1vers(Pente, 30, 45, -1.5, -0.5)
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 15
                Cpe10F1 = Cpe_1vers(Pente, 15, 30, -2.5, -1.1) : Cpe10G1 = Cpe_1vers(Pente, 15, 30, -1.3, -0.8) : Cpe10H1 = Cpe_1vers(Pente, 15, 30, -0.9, -0.8)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 15, 30, -2.8, -2.3)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = Cpe_1vers(Pente, 15, 30, -2, -1.5)
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = Cpe_1vers(Pente, 15, 30, -1.2, -0.8)
                    Cpe10H1 = Cpe1H - (Cpe1H - Cpe10H1) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
            Case Else 'Is >= 5
                Cpe10F1 = Cpe_1vers(Pente, 5, 15, -2.3, -2.5) : Cpe10G1 = -1.3 : Cpe10H1 = Cpe_1vers(Pente, 5, 15, -0.8, -0.9)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 5, 15, -2.5, -2.8)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = -1.2
                    Cpe10H1 = Cpe1H - (Cpe1H - Cpe10H1) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
        End Select
    End Sub
    Private Sub Pression_Pignon(ByVal Pente As Double, ByVal SF As Double, ByVal SG As Double, ByVal SH As Double, ByVal SI As Double, ByRef Cpe10Fup As Double, ByRef Cpe10Flow As Double,
                                ByRef Cpe10G As Double, ByRef Cpe10H As Double, ByRef Cpe10I As Double)
        Dim Cpe1F, Cpe1G, Cpe1H, Cpe1I As Double
        'Vent // au longpan ou perpendiculaire au Pignon
        Pente = Abs(Pente) * 180 / PI ' rad -> °
        Select Case Pente
            Case Is >= 75
                Cpe10Fup = -1.2 : Cpe10Flow = -1.2 : Cpe10G = -1.2 : Cpe10H = -1 : Cpe10I = -0.5
                If SF < 10 Then
                    Cpe1F = -2
                    Cpe10Fup = Cpe1F - (Cpe1F - Cpe10Fup) * Log10(SF) 'majoration de CpeF si surface<10m²
                    Cpe10Flow = Cpe10Fup
                End If
                If SG < 10 Then
                    Cpe1G = -2
                    Cpe10G = Cpe1G - (Cpe1G - Cpe10G) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = -1.3
                    Cpe10H = Cpe1H - (Cpe1H - Cpe10H) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 60
                Cpe10Fup = -1.2 : Cpe10Flow = -1.2 : Cpe10G = -1.2 : Cpe10H = -1 : Cpe10I = Cpe_1vers(Pente, 60, 75, -0.7, -0.5)
                If SF < 10 Then
                    Cpe1F = -2
                    Cpe10Fup = Cpe1F - (Cpe1F - Cpe10Fup) * Log10(SF) 'majoration de CpeF si surface<10m²
                    Cpe10Flow = Cpe10Fup
                End If
                If SG < 10 Then
                    Cpe1G = -2
                    Cpe10G = Cpe1G - (Cpe1G - Cpe10G) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = -1.3
                    Cpe10H = Cpe1H - (Cpe1H - Cpe10H) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
                If SI < 10 Then
                    Cpe1I = -1.2
                    Cpe10I = Cpe1i - (Cpe1i - Cpe10I) * Log10(SI) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 45
                Cpe10Fup = Cpe_1vers(Pente, 45, 60, -1.5, -1.2) : Cpe10Flow = Cpe_1vers(Pente, 45, 60, -1.3, -1.2)
                Cpe10G = Cpe_1vers(Pente, 45, 60, -1.4, -1.2) : Cpe10H = -1 : Cpe10I = Cpe_1vers(Pente, 45, 60, -0.9, -0.7)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 45, 60, -2.4, -2)
                    Cpe10Fup = Cpe1F - (Cpe1F - Cpe10Fup) * Log10(SF) 'majoration de CpeF si surface<10m²
                    Cpe1F = -2
                    Cpe10Flow = Cpe1F - (Cpe1F - Cpe10Flow) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = -2
                    Cpe10G = Cpe1G - (Cpe1G - Cpe10G) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = -1.3
                    Cpe10H = Cpe1H - (Cpe1H - Cpe10H) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
                If SI < 10 Then
                    Cpe1I = -1.2
                    Cpe10I = Cpe1I - (Cpe1I - Cpe10I) * Log10(SI) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 30
                Cpe10Fup = Cpe_1vers(Pente, 30, 45, -2.1, -1.5) : Cpe10Flow = -1.3 : Cpe10G = Cpe_1vers(Pente, 30, 45, -1.5, -1.4)
                Cpe10H = -1 : Cpe10I = Cpe_1vers(Pente, 30, 45, -0.8, -0.9)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 30, 45, -2.9, -2.4)
                    Cpe10Fup = Cpe1F - (Cpe1F - Cpe10Fup) * Log10(SF) 'majoration de CpeF si surface<10m²
                    Cpe1F = -2
                    Cpe10Flow = Cpe1F - (Cpe1F - Cpe10Flow) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = -2
                    Cpe10G = Cpe1G - (Cpe1G - Cpe10G) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = -1.3
                    Cpe10H = Cpe1H - (Cpe1H - Cpe10H) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
                If SI < 10 Then
                    Cpe1I = -1.2
                    Cpe10I = Cpe1I - (Cpe1I - Cpe10I) * Log10(SI) 'majoration de CpeF si surface<10m²
                End If
            Case Is >= 15
                Cpe10Fup = Cpe_1vers(Pente, 15, 30, -2.4, -2.1) : Cpe10Flow = Cpe_1vers(Pente, 15, 30, -1.6, -1.3)
                Cpe10G = Cpe_1vers(Pente, 15, 30, -1.9, -1.5) : Cpe10H = Cpe_1vers(Pente, 15, 30, -0.8, -1) : Cpe10I = Cpe_1vers(Pente, 15, 30, -0.7, -0.8)
                If SF < 10 Then
                    Cpe1F = -2.9
                    Cpe10Fup = Cpe1F - (Cpe1F - Cpe10Fup) * Log10(SF) 'majoration de CpeF si surface<10m²
                    Cpe1F = Cpe_1vers(Pente, 15, 30, -2.4, -2)
                    Cpe10Flow = Cpe1F - (Cpe1F - Cpe10Flow) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = Cpe_1vers(Pente, 15, 30, -2.5, -2)
                    Cpe10G = Cpe1G - (Cpe1G - Cpe10G) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = Cpe_1vers(Pente, 15, 30, -1.2, -1.3)
                    Cpe10H = Cpe1H - (Cpe1H - Cpe10H) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
                If SI < 10 Then
                    Cpe1I = -1.2
                    Cpe10I = Cpe1I - (Cpe1I - Cpe10I) * Log10(SI) 'majoration de CpeF si surface<10m²
                End If
            Case Else 'Is >= 5
                Cpe10Fup = Cpe_1vers(Pente, 5, 15, -2.1, -2.4) : Cpe10Flow = Cpe_1vers(Pente, 5, 15, -2.1, -1.6)
                Cpe10G = Cpe_1vers(Pente, 5, 15, -1.8, -1.9) : Cpe10H = Cpe_1vers(Pente, 5, 15, -0.6, -0.8) : Cpe10I = Cpe_1vers(Pente, 5, 15, -0.5, -0.7)
                If SF < 10 Then
                    Cpe1F = Cpe_1vers(Pente, 5, 15, -2.6, -2.9)
                    Cpe10Fup = Cpe1F - (Cpe1F - Cpe10Fup) * Log10(SF) 'majoration de CpeF si surface<10m²
                    Cpe1F = -2.4
                    Cpe10Flow = Cpe1F - (Cpe1F - Cpe10Flow) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                If SG < 10 Then
                    Cpe1G = Cpe_1vers(Pente, 5, 15, -2, -2.5)
                    Cpe10G = Cpe1G - (Cpe1G - Cpe10G) * Log10(SG) 'majoration de CpeF si surface<10m²
                End If
                If SH < 10 Then
                    Cpe1H = -1.2
                    Cpe10H = Cpe1H - (Cpe1H - Cpe10H) * Log10(SH) 'majoration de CpeF si surface<10m²
                End If
                If SI < 10 Then
                    Cpe1I = Cpe_1vers(Pente, 5, 15, -0.5, -1.2)
                    Cpe10I = Cpe1I - (Cpe1I - Cpe10I) * Log10(SI) 'majoration de CpeF si surface<10m²
                End If
        End Select
    End Sub
    Private Sub Pression_Vent_1versant_Multiple(ByVal i_cas As Integer, ByVal elem() As Integer, ByVal i_ele As Integer, ByVal pH As Double,
                                                ByVal k As Integer, ByVal trav As Double, ByVal CsCd As Double, ByVal Cpi As Double, ByRef pVent(,,,,) As Double)
        'Dim i As Integer
        'For i = elem(i_ele) To elem(i_ele + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '    'une seule pression de vent s'applique
        '    'pression origine
        '    pVent(i_cas, i, 1, 2, k) = (CsCd * pH + Cpi) * 0.5 * trav 'portique de rive 
        '    pVent(i_cas, i, 1, 1, k) = (CsCd * pH + Cpi) * trav 'portique intermédiaire
        '    'pression identique à l'origine et à l'extrémité
        '    pVent(i_cas, i, 2, 2, k) = (CsCd * pH + Cpi) * 0.5 * trav
        '    pVent(i_cas, i, 2, 1, k) = (CsCd * pH + Cpi) * trav
        'Next
    End Sub

    Private Sub Toiture2versant(ByVal Qvent As Double, ByVal Tab_Vent() As Double, ByRef rtf As RtfAnsiTextWriter, ByRef Verif As Boolean)

        Dim Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2 As Double ', Cpi
        Dim Cpe10I1, Cpe10J1, Cpe10I2, Cpe10J2 As Double
        Dim i_cas, j, nPvd, nPvg As Integer
        Dim Lb, Ld, e, SF, SG, SH, SI, SJ As Double
        With Wnd
            rtf.WriteStartGroup()
            rtf.FontSize = 12 : rtf.FontSize = 10
            For i_cas = 1 To 3
                Lb = 0
                Select Case i_cas
                    Case 1  'Vent perpendiculaire au longpan G/D 
                        Lb = .LongBat : Ld = .LargBat
                        If Lb > 2 * .Hbat Then e = 2 * .Hbat Else e = Lb
                        ' If i_cas = 1 Then Cpi = Cpigd(1) Else Cpi = Cpigd(2) 'surpression:indice=1 et dépression:indice=2

                        SH = ((.LargBat / 2 + .DecalFaitage) - e / 10) * Lb : SJ = (e / 10) * Lb : SI = ((.LargBat / 2 - .DecalFaitage) - e / 10) * Lb
                        SF = (e / 4) * (e / 10) : SG = (e / 10) * (Lb - 2 * (e / 4))
                        SH = SH / Cos(.Pvg) : SJ = SJ / Cos(.Pvd) : SI = SI / Cos(.Pvd) : SF = SF / Cos(.Pvg) : SG = SG / Cos(.Pvg)
                        Call Pression_2versant_LongPan(Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, Cpe10I1,
                                                                           Cpe10J1, Cpe10I2, Cpe10J2, nPvg, nPvd, Verif, .Pvg, .Pvd, SF, SG, SJ)
                        rtf.NewLine() : rtf.Underline = True : rtf.Italic = True
                        rtf.WriteString("4 - 2 - 1   Vent sur Longpan - sens du vent: Gauche vers la Droite ") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
                        rtf.WriteString("Dimension: e = " & e.ToString("#0.000") & " m.") : rtf.NewLine()
                        rtf.Bold = True
                        rtf.WriteString("Versant au vent:") : rtf.Bold = False : rtf.NewLine()
                        If nPvg = 2 Then

                            rtf.WriteString("Angle de pente < 45° et >-5°: 2 valeurs de pression = pression positive et pression négative (cf tab 7.3a de l'EN 1991-1-4)") : rtf.NewLine()
                            rtf.WriteString("a - pression positive soit pression sur la toiture") : rtf.NewLine()
                            rtf.WriteString("Zone F: Cpe = " & Cpe10F2.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone G: Cpe = " & Cpe10G2.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone H: Cpe = " & Cpe10H2.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

                            rtf.WriteString("b - pression négative soit soulèvement de la toiture") : rtf.NewLine()
                            rtf.WriteString("Zone F: Cpe = " & Cpe10F1.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone G: Cpe = " & Cpe10G1.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone H: Cpe = " & Cpe10H1.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

                        Else
                            rtf.WriteString("Angle de pente > 45° ou <-5°: 1 seule valeur de pression = pression positive soit pression sur la toiture (cf tab 7.3a de l'EN 1991-1-4)") : rtf.NewLine()
                            rtf.WriteString("Zone F: Cpe = " & Cpe10F2.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone G: Cpe = " & Cpe10G2.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone H: Cpe = " & Cpe10H2.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

                        End If
                        rtf.Bold = True
                        rtf.WriteString("Versant sous le vent:") : rtf.Bold = False : rtf.NewLine()
                        If nPvd = 2 Then

                            rtf.WriteString("Angle de pente < 45° et >-5°: 2 valeurs de pression = pression positive et pression négative (cf tab 7.3a de l'EN 1991-1-4)") : rtf.NewLine()
                            rtf.WriteString("a - pression positive soit pression sur la toiture") : rtf.NewLine()
                            rtf.WriteString("Zone I: Cpe = " & Cpe10I2.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone J: Cpe = " & Cpe10J2.ToString("#0.000") & " - Aire: " & SJ.ToString("#0.00") & " m² - Pression: " & (Cpe10J2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

                            rtf.WriteString("b - pression négative soit soulèvement de la toiture") : rtf.NewLine()
                            rtf.WriteString("Zone I: Cpe = " & Cpe10I1.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone J: Cpe = " & Cpe10J1.ToString("#0.000") & " - Aire: " & SJ.ToString("#0.00") & " m² - Pression: " & (Cpe10J1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        Else
                            rtf.WriteString("Angle de pente > 45° ou <-5°: 1 seule valeur de pression = pression négative soit soulèvement de la toiture (cf tab 7.3a de l'EN 1991-1-4)") : rtf.NewLine()
                            rtf.WriteString("Zone I: Cpe = " & Cpe10I1.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                            rtf.WriteString("Zone J: Cpe = " & Cpe10J1.ToString("#0.000") & " - Aire: " & SJ.ToString("#0.00") & " m² - Pression: " & (Cpe10J1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        End If
                        Try
                            Dim myImage As Image ' Create Image Element
                            myImage = My.Resources.vent_T2vers_LP
                            rtf.InsertImage(myImage)
                        Catch ex As Exception
                            Dim msg As String
                            msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
                        End Try
                        If Verif = False Then Exit Sub

                        'Pour affichage dans note de calcul
                        'surpression
                        Tab_Vent(6) = (.CsCd * Cpe10F1 - .CpiPlus) * Qvent
                        Tab_Vent(7) = (.CsCd * Cpe10G1 - .CpiPlus) * Qvent
                        Tab_Vent(8) = (.CsCd * Cpe10H1 - .CpiPlus) * Qvent
                        Tab_Vent(9) = (.CsCd * Cpe10I1 - .CpiPlus) * Qvent
                        Tab_Vent(10) = (.CsCd * Cpe10J1 - .CpiPlus) * Qvent
                        'dépression
                        Tab_Vent(26) = (.CsCd * Cpe10F1 - .CpiMoins) * Qvent
                        Tab_Vent(27) = (.CsCd * Cpe10G1 - .CpiMoins) * Qvent
                        Tab_Vent(28) = (.CsCd * Cpe10H1 - .CpiMoins) * Qvent
                        Tab_Vent(29) = (.CsCd * Cpe10I1 - .CpiMoins) * Qvent
                        Tab_Vent(30) = (.CsCd * Cpe10J1 - .CpiMoins) * Qvent
                        If nPvg = 2 Then
                            'surpression
                            Tab_Vent(16) = (.CsCd * Cpe10F2 - .CpiPlus) * Qvent
                            Tab_Vent(17) = (.CsCd * Cpe10G2 - .CpiPlus) * Qvent
                            Tab_Vent(18) = (.CsCd * Cpe10H2 - .CpiPlus) * Qvent
                            'dépression
                            Tab_Vent(36) = (.CsCd * Cpe10F2 - .CpiMoins) * Qvent
                            Tab_Vent(37) = (.CsCd * Cpe10G2 - .CpiMoins) * Qvent
                            Tab_Vent(38) = (.CsCd * Cpe10H2 - .CpiMoins) * Qvent
                        Else
                            'surpression
                            Tab_Vent(16) = 1000
                            Tab_Vent(17) = 1000
                            Tab_Vent(18) = 1000
                            'dépression
                            Tab_Vent(36) = 1000
                            Tab_Vent(37) = 1000
                            Tab_Vent(38) = 1000
                        End If
                        If nPvd = 2 Then
                            'surpression
                            Tab_Vent(19) = (.CsCd * Cpe10I2 - .CpiPlus) * Qvent
                            Tab_Vent(20) = (.CsCd * Cpe10J2 - .CpiPlus) * Qvent
                            'dépression
                            Tab_Vent(39) = (.CsCd * Cpe10I2 - .CpiMoins) * Qvent
                            Tab_Vent(40) = (.CsCd * Cpe10J2 - .CpiMoins) * Qvent
                        Else
                            'surpression
                            Tab_Vent(19) = 1000
                            Tab_Vent(20) = 1000
                            'dépression
                            Tab_Vent(39) = 1000
                            Tab_Vent(40) = 1000
                        End If
                    Case 2 'Vent perpendiculaire au longpan D/G
                        rtf.NewLine() : rtf.Underline = True : rtf.Italic = True
                        rtf.WriteString("4 - 2 - 2   Vent sur Longpan - sens du vent: Droite vers la Gauche ") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
                        If .DecalFaitage = 0 And .Pvd = .Pvg Then
                            rtf.WriteString("Bâtiment symétrique - Mêmes efforts quel que soit le longpan au vent. ") : rtf.NewLine()
                            rtf.WriteString("Les coefficients Cpe zone F à zone J sont identiques quelque soit le longpan sur lequel le vent souffle ( de la gauche vers la droite ou de la droite vers la gauche).") : rtf.NewLine()

                        Else
                            rtf.WriteString("Le bâtiment étant à pente dissymétrique, les coefficients Cpe zone F à zone J varient suivant le longpan sur lequel le vent souffle " &
                                                        "( de la gauche vers la droite ou de la droite vers la gauche).") : rtf.NewLine()
                            rtf.WriteString("Les valeurs indiquées ci-dessus correspondent à un vent soufflant de la gauche vers la droite.") : rtf.NewLine()
                            rtf.NewLine() : rtf.Underline = True
                            rtf.WriteString("Valeurs pour un vent soufflant de la droite vers la gauche:") : rtf.Underline = False : rtf.NewLine()
                            rtf.WriteString("A faire ... ") : rtf.NewLine()
                            Verif = False : rtf.WriteEndGroup()
                            MsgBox("Modélisation non implémentée", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
                            Exit Sub
                        End If

                    Case 3 'Vent sur pignon
                        Lb = .LargBat
                        If Lb > 2 * .Hbat Then e = 2 * .Hbat Else e = Lb
                        SH = (e / 2 - e / 10) * Lb / 2 : SI = (.LongBat - e / 2) * Lb / 2
                        SF = (e / 4) * (e / 10) : SG = (e / 10) * (Lb - 2 * (e / 4)) / 2
                        If .Pvg = .Pvd Then
                            SH = SH / Cos(.Pvg) : SI = SI / Cos(.Pvd) : SF = SF / Cos(.Pvg) : SG = SG / Cos(.Pvg)
                            Call Pression_2versant_Pignon(Cpe10F1, Cpe10G1, Cpe10H1, Cpe10I1, Verif, .Pvg, SF, SG)
                        Else
                            Verif = False : rtf.WriteEndGroup()
                            MsgBox("Modélisation non implémentée", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
                            Exit Sub
                        End If


                        'surpression
                        Tab_Vent(46) = (.CsCd * Cpe10F1 - .CpiPlus) * Qvent
                        Tab_Vent(47) = (.CsCd * Cpe10G1 - .CpiPlus) * Qvent
                        Tab_Vent(48) = (.CsCd * Cpe10H1 - .CpiPlus) * Qvent
                        Tab_Vent(49) = (.CsCd * Cpe10I1 - .CpiPlus) * Qvent
                        'dépression
                        Tab_Vent(56) = (.CsCd * Cpe10F1 - .CpiMoins) * Qvent
                        Tab_Vent(57) = (.CsCd * Cpe10G1 - .CpiMoins) * Qvent
                        Tab_Vent(58) = (.CsCd * Cpe10H1 - .CpiMoins) * Qvent
                        Tab_Vent(59) = (.CsCd * Cpe10I1 - .CpiMoins) * Qvent
                        rtf.NewLine() : rtf.Underline = True : rtf.Italic = True
                        rtf.WriteString("4 - 2 - 3   Vent sur Pignon ") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
                        rtf.WriteString("Dimension: e = " & e.ToString("#0.000") & " m.") : rtf.NewLine()
                        rtf.WriteString("Les aires F à I n'étant pas d'un seul tenant sur le même versant, les aires indiquées ci_après sont rapportées à chaque versant. " &
                                        "Les calculs de Cpe sont établis en tenant compte de ces surfaces.") : rtf.NewLine()
                        rtf.WriteString("Zone F: Cpe = " & Cpe10F1.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone G: Cpe = " & Cpe10G1.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone H: Cpe = " & Cpe10H1.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone I: Cpe = " & Cpe10I1.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Pas de zone J pour cette direction de vent.") : rtf.NewLine()
                        Try
                            Dim myImage As Image ' Create Image Element
                            myImage = My.Resources.vent_T2vers_Pignon
                            rtf.InsertImage(myImage)
                        Catch ex As Exception
                            Dim msg As String
                            msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
                        End Try

                End Select
            Next
            rtf.WriteEndGroup()
        End With

    End Sub
    Private Sub Pression_2versant_LongPan(ByRef Cpe10F1 As Double, ByRef Cpe10F2 As Double, ByRef Cpe10G1 As Double, ByRef Cpe10G2 As Double, ByRef Cpe10H1 As Double,
                                          ByRef Cpe10H2 As Double, ByRef Cpe10I1 As Double, ByRef Cpe10J1 As Double, ByRef Cpe10I2 As Double, ByRef Cpe10J2 As Double,
                                          ByRef nPvg As Integer, ByRef nPvd As Integer, ByRef Verif As Boolean,
                                          ByVal Pvg As Double, ByVal Pvd As Double, ByVal SF As Double, ByVal SG As Double, ByVal SJ As Double)
        'Vent perpendiculaire au longpan
        Dim Cpe1F, Cpe1G, Cpe1J As Double

        Pvg = Pvg * 180 / PI ' rad -> °
        nPvg = 1 : nPvd = 1 'initalisation = 1 seul coefficient Cpe10 par zone pour le versant sous le vent
        'coefficients de pression pour la pente au vent
        Select Case Pvg
            Case Is >= 75
                Cpe10F1 = 0.8 : Cpe10G1 = 0.8 : Cpe10H1 = 0.8
            Case Is >= 60
                Cpe10F1 = Cpe_1vers(Pvg, 60, 75, 0.7, 0.8) : Cpe10G1 = Cpe_1vers(Pvg, 60, 75, 0.7, 0.8) : Cpe10H1 = Cpe_1vers(Pvg, 60, 75, 0.7, 0.8)
            Case Is >= 45
                Cpe10F1 = 0.7 : Cpe10G1 = 0.7 : Cpe10H1 = Cpe_1vers(Pvg, 45, 60, 0.6, 0.7)
            Case Is >= 30
                nPvg = 2
                Cpe10F1 = Cpe_1vers(Pvg, 30, 45, -0.5, 0)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(Pvg, 30, 45, -1.5, 0)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = Cpe_1vers(Pvg, 30, 45, -0.5, 0)
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = Cpe_1vers(Pvg, 30, 45, -1.5, 0)
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(Pvg, 30, 45, -0.2, 0)
                Cpe10F2 = 0.7 : Cpe10G2 = 0.7 : Cpe10H2 = Cpe_1vers(Pvg, 30, 45, 0.4, 0.6)
            Case Is >= 15
                nPvg = 2
                Cpe10F1 = Cpe_1vers(Pvg, 15, 30, -0.9, -0.5)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(Pvg, 15, 30, -2, -1.5)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = Cpe_1vers(Pvg, 15, 30, -0.8, -0.5)
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -1.5
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(Pvg, 15, 30, -0.3, -0.2)
                Cpe10F2 = Cpe_1vers(Pvg, 15, 30, 0.2, 0.7) : Cpe10G2 = Cpe_1vers(Pvg, 15, 30, 0.2, 0.7) : Cpe10H2 = Cpe_1vers(Pvg, 15, 30, 0.2, 0.4)
            Case Is >= 5
                nPvg = 2
                Cpe10F1 = Cpe_1vers(Pvg, 5, 15, -1.7, -0.9)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(Pvg, 5, 15, -2.5, -2)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = Cpe_1vers(Pvg, 5, 15, -1.2, -0.8)
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = Cpe_1vers(Pvg, 5, 15, -2, -1.5)
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(Pvg, 5, 15, -0.6, -0.3)
                Cpe10F2 = Cpe_1vers(Pvg, 5, 15, 0, 0.2) : Cpe10G2 = Cpe_1vers(Pvg, 5, 15, 0, 0.2) : Cpe10H2 = Cpe_1vers(Pvg, 5, 15, 0, 0.2)
            Case Is >= -5
                'suivant le nota du tableau 7.4a, cette partie n'est pas utilisable. Utilisation de la table de valeurs de latoiture-terrasse.
                'Si branchement sur cette étiquette, bug dans le programme
                MsgBox("Erreur en sous-prog Pression_2versant_LongPan" & "Branchement sur une étiquette sans réalité physique - voir code pour correction",
                        MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Sous-prog Pression_2versant_LongPan")
                Verif = False : Exit Sub
            Case Is >= -15
                Cpe10F1 = Cpe_1vers(Pvg, -15, -5, -2.5, -2.3)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(Pvg, -15, -5, -2.8, -2.5)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = Cpe_1vers(Pvg, -15, -5, -1.3, -1.2)
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(Pvg, -15, -5, -0.9, -0.8)
            Case Is >= -30
                Cpe10F1 = Cpe_1vers(Pvg, -30, -15, -1.1, -2.5)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(Pvg, -30, -15, -2, -2.8)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = Cpe_1vers(Pvg, -30, -15, -0.8, -1.3)
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = Cpe_1vers(Pvg, -30, -15, -1.5, -2)
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(Pvg, -30, -15, -0.8, -0.9)
            Case Is >= -45
                Cpe10F1 = Cpe_1vers(Pvg, -45, -30, -0.6, -1.1)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(Pvg, -45, -30, -0.6, -2)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = Cpe_1vers(Pvg, -45, -30, -0.6, -0.8)
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = Cpe_1vers(Pvg, -45, -30, -0.6, -1.5)
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = -0.8
            Case Else '< -45
                Cpe10F1 = -0.6 : Cpe10G1 = -0.6 : Cpe10H1 = -0.8
        End Select
        Pvd = Pvd * 180 / PI 'transformation de l'angle en °, pris de même signe que pour pvg en raison de la formulation des tableaux dans l'eurocode
        'coefficients de pression pour la pente sous le vent
        Select Case Pvd
            Case Is >= 75
                Cpe10I1 = -0.2 : Cpe10J1 = -0.3
            Case Is >= 60
                Cpe10I1 = -0.2 : Cpe10J1 = -0.3
            Case Is >= 45
                Cpe10I1 = -0.2 : Cpe10J1 = -0.3
            Case Is >= 30
                nPvd = 2
                Cpe10I1 = Cpe_1vers(Pvd, 30, 45, -0.4, -0.2) : Cpe10J1 = Cpe_1vers(Pvd, 30, 45, -0.5, -0.3)
                Cpe10I2 = 0 : Cpe10J2 = 0
            Case Is >= 15
                nPvd = 2
                Cpe10I1 = -0.4
                Cpe10J1 = Cpe_1vers(Pvd, 15, 30, -1, -0.5)
                If SJ < 10 Then 'surface inférieure à 10 m²
                    Cpe1J = Cpe_1vers(Pvd, 15, 30, -1.5, -0.5)
                    Cpe10J1 = Cpe1J - (Cpe1J - Cpe10J1) * Log10(SJ) 'majoration de CpeJ si surface<10m²
                End If
                Cpe10I2 = 0 : Cpe10J2 = 0
            Case Is >= 5
                nPvd = 2
                Cpe10I1 = Cpe_1vers(Pvd, 5, 15, -0.6, -0.4)
                Cpe10J1 = Cpe_1vers(Pvd, 5, 15, -0.6, -1)
                If SJ < 10 Then 'surface inférieure à 10 m²
                    Cpe1J = Cpe_1vers(Pvd, 5, 15, -0.6, -1.5)
                    Cpe10J1 = Cpe1J - (Cpe1J - Cpe10J1) * Log10(SJ) 'majoration de CpeJ si surface<10m²
                End If
                Cpe10I2 = Cpe_1vers(Pvd, 5, 15, 0.2, 0)
                Cpe10J2 = Cpe_1vers(Pvd, 5, 15, 0.2, 0)
            Case Is >= -5
                'suivant le nota du tableau 7.4a, cette partie n'est pas utilisable. Utilisation de la table de valeurs de latoiture-terrasse.
                'Si branchement sur cette étiquette, bug dans le programme
                MsgBox("Erreur en sous-prog Pression_2versant_LongPan" & "Branchement sur une étiquette sans réalité physique - voir code pour correction",
                        MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Sous-prog Pression_2versant_LongPan")
                Verif = False : Exit Sub
            Case Is >= -15
                Cpe10I1 = Cpe_1vers(Pvd, -15, -5, -0.5, -0.6)
                Cpe10J1 = Cpe_1vers(Pvd, -15, -5, -0.7, -0.6)
                If SJ < 10 Then 'surface inférieure à 10 m²
                    Cpe1J = Cpe_1vers(Pvd, -15, -5, -1.2, -0.6)
                    Cpe10J1 = Cpe1J - (Cpe1J - Cpe10J1) * Log10(SJ) 'majoration de CpeJ si surface<10m²
                End If
            Case Is >= -30
                Cpe10I1 = Cpe_1vers(Pvd, -30, -15, -0.6, -0.5)
                Cpe10J1 = Cpe_1vers(Pvd, -30, -15, -0.8, -0.7)
                If SJ < 10 Then 'surface inférieure à 10 m²
                    Cpe1J = Cpe_1vers(Pvd, -30, -15, -1.4, -1.2)
                    Cpe10J1 = Cpe1J - (Cpe1J - Cpe10J1) * Log10(SJ) 'majoration de CpeJ si surface<10m²
                End If
            Case Is >= -45
                Cpe10I1 = Cpe_1vers(Pvd, -45, -30, -0.7, -0.6)
                Cpe10J1 = Cpe_1vers(Pvd, -45, -30, -1, -0.8)
                If SJ < 10 Then 'surface inférieure à 10 m²
                    Cpe1J = Cpe_1vers(Pvd, -45, -30, -1.5, -1.4)
                    Cpe10J1 = Cpe1J - (Cpe1J - Cpe10J1) * Log10(SJ) 'majoration de CpeJ si surface<10m²
                End If
            Case Else '< -45
                Cpe10I1 = -0.7 : Cpe10J1 = -1
        End Select

    End Sub
    Private Sub Pression_2versant_Pignon(ByRef Cpe10F1 As Double, ByRef Cpe10G1 As Double, ByRef Cpe10H1 As Double, ByRef Cpe10I1 As Double, ByRef Verif As Boolean,
                                         ByVal pente As Double, ByVal SF As Double, ByVal SG As Double)
        'Vent // au longpan ou perpendiculaire au pignon
        Dim Cpe1F, Cpe1G As Double
        pente = pente * 180 / PI ' rad -> °
        Select Case pente
            Case Is >= 75
                Cpe10F1 = -1.1
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = -1.5
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = -1.2
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = -0.8 : Cpe10I1 = -0.5
            Case Is >= 60
                Cpe10F1 = -1.1
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = -1.5
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = -1.2
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = -0.8 : Cpe10I1 = -0.5
            Case Is >= 45
                Cpe10F1 = -1.1
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = -1.5
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = Cpe_1vers(pente, 45, 60, -1.4, -1.2)
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(pente, 45, 60, -0.9, -0.8) : Cpe10I1 = -0.5
            Case Is >= 30
                Cpe10F1 = -1.1
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = -1.5
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = -1.4
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(pente, 30, 45, -0.8, -0.9) : Cpe10I1 = -0.5
            Case Is >= 15
                Cpe10F1 = Cpe_1vers(pente, 15, 30, -1.3, -1.1)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(pente, 15, 30, -2, -1.5)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = Cpe_1vers(pente, 15, 30, -1.3, -1.4)
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(pente, 15, 30, -0.6, -0.8)
                Cpe10I1 = -0.5
            Case Is >= 5
                Cpe10F1 = Cpe_1vers(pente, 5, 15, -1.6, -1.3)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(pente, 5, 15, -2.2, 2)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = -1.3
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(pente, 5, 15, -0.7, -0.6)
                Cpe10I1 = Cpe_1vers(pente, 5, 15, -0.6, -0.5)
            Case Is >= -5
                'suivant le nota du tableau 7.4a, cette partie n'est pas utilisable. Utilisation de la table de valeurs de latoiture-terrasse.
                'Si branchement sur cette étiquette, bug dans le programme
                MsgBox("Erreur en sous-prog Pression_2versant_LongPan" & "Branchement sur une étiquette sans réalité physique - voir code pour correction",
                        MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Sous-prog Pression_2versant_LongPan")
                Verif = False : Exit Sub
            Case Is >= -15
                Cpe10F1 = Cpe_1vers(pente, -15, -5, -1.9, -1.8)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = -2.5
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = -1.2
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(pente, -15, -5, -0.8, -0.7)
                Cpe10I1 = Cpe_1vers(pente, -15, -5, -0.8, -0.6)
            Case Is >= -30
                Cpe10F1 = Cpe_1vers(pente, -30, -15, -1.5, -1.9)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(pente, -30, -15, -2.1, -2.5)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = -1.2
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = Cpe_1vers(pente, -30, -15, -1, -0.8)
                Cpe10I1 = Cpe_1vers(pente, -30, -15, -0.9, -0.8)
            Case Is >= -45
                Cpe10F1 = Cpe_1vers(pente, -45, -30, -1.4, -1.5)
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = Cpe_1vers(pente, -45, -30, -2, -2.1)
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = -1.2
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = -1 : Cpe10I1 = -0.9
            Case Else
                Cpe10F1 = -1.4
                If SF < 10 Then 'surface inférieure à 10 m²
                    Cpe1F = -2
                    Cpe10F1 = Cpe1F - (Cpe1F - Cpe10F1) * Log10(SF) 'majoration de CpeF si surface<10m²
                End If
                Cpe10G1 = -1.2
                If SG < 10 Then 'surface inférieure à 10 m²
                    Cpe1G = -2
                    Cpe10G1 = Cpe1G - (Cpe1G - Cpe10G1) * Log10(SG) 'majoration de CpeG si surface<10m²
                End If
                Cpe10H1 = -1 : Cpe10I1 = -0.9
        End Select
    End Sub

    Private Sub Vent_ToitureTerrasse(ByVal Qvent As Double, ByRef Tab_Vent() As Double, ByRef rtf As RtfAnsiTextWriter)

        'nb_Cpe = nombre de Cpe different pour une même zone de pression - voir zone I
        'rappel pour les coefficients Cpi: Cpigd(1) = vent gauche droite surpression; Cpigd(2) = vent gauche droite dépression et etc ...
        'CsCd coefficient structural applicable sur les surfaces extérieures
        Dim h, e, Cpe10F, Cpe1F, Cpe10G, Cpe10H, Cpe10I1, Cpe10I2, Cpi, Lb, Ld As Double
        Dim SF, SG, SH, SI As Double
        Dim i_cas As Integer

        With Wnd
            rtf.WriteStartGroup()
            Try
                Dim myImage As Image ' Create Image Element
                myImage = My.Resources.vent_terrasse
                rtf.InsertImage(myImage)
            Catch ex As Exception
                Dim msg As String
                msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
            End Try
            For i_cas = 1 To 2
                Select Case i_cas
                    Case 1   '  -  Cas vent G/D - cas 1 du vent Surpression + cas 2 du vent  Dépression''Cas vent D/G  - cas 3 du vent Surpression - +   - cas 4 du vent Dépression
                        Lb = .LongBat : Ld = .LargBat
                    Case 2 'Cas vent sur pignon surpression - cas 5 du vent
                        If .Hp = 0 Then .Hp = 0 Else .Hp = .Hp
                        Lb = .LargBat : Ld = .LongBat
                End Select
                'Vent sur long-pan  
                Select Case .Hp / .Hbat
                    Case Is < 0.025 'rives à arêtes vives
                        Cpe10F = -1.8 : Cpe1F = -2.5 : Cpe10G = -1.2 : Cpe10H = -0.7 : Cpe10I1 = -0.2 : Cpe10I2 = 0.2
                    Case Is < 0.05 'rives avec acrotère 
                        'appel à la fonction d'interpolation: Cpe_terras(hph As Double, ByVal hph1 As Double, ByVal hph2 As Double, ByVal Cpe1 As Double, ByVal Cpe2)
                        Cpe10F = Cpe_Terras(.Hp / .Hbat, 0.025, 0.05, -1.6, -1.4) : Cpe1F = Cpe_Terras(.Hp / .Hbat, 0.025, 0.05, -2.2, -2)
                        Cpe10G = Cpe_Terras(.Hp / .Hbat, 0.025, 0.05, -1.1, -0.9)
                        Cpe10H = -0.7 : Cpe10I1 = -0.2 : Cpe10I2 = 0.2
                    Case Is < 0.1 'rives avec acrotère
                        Cpe10F = Cpe_Terras(.Hp / .Hbat, 0.05, 0.1, -1.4, -1.2) : Cpe1F = Cpe_Terras(.Hp / .Hbat, 0.05, 0.1, -2, -1.8)
                        Cpe10G = Cpe_Terras(.Hp / .Hbat, 0.05, 0.1, -0.9, -0.8)
                        Cpe10H = -0.7 : Cpe10I1 = -0.2 : Cpe10I2 = 0.2
                    Case Is >= 0.1 'rives avec acrotère
                        Cpe10F = -1.2 : Cpe1F = -1.8 : Cpe10G = -0.8 : Cpe10H = -0.7 : Cpe10I1 = -0.2 : Cpe10I2 = 0.2
                End Select
                'calcul des pressions
                h = .Hbat - .Hp
                If Lb > 2 * h Then
                    e = 2 * h
                Else
                    e = Lb
                End If
                If e ^ 2 / 40 < 10 Then Cpe10F = Cpe1F - (Cpe1F - Cpe10F) * Log10(e ^ 2 / 40) 'majoration de CpeF si surface<10m²
                SF = e / 4 * e / 10 : SG = (e / 10 * Lb) - 2 * SF : SH = (e / 2 * Lb) - SG - 2 * SF : SI = Lb * Ld - (SH + SG + 2 * SF)

                'Dans la suite du calcul, la Zone I sera comptée uniquement avec le Cpi conduisant à un soulèvement, le Cpi conduisant à une charge gravitaire n’étant pas dimensionnant.
                Select Case i_cas 'toiture terrasse - pente< 5° (= 8,75%)
                    Case 1  ' vent G/D surpression et dépression' vent D/G surpression et dépression
                        rtf.NewLine() : rtf.Underline = True : rtf.Italic = True
                        rtf.WriteString("4 - 2 - 1   Vent sur Longpan ") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
                        rtf.WriteString("Caractéristiques géométriques: e/4 = " & (e / 4).ToString("#0.000") & " m; e/10 = " & (e / 10).ToString("#0.000") & " m; e/2 =" & (e / 2).ToString("#0.000") & " m.")
                        rtf.WriteString("Zone F: Cpe = " & Cpe10F.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone G: Cpe = " & Cpe10G.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone H: Cpe = " & Cpe10H.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone I (Soulèvement): Cpe = " & Cpe10I1.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone I (charge gravitaire): Cpe = " & Cpe10I2.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

                    Case 2 ' vent sur pignon
                        rtf.NewLine() : rtf.Underline = True : rtf.Italic = True
                        rtf.WriteString("4 - 2 - 2   Vent sur Pignon") : rtf.Italic = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
                        rtf.WriteString("Caractéristiques géométriques: e/4 = " & (e / 4).ToString("#0.000") & " m; e/10 = " & (e / 10).ToString("#0.000") & " m; e/2 =" & (e / 2).ToString("#0.000") & " m.")
                        rtf.WriteString("Zone F: Cpe = " & Cpe10F.ToString("#0.000") & " - Aire: " & SF.ToString("#0.00") & " m² - Pression: " & (Cpe10F * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone G: Cpe = " & Cpe10G.ToString("#0.000") & " - Aire: " & SG.ToString("#0.00") & " m² - Pression: " & (Cpe10G * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone H: Cpe = " & Cpe10H.ToString("#0.000") & " - Aire: " & SH.ToString("#0.00") & " m² - Pression: " & (Cpe10H * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone I (Soulèvement): Cpe = " & Cpe10I1.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I1 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()
                        rtf.WriteString("Zone I (charge gravitaire): Cpe = " & Cpe10I2.ToString("#0.000") & " - Aire: " & SI.ToString("#0.00") & " m² - Pression: " & (Cpe10I2 * Qvent).ToString("#0.00") & " daN/m²") : rtf.NewLine()

                End Select
            Next
            rtf.WriteEndGroup()
            'pour injection dans tableau
            'Long pan
            'surpression
            Tab_Vent(6) = (.CsCd * Cpe10F + .CpiPlus) * Qvent
            Tab_Vent(7) = (.CsCd * Cpe10G + .CpiPlus) * Qvent
            Tab_Vent(8) = (.CsCd * Cpe10H + .CpiPlus) * Qvent
            Tab_Vent(9) = (.CsCd * Cpe10I1 + Cpi) * Qvent
            'Dépression
            Tab_Vent(16) = (.CsCd * Cpe10F + .CpiMoins) * Qvent
            Tab_Vent(17) = (.CsCd * Cpe10G + .CpiMoins) * Qvent
            Tab_Vent(18) = (.CsCd * Cpe10H + .CpiMoins) * Qvent
            Tab_Vent(19) = (.CsCd * Cpe10I2 + .CpiMoins) * Qvent
            'Pignon
            'surpression
            Tab_Vent(26) = Tab_Vent(6) : Tab_Vent(27) = Tab_Vent(7) : Tab_Vent(28) = Tab_Vent(8) : Tab_Vent(29) = Tab_Vent(9)
            'Dépression
            Tab_Vent(36) = Tab_Vent(16) : Tab_Vent(37) = Tab_Vent(17) : Tab_Vent(38) = Tab_Vent(18) : Tab_Vent(39) = Tab_Vent(19)
        End With


    End Sub

    Private Sub Force_Frottement(ByRef Verif As Boolean, ByRef rtf As RtfAnsiTextWriter)
        Dim A_para, A_per, Aref_Mur, Aref_Toit, h_mur, L_min, F_fr As Double
        With Wnd
            rtf.WriteStartGroup()
            rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("6 - Calcul des forces de frottement") : rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
            rtf.WriteString("6 - 1  Forces de frottement dans le sens du longPan") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            rtf.WriteString("Sans objet - Aire totale de surface parallèle au vent < 4 x Aire totale perpendiculaire au vent et sous le vent. ") : rtf.NewLine()

            rtf.NewLine() : rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("6 - 2  Forces de frottement dans le sens du Pignon") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()

            Select Case .GeomToiture
                Case 1 ' toiture terrasse - pente< 5° (= 8,75%)
                    A_para = 2 * .LongBat * .Hbat + .LongBat * .LargBat
                    A_per = 2 * .LargBat * .Hbat
                    rtf.WriteString("Surface totale parallèle au vent: " & A_para.ToString("#,##0.00") & " m².") : rtf.NewLine()
                    rtf.WriteString("Surface totale perpendiculaire au vent: " & A_per.ToString("#,##0.00") & " m².") : rtf.NewLine()
                    If A_para < 4 * A_per Then
                        rtf.WriteString("Aucune force de frottement calculée - Aire totale de surface parallèle au vent < 4 x Aire totale perpendiculaire au vent et sous le vent. ") : rtf.NewLine()
                    Else
                        rtf.WriteString("Aire totale de surface parallèle au vent > 4 x Aire totale perpendiculaire au vent et sous le vent. ") : rtf.NewLine()
                        rtf.WriteString("Prise en compte des forces de frottement ") : rtf.NewLine()
                        rtf.WriteString("Coefficient de frottement:") : rtf.NewLine()
                        rtf.WriteString("... Mur Cfr:" & .Cfr_Mur.ToString("0.00")) : rtf.NewLine()
                        rtf.WriteString("... Toiture Cfr:" & .Cfr_Toit.ToString("0.00")) : rtf.NewLine()
                        L_min = Min(2 * .LargBat, 4 * .Hbat)
                        h_mur = .Hbat - (.LargBat / 2) * Tan(.Pente_1Vers)
                        Aref_Mur = h_mur * (.LongBat - L_min) * 2
                        If Aref_Mur < 0 Then
                            MessageBox.Show("Pb Aref_mur<0 - Calcul arrêté.", "Calcul au vent - forces de frottement", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            rtf.WriteEndGroup() : Verif = False : Exit Sub
                        End If
                        Aref_Toit = (.LargBat / Cos(.Pente_1Vers)) * (.LongBat - L_min)
                        F_fr = (Aref_Mur * .Cfr_Mur + Aref_Toit * .Cfr_Toit) * Qp(.Profil_LongPan - 1) / 10
                        rtf.WriteString("Surface de toiture soumise au frottement Aref: " & Aref_Toit.ToString("#,##0.00") & " m².") : rtf.NewLine()
                        rtf.WriteString("Surface de mur soumise au frottement Aref: " & Aref_Mur.ToString("#,##0.00") & " m².") : rtf.NewLine()
                        rtf.WriteString("Force totale de frottement Ffr: " & F_fr.ToString("#,##0.00") & " daN.") : rtf.NewLine()
                    End If
                Case 2 'toiture à 1 versant
                    h_mur = .Hbat - (.LargBat * Tan(.Pente_1Vers))
                    A_para = .LongBat * .Hbat + .LongBat * h_mur + .LongBat * .LargBat / Cos(.Pente_1Vers)
                    A_per = 2 * .LargBat * h_mur + (.Hbat - h_mur) * .LargBat
                    rtf.WriteString("Surface totale parallèle au vent: " & A_para.ToString("#,##0.00") & " m².") : rtf.NewLine()
                    rtf.WriteString("Surface totale perpendiculaire au vent: " & A_per.ToString("#,##0.00") & " m².") : rtf.NewLine()
                    If A_para < 4 * A_per Then
                        rtf.WriteString("Aucune force de frottement calculée - Aire totale de surface parallèle au vent < 4 x Aire totale perpendiculaire au vent et sous le vent. ") : rtf.NewLine()
                    Else
                        rtf.WriteString("Aire totale de surface parallèle au vent > 4 x Aire totale perpendiculaire au vent et sous le vent. ") : rtf.NewLine()
                        rtf.WriteString("Prise en compte des forces de frottement ") : rtf.NewLine()
                        rtf.WriteString("Coefficient de frottement:") : rtf.NewLine()
                        rtf.WriteString("... Mur Cfr:" & .Cfr_Mur.ToString("0.00")) : rtf.NewLine()
                        rtf.WriteString("... Toiture Cfr:" & .Cfr_Toit.ToString("0.00")) : rtf.NewLine()
                        L_min = Min(2 * .LargBat, 4 * .Hbat)
                        Aref_Mur = h_mur * (.LongBat - L_min) + .Hbat * (.LongBat - L_min)
                        If Aref_Mur < 0 Then
                            MessageBox.Show("Pb Aref_mur<0 - Calcul arrêté.", "Calcul au vent - forces de frottement", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            rtf.WriteEndGroup() : Verif = False : Exit Sub
                        End If
                        Aref_Toit = (.LargBat / Cos(.Pente_1Vers)) * (.LongBat - L_min)
                        F_fr = (Aref_Mur * .Cfr_Mur + Aref_Toit * .Cfr_Toit) * Qp(.Profil_LongPan - 1) / 10
                        rtf.WriteString("Surface de toiture soumise au frottement Aref: " & Aref_Toit.ToString("#,##0.00") & " m².") : rtf.NewLine()
                        rtf.WriteString("Surface de mur soumise au frottement Aref: " & Aref_Mur.ToString("#,##0.00") & " m².") : rtf.NewLine()
                        rtf.WriteString("Force totale de frottement Ffr: " & F_fr.ToString("#,##0.00") & " daN.") : rtf.NewLine()
                    End If
                Case 3 'toiture à 2 versants 
                    If .DecalFaitage < 0.05 And .Pvg = .Pvd Then
                        h_mur = .Hbat - (.LargBat * Tan(.Pvg) / 2)
                    Else
                        rtf.WriteString("A faire") : rtf.WriteEndGroup() : Exit Sub
                    End If
                    A_para = 2 * .LongBat * h_mur + .LongBat * .LargBat / Cos(.Pvg)
                    A_per = 2 * .LargBat * h_mur + (.Hbat - h_mur) * .LargBat
                    rtf.WriteString("Surface totale parallèle au vent: " & A_para.ToString("#,##0.00") & " m².") : rtf.NewLine()
                    rtf.WriteString("Surface totale perpendiculaire au vent: " & A_per.ToString("#,##0.00") & " m².") : rtf.NewLine()
                    If A_para < 4 * A_per Then
                        rtf.WriteString("Aucune force de frottement calculée - Aire totale de surface parallèle au vent < 4 x Aire totale perpendiculaire au vent et sous le vent. ") : rtf.NewLine()
                    Else
                        rtf.WriteString("Aire totale de surface parallèle au vent > 4 x Aire totale perpendiculaire au vent et sous le vent. ") : rtf.NewLine()
                        rtf.WriteString("Prise en compte des forces de frottement ") : rtf.NewLine()
                        rtf.WriteString("Coefficient de frottement:") : rtf.NewLine()
                        rtf.WriteString("... Mur Cfr:" & .Cfr_Mur.ToString("0.00")) : rtf.NewLine()
                        rtf.WriteString("... Toiture Cfr:" & .Cfr_Toit.ToString("0.00")) : rtf.NewLine()
                        L_min = Min(2 * .LargBat, 4 * .Hbat)
                        Aref_Mur = 2 * h_mur * (.LongBat - L_min)
                        If Aref_Mur < 0 Then
                            MessageBox.Show("Pb Aref_mur<0 - Calcul arrêté.", "Calcul au vent - forces de frottement", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            rtf.WriteEndGroup() : Verif = False : Exit Sub
                        End If
                        Aref_Toit = (.LargBat / Cos(.Pente_1Vers)) * (.LongBat - L_min)
                        F_fr = (Aref_Mur * .Cfr_Mur + Aref_Toit * .Cfr_Toit) * Qp(.Profil_LongPan - 1) / 10
                        rtf.WriteString("Surface de toiture soumise au frottement Aref: " & Aref_Toit.ToString("#,##0.00") & " m².") : rtf.NewLine()
                        rtf.WriteString("Surface de mur soumise au frottement Aref: " & Aref_Mur.ToString("#,##0.00") & " m².") : rtf.NewLine()
                        rtf.WriteString("Force totale de frottement Ffr: " & F_fr.ToString("#,##0.00") & " daN.") : rtf.NewLine()
                    End If
                Case 4
                    rtf.WriteString("A faire ") : rtf.NewLine()
            End Select
            rtf.WriteEndGroup()
        End With
    End Sub

    Private Sub Acrotere(ByRef rtf As RtfAnsiTextWriter)
        Dim CpA, CpB, CpC, CpD As Double
        With Wnd
            If .Acrot_LongPan = True And .Acrot_Pignon = False Then
                Select Case .LongBat / .Hp
                    Case Is < 3
                        CpA = 2.3 : CpB = 1.4 : CpC = 1.2 : CpD = 1.2
                    Case Is = 5
                        CpA = 2.9 : CpB = 1.8 : CpC = 1.4 : CpD = 1.2
                    Case Is >= 10
                        CpA = 3.4 : CpB = 2.1 : CpC = 1.7 : CpD = 1.2
                End Select
            ElseIf .Acrot_LongPan = False And .Acrot_Pignon = True Then
                Select Case .LargBat / .Hp
                    Case Is < 3
                        CpA = 2.3 : CpB = 1.4 : CpC = 1.2 : CpD = 1.2
                    Case Is = 5
                        CpA = 2.9 : CpB = 1.8 : CpC = 1.4 : CpD = 1.2
                    Case Is >= 10
                        CpA = 3.4 : CpB = 2.1 : CpC = 1.7 : CpD = 1.2
                End Select
            Else 'les 2 vraies
                CpA = 2.1 : CpB = 1.8 : CpC = 1.4 : CpD = 1.2
            End If
            rtf.WriteStartGroup()
            rtf.NewParagraph()
            rtf.Bold = True : rtf.Underline = True
            rtf.WriteString("Efforts sur acrotères:") : rtf.Bold = False : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
            If .Acrot_LongPan = True And .Acrot_Pignon = True Then
                rtf.WriteString("Sur LongPan et Pignon:") : rtf.NewLine()
            ElseIf .Acrot_LongPan = True And .Acrot_Pignon = False Then
                rtf.WriteString("Sur LongPan:") : rtf.NewLine()
            ElseIf .Acrot_Pignon = True Then
                rtf.WriteString("Sur Pignon:") : rtf.NewLine()
            End If
            rtf.WriteString("Zone A: Cpnet = " & CpA.ToString("#0.00") & " - Longueur: " & (0.3 * .Hp).ToString("#0.00") & " m - Pression: " & (CpA * Qp(.Profil_LongPan - 1) / 10).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone B: Cpnet = " & CpB.ToString("#0.00") & " - Longueur: " & (1.7 * .Hp).ToString("#0.00") & " m - Pression: " & (CpB * Qp(.Profil_LongPan - 1) / 10).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone C: Cpnet = " & CpC.ToString("#0.00") & " - Longueur: " & (2 * .Hp).ToString("#0.00") & " m - Pression: " & (CpC * Qp(.Profil_LongPan - 1) / 10).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteString("Zone D: Cpnet = " & CpD.ToString("#0.00") & " sur la longueur restante - Pression: " & (CpD * Qp(.Profil_LongPan - 1) / 10).ToString("#0.00") & " daN/m²") : rtf.NewLine()
            rtf.WriteEndGroup()
        End With

    End Sub
    Private Sub Toiture_formant_versant_unique(ByVal nbhall As Integer, ByVal Pvg() As Double, ByVal LargHall() As Double, ByVal Trav As Double,
                                               ByVal elem() As Integer, ByVal Hacrot() As Double, ByVal Hbat As Double,
                                               ByVal LongueurTot As Double, ByVal Hjarret(,) As Double,
                                                ByVal CsCd As Double, ByVal Cpigd() As Double, ByVal Cpidg() As Double, ByVal Cpipig As Double,
                                               ByRef pVent(,,,,) As Double, ByRef xV1(,) As Double, ByRef xV2(,) As Double, ByRef nb_Cpe(,) As Integer,
                                               ByRef Verif As Boolean)
        'Dim Cpe10Fup, Cpe10Flow, Cpe10F1, Cpe10F2, Cpe10G, Cpe10G1, Cpe10G2, Cpe10H, Cpe10H1, Cpe10H2, Cpe10I, Cpi As Double
        'Dim i, i_cas As Integer
        'Dim Lb, e As Double
        'Dim LF1, LG1, LF2, LG2, LH1, LH2, LI1, LI2, LFG1, LFG2 As Double

        'For i_cas = 1 To 5
        '    Lb = 0
        '    Select Case i_cas
        '        Case 1, 2 'Vent perpendiculaire au longpan G/D                     
        '            Lb = LongueurTot
        '            If Lb > 2 * Hbat Then
        '                e = 2 * Hbat
        '            Else
        '                e = Lb
        '            End If
        '            Select Case e / 4
        '                Case Is > 1.5 * Trav
        '                    'intermédiaire et rive identique: région F
        '                    LF1 = 0.5 * Trav : LG1 = 0 'rive 
        '                    LF2 = Trav : LG2 = 0 'intermédiaire 
        '                Case Is > 0.5 * Trav
        '                    'rive: région F
        '                    LF1 = 0.5 * Trav : LG1 = 0 'rive 
        '                    'intermédiaire: région F et G
        '                    LF2 = (e / 4) - 0.5 * Trav : LG2 = Trav - LF2
        '                Case Else
        '                    'rive: région F et G
        '                    LF1 = (e / 4) : LG1 = (0.5 * Trav) - (e / 4) 'rive 
        '                    'intermédiaire: région G
        '                    LF2 = 0 * Trav : LG2 = Trav
        '            End Select
        '            If i_cas = 1 Then Cpi = Cpigd(1) Else Cpi = Cpigd(2) 'surpression:indice=1 et dépression:indice=2
        '            If Hjarret(1, 1) < Hjarret(nbhall, 2) Then
        '                'rive basse sur poteau de gauche et rive haute sur poteau de droite
        '                'correspond à la figure 7.10 configuration b
        '                Call Pression_Rive_Basse(Pvg(1), Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, i, Verif)
        '                If Verif = False Then Exit Sub
        '                nb_Cpe(i_cas, 1) = i
        '                Call Pression_Vent_1versant_GD(i_cas, elem, 1, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, CsCd, Cpi, pVent, xV1)
        '                If nbhall > 1 Then Call Pression_Vent_1versant_GD(i_cas, elem, 3, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 2) = i 'nef 2
        '                If nbhall > 2 Then Call Pression_Vent_1versant_GD(i_cas, elem, 5, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 3) = i 'nef 3
        '                If nbhall > 3 Then Call Pression_Vent_1versant_GD(i_cas, elem, 7, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 4) = i 'nef 4
        '                If nb_Cpe(i_cas, 1) = 2 Then
        '                    'la rive basse est sur le poteau de gauche et pente<30°, la deuxième valeur de Cpe10 est positive
        '                    's'il existe 2 valeurs pour Cpe, le logiciel prends toujours pour première valeur, la valeur négative
        '                    Call Pression_Vent_1versant_GD(i_cas, elem, 1, LF1, LF2, LG1, LG2, e, Cpe10F2, Cpe10G2, Cpe10H2, 2, Trav, CsCd, Cpi, pVent, xV1)
        '                    If nbhall > 1 Then Call Pression_Vent_1versant_GD(i_cas, elem, 3, LF1, LF2, LG1, LG2, e, Cpe10F2, Cpe10G2, Cpe10H2, 2, Trav, CsCd, Cpi, pVent, xV1) 'nef 2
        '                    If nbhall > 2 Then Call Pression_Vent_1versant_GD(i_cas, elem, 5, LF1, LF2, LG1, LG2, e, Cpe10F2, Cpe10G2, Cpe10H2, 2, Trav, CsCd, Cpi, pVent, xV1) 'nef 3
        '                    If nbhall > 3 Then Call Pression_Vent_1versant_GD(i_cas, elem, 7, LF1, LF2, LG1, LG2, e, Cpe10F2, Cpe10G2, Cpe10H2, 2, Trav, CsCd, Cpi, pVent, xV1) 'nef 4
        '                End If
        '            Else
        '                'rive haute sur poteau de gauche et rive basse sur poteau de droite
        '                'correspond à la figure 7.10 configuration a
        '                Call Pression_Rive_Haute(Pvg(1), Cpe10F1, Cpe10G1, Cpe10H1)
        '                nb_Cpe(i_cas, 1) = 1
        '                Call Pression_Vent_1versant_GD(i_cas, elem, 1, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, CsCd, Cpi, pVent, xV1)
        '                If nbhall > 1 Then Call Pression_Vent_1versant_GD(i_cas, elem, 3, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 2) = 1 'nef 2
        '                If nbhall > 2 Then Call Pression_Vent_1versant_GD(i_cas, elem, 5, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 3) = 1 'nef 3
        '                If nbhall > 3 Then Call Pression_Vent_1versant_GD(i_cas, elem, 7, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 4) = 1 'nef 4
        '            End If
        '        Case 3, 4 'Vent perpendiculaire au longpan D/G        
        '            If i_cas = 3 Then Cpi = Cpidg(1) Else Cpi = Cpidg(2) 'surpression:indice=1 et dépression:indice=2
        '            Lb = LargHall(1) + LargHall(2) + LargHall(3) + LargHall(4) 'longueur du pignon
        '            'toiture sous forme  de versant unique
        '            If Hjarret(1, 1) < Hjarret(nbhall, 2) Then
        '                'rive basse sur poteau de gauche et rive haute sur poteau de droite
        '                'correspond à la figure 7.10 configuration b
        '                Call Pression_Rive_Basse(Pvg(1), Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, i, Verif)
        '                If Verif = False Then Exit Sub
        '                nb_Cpe(i_cas, 1) = i  'i prends la valeur 1 ou 2
        '                Call Pression_Vent_1versant_DG(i_cas, elem, 1, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, Lb, CsCd, Cpi, pVent, xV1)
        '                If nbhall > 1 Then Call Pression_Vent_1versant_DG(i_cas, elem, 3, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 2) = i 'nef 2
        '                If nbhall > 2 Then Call Pression_Vent_1versant_DG(i_cas, elem, 5, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 3) = i 'nef 3
        '                If nbhall > 3 Then Call Pression_Vent_1versant_DG(i_cas, elem, 7, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 4) = i 'nef 4
        '                If nb_Cpe(i_cas, 1) = 2 Then
        '                    'la rive basse est sur le poteau de gauche et pente<30°, la deuxième valeur de Cpe10 est positive
        '                    's'il existe 2 valeurs pour Cpe, le logiciel prends toujours pour première valeur, la valeur négative
        '                    Call Pression_Vent_1versant_DG(i_cas, elem, 1, LF1, LF2, LG1, LG2, e, Cpe10F2, Cpe10G2, Cpe10H2, 2, Trav, Lb, CsCd, Cpi, pVent, xV1)
        '                    If nbhall > 1 Then Call Pression_Vent_1versant_DG(i_cas, elem, 3, LF1, LF2, LG1, LG2, e, Cpe10F2, Cpe10G2, Cpe10H2, 2, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 2) = i 'nef 2
        '                    If nbhall > 2 Then Call Pression_Vent_1versant_DG(i_cas, elem, 3, LF1, LF2, LG1, LG2, e, Cpe10F2, Cpe10G2, Cpe10H2, 2, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 3) = i 'nef 3
        '                    If nbhall > 3 Then Call Pression_Vent_1versant_DG(i_cas, elem, 3, LF1, LF2, LG1, LG2, e, Cpe10F2, Cpe10G2, Cpe10H2, 2, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 4) = i 'nef 4
        '                End If
        '            Else
        '                'rive haute sur poteau de gauche et rive basse sur poteau de droite
        '                'correspond à la figure 7.10 configuration a
        '                Call Pression_Rive_Haute(Pvg(1), Cpe10F1, Cpe10G1, Cpe10H1)
        '                nb_Cpe(i_cas, 1) = 1
        '                Call Pression_Vent_1versant_DG(i_cas, elem, 1, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, Lb, CsCd, Cpi, pVent, xV1)
        '                If nbhall > 1 Then Call Pression_Vent_1versant_DG(i_cas, elem, 3, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 2) = 1 'nef 2
        '                If nbhall > 2 Then Call Pression_Vent_1versant_DG(i_cas, elem, 5, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 3) = 1 'nef 3
        '                If nbhall > 3 Then Call Pression_Vent_1versant_DG(i_cas, elem, 7, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, 1, Trav, Lb, CsCd, Cpi, pVent, xV1) : nb_Cpe(i_cas, 4) = 1 'nef 4
        '            End If
        '        Case 5 'Vent sur pignon
        '            Call Pression_Pignon(Pvg(1), Cpe10Fup, Cpe10Flow, Cpe10G, Cpe10H, Cpe10I)
        '            nb_Cpe(5, 1) = 1
        '            Lb = LargHall(1) + LargHall(2) + LargHall(3) + LargHall(4) 'longueur du pignon 
        '            If Lb > 2 * Hbat Then
        '                e = 2 * Hbat
        '            Else
        '                e = Lb
        '            End If
        '            If e / 10 > 1.5 * Trav Then
        '                LH1 = 0 : LH2 = 0 : LI1 = 0 : LI2 = 0 : LFG1 = 0.5 * Trav : LFG2 = 1.5 * Trav
        '            ElseIf e / 10 > 0.5 * Trav Then
        '                LH1 = 0 : LI1 = 0 : LFG1 = 0.5 * Trav
        '                LFG2 = (e / 10) - 0.5 * Trav
        '                If e / 2 > 1.5 * Trav Then
        '                    LH2 = 1.5 * Trav - (e / 2) : LI2 = 0
        '                Else
        '                    LH2 = (e / 2) - (e / 10) : LI2 = 1.5 * Trav - (e / 2)
        '                End If
        '            End If
        '            Call Pression_Vent_1versant_Pignon(i_cas, elem, 1, LFG1, LFG2, LH1, LH2, LI1, LI2, Lb, e, Cpe10Flow, Cpe10Fup, Cpe10G, Cpe10H, Cpe10I, 1, Trav, Hjarret, nbhall, CsCd, Cpipig, pVent, xV1, xV2)
        '            If nbhall > 1 Then Call Pression_Vent_1versant_Pignon(i_cas, elem, 3, LFG1, LFG2, LH1, LH2, LI1, LI2, Lb, e, Cpe10Flow, Cpe10Fup, Cpe10G, Cpe10H, Cpe10I, 1, Trav, Hjarret, nbhall, CsCd, Cpipig, pVent, xV1, xV2) : nb_Cpe(5, 2) = 1 'nef 2
        '            If nbhall > 2 Then Call Pression_Vent_1versant_Pignon(i_cas, elem, 5, LFG1, LFG2, LH1, LH2, LI1, LI2, Lb, e, Cpe10Flow, Cpe10Fup, Cpe10G, Cpe10H, Cpe10I, 1, Trav, Hjarret, nbhall, CsCd, Cpipig, pVent, xV1, xV2) : nb_Cpe(5, 3) = 1 'nef 3
        '            If nbhall > 3 Then Call Pression_Vent_1versant_Pignon(i_cas, elem, 7, LFG1, LFG2, LH1, LH2, LI1, LI2, Lb, e, Cpe10Flow, Cpe10Fup, Cpe10G, Cpe10H, Cpe10I, 1, Trav, Hjarret, nbhall, CsCd, Cpipig, pVent, xV1, xV2) : nb_Cpe(5, 4) = 1 'nef 4
        '    End Select
        'Next
    End Sub
    Private Sub Toiture2versant_Multiple(ByVal nbhall As Integer, ByVal Pvg() As Double, ByVal Pvd() As Double, ByVal LargHall() As Double,
                                        ByVal Trav As Double, ByVal elem() As Integer, ByVal Hbat As Double, ByVal LongueurTot As Double,
                                   ByVal nbFaitage() As Integer, ByVal CsCd As Double, ByVal Cpigd() As Double, ByVal Cpidg() As Double, ByVal Cpipig As Double,
                                    ByVal Pcont() As Double, ByVal Qvent As Double,
                                  ByRef pVent(,,,,) As Double, ByRef xV1(,) As Double, ByRef nb_Cpe(,) As Integer, ByRef Verif As Boolean)
        'Dim Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, Cpe10I1, Cpe10J1, Cpe10I2, Cpe10J2, Lpignon, Cpi As Double
        'Dim i, i_cas, j, nPvd, nPvg As Integer
        'Dim Lb, e As Double
        'Dim LF1, LG1, LF2, LG2, SF, SG As Double
        'Dim Cp10F, Cp10G As Boolean
        'For i_cas = 1 To 5
        '    Lb = 0
        '    Select Case i_cas
        '        Case 1, 2 'Vent perpendiculaire au longpan G/D 
        '            Lb = LongueurTot
        '            If Lb > 2 * Hbat Then
        '                e = 2 * Hbat
        '            Else
        '                e = Lb
        '            End If
        '            Select Case e / 4
        '                Case Is > 1.5 * Trav
        '                    'intermédiaire et rive identique: région F
        '                    LF1 = 0.5 * Trav : LG1 = 0 'rive 
        '                    LF2 = Trav : LG2 = 0 'intermédiaire 
        '                Case Is > 0.5 * Trav
        '                    'rive: région F
        '                    LF1 = 0.5 * Trav : LG1 = 0 'rive 
        '                    'intermédiaire: région F et G
        '                    LF2 = (e / 4) - 0.5 * Trav : LG2 = Trav - LF2
        '                Case Else
        '                    'rive: région F et G
        '                    LF1 = (e / 4) : LG1 = (0.5 * Trav) - (e / 4) 'rive 
        '                    'intermédiaire: région G
        '                    LF2 = 0 * Trav : LG2 = Trav
        '            End Select
        '            If i_cas = 1 Then Cpi = Cpigd(1) Else Cpi = Cpigd(2) 'surpression:indice=1 et dépression:indice=2
        '            Call Pression_Rive_Basse(Pvg(1), Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, i, Verif)
        '            If Verif = False Then Exit Sub
        '            For i = 1 To nbhall : nb_Cpe(i_cas, i) = 1 : Next 'i
        '            Call Pression_Pente1_2V_Multiple(i_cas, nbFaitage(1), elem, 1, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, nbhall, 0, 1, Trav, CsCd, Cpi, pVent, xV1)
        '            Call Pression_2versant_LongPan(Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, Cpe10I1,
        '                                                Cpe10J1, Cpe10I2, Cpe10J2, nPvg, nPvd, Verif, -Pvd(1), -Pvg(2), Cp10F, Cp10G, SF, SG)
        '            Call Pression_Noue_2V_Multiple(i_cas, nbFaitage, elem, 1, 3, 1, Cpe10H1, Cpe10I1, 1, Trav, CsCd, Cpi, pVent)
        '            If nbhall > 2 Then
        '                Call Pression_2versant_LongPan(Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, Cpe10I1,
        '                                                              Cpe10J1, Cpe10I2, Cpe10J2, nPvg, nPvd, Verif, -Pvd(2), -Pvg(3), Cp10F, Cp10G, SF, SG)
        '                Call Pression_Noue_2V_Multiple(i_cas, nbFaitage, elem, 3, 5, 2, 0.6 * Cpe10H1, 0.6 * Cpe10I1, 1, Trav, CsCd, Cpi, pVent)
        '                If nbhall > 3 Then
        '                    Call Pression_2versant_LongPan(Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, Cpe10I1,
        '                                                            Cpe10J1, Cpe10I2, Cpe10J2, nPvg, nPvd, Verif, -Pvd(3), -Pvg(4), Cp10F, Cp10G, SF, SG)
        '                    Call Pression_Noue_2V_Multiple(i_cas, nbFaitage, elem, 5, 7, 3, 0.6 * Cpe10H1, 0.6 * Cpe10I1, 1, Trav, CsCd, Cpi, pVent)
        '                End If
        '            End If
        '            Call Pression_Terminal_2V_Multiple(i_cas, nbFaitage(nbhall), elem, 2 * nbhall - 1, 0.6 * Cpe10I1, 1, Trav, 1, CsCd, Cpi, pVent)
        '        Case 3, 4 'Vent perpendiculaire au longpan D/G
        '            If i_cas = 3 Then Cpi = Cpidg(1) Else Cpi = Cpidg(2) 'surpression:indice=1 et dépression:indice=2
        '            Lpignon = LargHall(1) + LargHall(2) + LargHall(3) + LargHall(4)
        '            Call Pression_Rive_Basse(Pvd(nbhall), Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, i, Verif)
        '            If Verif = False Then Exit Sub
        '            For i = 1 To nbhall : nb_Cpe(i_cas, i) = 1 : Next 'i 
        '            Call Pression_Pente1_2V_Multiple(i_cas, nbFaitage(nbhall), elem, nbhall - 1, LF1, LF2, LG1, LG2, e, Cpe10F1, Cpe10G1, Cpe10H1, nbhall, Lpignon, 1, Trav, CsCd, Cpi, pVent, xV1)
        '            Call Pression_2versant_LongPan(Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, Cpe10I1,
        '                                                            Cpe10J1, Cpe10I2, Cpe10J2, nPvg, nPvd, Verif, -Pvd(nbhall - 1), -Pvg(nbhall), Cp10F, Cp10G, SF, SG)
        '            Call Pression_Noue_2V_Multiple(i_cas, nbFaitage, elem, 2 * nbhall - 3, 2 * nbhall - 1, 1, Cpe10H1, Cpe10I1, 1, Trav, CsCd, Cpi, pVent)
        '            If nbhall > 2 Then
        '                Call Pression_2versant_LongPan(Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, Cpe10I1,
        '                                                            Cpe10J1, Cpe10I2, Cpe10J2, nPvg, nPvd, Verif, -Pvd(nbhall - 2), -Pvg(nbhall - 1), Cp10F, Cp10G, SF, SG)
        '                Call Pression_Noue_2V_Multiple(i_cas, nbFaitage, elem, 2 * nbhall - 5, 2 * nbhall - 3, 1, 0.6 * Cpe10H1, 0.6 * Cpe10I1, 1, Trav, CsCd, Cpi, pVent)
        '                If nbhall > 3 Then
        '                    Call Pression_2versant_LongPan(Cpe10F1, Cpe10F2, Cpe10G1, Cpe10G2, Cpe10H1, Cpe10H2, Cpe10I1,
        '                                                            Cpe10J1, Cpe10I2, Cpe10J2, nPvg, nPvd, Verif, -Pvd(nbhall - 3), -Pvg(nbhall - 2), Cp10F, Cp10G, SF, SG)
        '                    Call Pression_Noue_2V_Multiple(i_cas, nbFaitage, elem, 2 * nbhall - 7, 2 * nbhall - 5, 3, 0.6 * Cpe10H1, 0.6 * Cpe10I1, 1, Trav, CsCd, Cpi, pVent)
        '                End If
        '            End If
        '            Call Pression_Terminal_2V_Multiple(i_cas, nbFaitage(1), elem, 1, 0.6 * Cpe10I1, 1, Trav, 2, CsCd, Cpi, pVent)
        '        Case 5 'Vent sur pignon
        '            Lb = 0
        '            For i = 1 To nbhall
        '                Lb = Lb + LargHall(i) : nb_Cpe(5, j) = 1
        '            Next
        '            If Lb > 2 * Hbat Then
        '                e = 2 * Hbat
        '            Else
        '                e = Lb
        '            End If
        '            Dim LH1, LH2, LI1, LI2, LFG1, LFG2 As Double
        '            If e / 10 > 1.5 * Trav Then
        '                LH1 = 0 : LH2 = 0 : LI1 = 0 : LI2 = 0 : LFG1 = 0.5 * Trav : LFG2 = 1.5 * Trav
        '            ElseIf e / 10 > 0.5 * Trav Then
        '                LH1 = 0 : LI1 = 0 : LFG1 = 0.5 * Trav
        '                LFG2 = (e / 10) - 0.5 * Trav
        '                If e / 2 > 1.5 * Trav Then
        '                    LH2 = 1.5 * Trav - (e / 2) : LI2 = 0
        '                Else
        '                    LH2 = (e / 2) - (e / 10) : LI2 = 1.5 * Trav - (e / 2)
        '                End If
        '            End If
        '            'SH = ((e / 2) - e / 10) * Lb : SI = (LongueurTot - e / 2) * Lb
        '            SF = (e / 4) * (e / 10) : SG = (e / 10) * (Lb - 2 * (e / 4))
        '            If (e / 4) * (e / 10) < 10 Then
        '                Cp10F = False
        '                If (e / 10) * (Lb - 2 * (e / 4)) < 10 Then Cp10G = False
        '            End If
        '            For j = 1 To nbhall
        '                Call Pression_2versant_Pignon(Cpe10F1, Cpe10G1, Cpe10H1, Cpe10I1, Verif, Pvg(j), Cp10F, Cp10G, SF, SG)
        '                If Verif = False Then Exit Sub
        '                Call Pression_2versant_Pignon(Cpe10F2, Cpe10G2, Cpe10H2, Cpe10I2, Verif, Pvd(j), Cp10F, Cp10G, SF, SG)
        '                If Verif = False Then Exit Sub
        '                Call Pression_Vent_2versant_Pignon(i_cas, elem, 2 * j - 1, LFG1, LFG2, LH1, LH2, LI1, LI2, Lb, e,
        '                Cpe10F1, Cpe10G1, Cpe10H1, Cpe10I1, Cpe10F2, Cpe10G2, Cpe10H2, Cpe10I2, 1, nbFaitage(j), Trav, LargHall, CsCd, Cpipig, Pcont(j), Qvent, pVent, xV1)
        '            Next
        '    End Select
        'Next
    End Sub
    Private Sub Pression_Pente1_2V_Multiple(ByVal i_cas As Integer, ByVal noeFaitage As Integer, ByVal elem() As Integer, ByVal i_ele As Integer,
                                            ByVal LF1 As Double, ByVal LF2 As Double,
                                            ByVal LG1 As Double, ByVal LG2 As Double, ByVal e As Double, ByVal CpeF As Double,
                                            ByVal CpeG As Double, ByVal CpeH As Double, ByVal nbhall As Integer, ByVal Lpignon As Double,
                                            ByVal k As Integer, ByVal trav As Double, ByVal cscd As Double, ByVal Cpi As Double,
                                            ByRef pVent(,,,,) As Double, ByRef xV1(,) As Double)
        ''Rappel:  pVent(i_cas, i, i1, 1, k) :  i_cas: =1 pour G/D +surpression, =2 pour G/D + depression, ...
        ''                                     i = n° d'élément
        ''                                     i1 = 1 ou 2 suivant noeud origine ou extrémité de l'élément
        ''                                     1 ou 2 si portique rive ou intermédiaire
        ''                                     k =n° d'ordre , une pression pouvant être positive ou négative sur le même élément
        'Dim i, ele1 As Integer
        'Select Case i_ele
        '    Case 1 'vent venant de la gauche
        '        For i = elem(i_ele) To elem(i_ele + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '            If Ele(1, i) = noeFaitage Then Exit Sub 'alors calcul sous le vent
        '            'calcul de la couverture au vent
        '            If X_noe(Ele(1, i)) < e / 10 Then
        '                'pression origine
        '                pVent(i_cas, i, 1, 2, k) = cscd * (CpeF * LF1 + CpeG * LG1) + Cpi * (LF1 + LG1) 'portique de rive  
        '                pVent(i_cas, i, 1, 1, k) = cscd * (CpeF * LF2 + CpeG * LG2) + Cpi * (LF2 + LG2) 'portique intermédiaire
        '                If X_noe(Ele(2, i)) < e / 10 Then 'une seule pression de vent s'applique
        '                    'pression identique à l'origine et à l'extrémité
        '                    pVent(i_cas, i, 2, 2, k) = cscd * (CpeF * LF1 + CpeG * LG1) + Cpi * (LF1 + LG1) 'rive  
        '                    pVent(i_cas, i, 2, 1, k) = cscd * (CpeF * LF2 + CpeG * LG2) + Cpi * (LF2 + LG2) ' intermédiaire
        '                ElseIf X_noe(Ele(2, i)) < e / 2 Then '2 pressions de vent s'appliquent
        '                    'pression extrémité
        '                    pVent(i_cas, i, 2, 2, k) = (cscd * CpeH + Cpi) * 0.5 * trav
        '                    pVent(i_cas, i, 2, 1, k) = (cscd * CpeH + Cpi) * trav
        '                    xV1(i_cas, i) = e / 10 'coordonnées absolues, coordonnée du changement de pression
        '                End If
        '            Else
        '                'pression origine
        '                pVent(i_cas, i, 1, 2, k) = (cscd * CpeH + Cpi) * 0.5 * trav
        '                pVent(i_cas, i, 1, 1, k) = (cscd * CpeH + Cpi) * trav
        '                'une seule pression de vent s'applique
        '                'pression identique à l'origine et à l'extrémité
        '                pVent(i_cas, i, 2, 2, k) = (cscd * CpeH + Cpi) * 0.5 * trav
        '                pVent(i_cas, i, 2, 1, k) = (cscd * CpeH + Cpi) * trav
        '            End If
        '        Next
        '    Case nbhall - 1 'vent venant de la droite
        '        For i = elem(i_ele) To elem(i_ele + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '            If Ele(1, i) = noeFaitage Then ele1 = i : Exit For 'alors calcul sous le vent
        '        Next
        '        For i = ele1 To elem(i_ele + 1) 'éléments composant l'arbalétrier - du faitage vers la noue
        '            'calcul de la couverture au vent
        '            If Lpignon - X_noe(Ele(1, i)) < e / 10 Then
        '                'pression origine
        '                pVent(i_cas, i, 1, 2, k) = cscd * (CpeF * LF1 + CpeG * LG1) + Cpi * (LF1 + LG1) 'portique de rive  
        '                pVent(i_cas, i, 1, 1, k) = cscd * (CpeF * LF2 + CpeG * LG2) + Cpi * (LF2 + LG2) 'portique intermédiaire
        '                'une seule pression de vent s'applique
        '                'pression identique à l'origine et à l'extrémité
        '                pVent(i_cas, i, 2, 2, k) = cscd * (CpeF * LF1 + CpeG * LG1) + Cpi * (LF1 + LG1) 'rive  
        '                pVent(i_cas, i, 2, 1, k) = cscd * (CpeF * LF2 + CpeG * LG2) + Cpi * (LF2 + LG2) ' intermédiaire
        '            Else
        '                'pression origine
        '                pVent(i_cas, i, 1, 2, k) = (cscd * CpeH + Cpi) * 0.5 * trav
        '                pVent(i_cas, i, 1, 1, k) = (cscd * CpeH + Cpi) * trav
        '                If Lpignon - X_noe(Ele(2, i)) < e / 10 Then
        '                    pVent(i_cas, i, 2, 2, k) = cscd * (CpeF * LF1 + CpeG * LG1) + Cpi * (LF1 + LG1) 'rive  
        '                    pVent(i_cas, i, 2, 1, k) = cscd * (CpeF * LF2 + CpeG * LG2) + Cpi * (LF1 + LG1) ' intermédiaire
        '                    xV1(i_cas, i) = Lpignon - e / 10 'coordonnées absolues, coordonnée du changement de pression
        '                Else 'une seule pression de vent s'applique
        '                    'pression identique à l'origine et à l'extrémité
        '                    'pression extrémité
        '                    pVent(i_cas, i, 2, 2, k) = (cscd * CpeH + Cpi) * 0.5 * trav
        '                    pVent(i_cas, i, 2, 1, k) = (cscd * CpeH + Cpi) * trav
        '                End If
        '            End If
        '        Next

        'End Select

    End Sub
    Private Sub Pression_Noue_2V_Multiple(ByVal i_cas As Integer, ByVal nbFaitage() As Integer, ByVal elem() As Integer, ByVal i_ele As Integer, ByVal i_ele1 As Integer,
                                        ByVal nfaitage1 As Integer, ByVal CpeH As Double, ByVal CpeI As Double,
                                           ByVal k As Integer, ByVal trav As Double, ByVal cscd As Double, ByVal Cpi As Double, ByRef pVent(,,,,) As Double)
        ''Rappel:  pVent(i_cas, i, i1, 1, k) :  i_cas: =1 pour G/D +surpression, =2 pour G/D + depression, ...
        ''                                     i = n° d'élément
        ''                                     i1 = 1 ou 2 suivant noeud origine ou extrémité de l'élément
        ''                                     1 ou 2 si portique courant ou rive
        ''                                     k =n° d'ordre , une pression pouvant être positive ou négative sur le même élément
        'Dim i, ele1, ele2 As Integer
        ''calcul du tronçon faitage -> noue
        'For i = elem(i_ele) To elem(i_ele + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '    If Ele(1, i) = nbFaitage(nfaitage1) Then ele1 = Ele(1, i)
        'Next
        'For i = ele1 To elem(i_ele + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '    'calcul de la partie de couverture de la noue au faitage  
        '    'pression origine
        '    pVent(i_cas, i, 1, 2, k) = (cscd * CpeI + Cpi) * 0.5 * trav
        '    pVent(i_cas, i, 1, 1, k) = (cscd * CpeI + Cpi) * trav
        '    'pression identique à l'origine et à l'extrémité
        '    pVent(i_cas, i, 2, 2, k) = (cscd * CpeI + Cpi) * 0.5 * trav
        '    pVent(i_cas, i, 2, 1, k) = (cscd * CpeI + Cpi) * trav
        'Next
        ''calcul du tronçon noue -> faitage
        'For i = elem(i_ele1) To elem(i_ele1 + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '    If Ele(1, i) = nbFaitage(nfaitage1 + 1) Then ele2 = Ele(1, i)
        'Next
        'For i = ele2 To elem(i_ele1 + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '    'calcul de la partie de couverture du faitage à la noue          
        '    'pression origine
        '    pVent(i_cas, i, 1, 2, k) = (cscd * CpeH + Cpi) * 0.5 * trav
        '    pVent(i_cas, i, 1, 1, k) = (cscd * CpeH + Cpi) * trav
        '    'une seule pression de vent s'applique
        '    'pression identique à l'origine et à l'extrémité
        '    pVent(i_cas, i, 2, 2, k) = (cscd * CpeH + Cpi) * 0.5 * trav
        '    pVent(i_cas, i, 2, 1, k) = (cscd * CpeH + Cpi) * trav
        'Next
    End Sub
    Private Sub Pression_Terminal_2V_Multiple(ByVal i_cas As Integer, ByVal noeFaitage As Integer, ByVal elem() As Integer, ByVal i_ele As Integer,
                                               ByVal CpeI As Double, ByVal k As Integer, ByVal Trav As Double, ByVal type_calcul As Integer,
                                               ByVal cscd As Double, ByVal Cpi As Double, ByRef pVent(,,,,) As Double)
        'Dim i, ele1 As Integer
        'Select Case type_calcul
        '    Case 1 'vent de la gauche vers la droite
        '        For i = elem(i_ele) To elem(i_ele + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '            If Ele(1, i) = noeFaitage Then ele1 = Ele(1, i) : Exit For
        '        Next
        '        For i = ele1 To elem(i_ele + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '            'calcul de la couverture sous le vent
        '            'pression origine
        '            pVent(i_cas, i, 1, 2, k) = (cscd * CpeI + Cpi) * 0.5 * Trav
        '            pVent(i_cas, i, 1, 1, k) = (cscd * CpeI + Cpi) * Trav
        '            'pression identique à l'origine et à l'extrémité
        '            pVent(i_cas, i, 2, 2, k) = (cscd * CpeI + Cpi) * 0.5 * Trav
        '            pVent(i_cas, i, 2, 1, k) = (cscd * CpeI + Cpi) * Trav
        '        Next
        '    Case 2 'vent de la droite vers la gauche
        '        For i = elem(i_ele) To elem(i_ele + 1) 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '            If Ele(1, i) = noeFaitage Then ele1 = Ele(1, i) : Exit For
        '        Next
        '        For i = elem(i_ele) To ele1 'éléments composant l'arbalétrier - la numérotation va de la gauche vers la droite
        '            'calcul de la couverture sous le vent
        '            'pression origine
        '            pVent(i_cas, i, 1, 2, k) = (cscd * CpeI + Cpi) * 0.5 * Trav
        '            pVent(i_cas, i, 1, 1, k) = (cscd * CpeI + Cpi) * Trav
        '            'pression identique à l'origine et à l'extrémité
        '            pVent(i_cas, i, 2, 2, k) = (cscd * CpeI + Cpi) * 0.5 * Trav
        '            pVent(i_cas, i, 2, 1, k) = (cscd * CpeI + Cpi) * Trav
        '        Next
        'End Select
    End Sub

    Private Function Qp(ByVal Zh As Double) As Double
        Dim Z0, Zmin As Double ', Ce 
        With Wnd
            .Cr = Cr(Z0, Zmin, Zh)
            .Vm = .Cr * .Coro * .Vb
            'Calcul de la pression dynamique de pointe
            .Iv = Iv(Z0, Zmin, Zh)
            Qp = (1 + 7 * .Iv) * 0.5 * 1.225 * .Vm ^ 2
            '  Ce = Qp / (0.5 * 1.225 * .Vb ^ 2)
        End With
    End Function
    Private Function Cr(ByRef Z0 As Double, ByRef Zmin As Double, ByVal Zh As Double) As Double

        With Wnd
            Select Case .CatVent 'rugosité du terrain
                Case 1 '0:
                    Z0 = 0.005 : Zmin = 1
                Case 2 'II
                    Z0 = 0.05 : Zmin = 2
                Case 3 ' IIIa
                    Z0 = 0.2 : Zmin = 5
                Case 4 'IIIb
                    Z0 = 0.5 : Zmin = 9
                Case 5 'IV
                    Z0 = 1 : Zmin = 15
            End Select
            .Kr = 0.19 * (Z0 / 0.05) ^ 0.07 ': Tab_Vent(8) = Kr
            ' If passage = 1 Then Tab_Vent(9) = Ze Else Tab_Vent(48) = Ze
            Select Case Zh
                Case Is > 200
                    MsgBox("La limite pour la hauteur est fixée à 200m. La valeur de Ze pour le calcul de la valeur de Cr est dépassée." & vbCrLf &
                           "La suite du calcul est effectuée avec une hauteur de valeur 200m.", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly,
                           "Eurocode - Routine Private Function Cr")
                    Cr = .Kr * Log(200 / Z0)
                Case Is > Zmin
                    Cr = .Kr * Log(Zh / Z0)
                Case Else
                    Cr = .Kr * Log(Zmin / Z0)
            End Select

        End With
    End Function
    Private Function Iv(ByVal Z0 As Double, ByVal Zmin As Double, ByVal Zh As Double) As Double

        With Wnd
            Select Case .OroCas
                Case 0 ' terrain plat pour l'Orographie
                    .Ki = 1 - 0.0002 * (Log10(Z0) + 3) ^ 6
                Case 1 'cas I pour l'Orographie
                    .Ki = .Coro * (1 - 0.0002 * (Log10(Z0) + 3) ^ 6)
                Case 2 ' cas II pour l'Orographie 
                    .Ki = 1 - 0.0002 * (Log10(Z0) + 3) ^ 6
            End Select
            Select Case Zh '.Ze(i)
                Case Is > 200
                    MsgBox("La limite de hauteur fixée à 200m pour le calcul de la valeur de Iv, est dépassée." & vbCrLf &
                           "Toutefois, le calcul est continué avec la hauteur limite 200m.", MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Eurocode - Routine Private Function Iv")
                    Iv = .Ki / (.Coro * Log(200 / Z0))
                Case Is > Zmin
                    Iv = .Ki / (.Coro * Log(Zh / Z0)) '  Iv = .Ki / (.Coro * Log(.Ze(i) / Z0))
                Case Else
                    Iv = .Ki / (.Coro * Log(Zmin / Z0))
            End Select
        End With
    End Function
    Private Function Cpe_Terras(ByVal hph As Double, ByVal hph1 As Double, ByVal hph2 As Double, ByVal Cpe1 As Double, ByVal Cpe2 As Double) As Double
        Cpe_Terras = Cpe2 + ((Cpe1 - Cpe2) * ((hph2 - hph) / (hph2 - hph1)))
    End Function
    Private Function Cpe_1vers(ByVal pente As Double, ByVal pente1 As Double, ByVal pente2 As Double, ByVal Cpe1 As Double, ByVal Cpe2 As Double) As Double
        Cpe_1vers = Cpe2 + ((Cpe1 - Cpe2) * ((pente2 - pente) / (pente2 - pente1)))
    End Function
    Private Function Cpi_muhd(ByVal mu As Double, ByVal h As Double, ByVal d As Double) As Double
        Dim Cpi_muhd1, Cpi_muhd2 As Double
        Select Case h / d 'rapport hauteur bat/profondeur
            Case Is > 1
                Select Case mu
                    Case Is >= 0.95
                        Cpi_muhd = -0.5
                    Case Is < 0.33
                        Cpi_muhd = 0.35
                    Case Else
                        Cpi_muhd = -1.37096774 * mu + 0.80242
                End Select
            Case Is <= 0.25
                Select Case mu
                    Case Is >= 0.9
                        Cpi_muhd = -0.3
                    Case Is < 0.33
                        Cpi_muhd = 0.35
                    Case Else
                        Cpi_muhd = -1.14035088 * mu + 0.7263158
                End Select
            Case Else ' 0,25<Hbat / d<1
                'interpolation linéaire
                Select Case mu
                    Case Is >= 0.95
                        Cpi_muhd1 = -0.5
                    Case Is < 0.33
                        Cpi_muhd1 = 0.35
                    Case Else
                        Cpi_muhd1 = -1.37096774 * mu + 0.80242
                End Select
                Select Case mu
                    Case Is >= 0.9
                        Cpi_muhd2 = -0.3
                    Case Is < 0.33
                        Cpi_muhd2 = 0.35
                    Case Else
                        Cpi_muhd2 = -1.14035088 * mu + 0.7263158
                End Select
                Cpi_muhd = Cpi_muhd1 + (Cpi_muhd2 - Cpi_muhd1) * (1 - (h / d)) / (0.75) 'a vérifier
        End Select
    End Function
#End Region
#Region "Calcul CsCd"
    Public Sub Calcul_CsCd(ByVal longpan As Double, ByVal pignon As Double, ByVal h As Double, ByVal RegVent As Integer, ByVal CatVent As Integer, ByVal Cvt As Integer,
                           ByVal Co As Double, ByVal Orocas As Integer, ByVal GP As Double, ByVal GE As Double, ByRef CsCd As Double,
                            ByRef rtf As RtfAnsiTextWriter)
        Dim Vb, Zmin As Integer
        Dim B2, Cr, Cf, Cf0, Iv, Kr, ki, Kp, fl, Lz, Rb, Rh, R2, Sl, T, Vm, Z0, Zs As Double
        Dim α, ηh, ηb, δ, δs, δa, ν, µe, Ψr, Ψλ, λ As Double
        Select Case CatVent 'rugosité du terrain
            Case 1 '0:
                Z0 = 0.005 : Zmin = 1
            Case 2 'II
                Z0 = 0.05 : Zmin = 2
            Case 3 ' IIIa
                Z0 = 0.2 : Zmin = 5
            Case 4 'IIIb
                Z0 = 0.5 : Zmin = 9
            Case 5 'IV
                Z0 = 1 : Zmin = 15
        End Select
        Zs = 0.6 * h
        If Zs < Zmin Then Zs = Zmin
        α = 0.67 + 0.05 * Log(Z0)
        Lz = 300 * (Zs / 200) ^ α

        'suivant annexe 4 NV65
        Select Case Cvt
            Case 1 'maçonnerie ou béton banché
                T = 0.06 * h / pignon ^ 0.5 * (h / (2 * pignon + h)) ^ 0.5
                δs = 0.1
            Case 2 'voile BA (béton banché ferraillé)
                T = 0.08 * h / pignon ^ 0.5 * (h / (pignon + h)) ^ 0.5
                δs = 0.1
            Case 3 'portique BA
                T = 0.09 * h / pignon ^ 0.5
                δs = 0.1
            Case 4 'portique CM
                T = 0.1 * h / pignon ^ 0.5
                δs = 0.05
        End Select
        'Vitesse moyenne du vent  
        Select Case RegVent
            Case 1 'région 1
                Vb = 22
            Case 2 'région 2
                Vb = 24
            Case 3 'région 3
                Vb = 26
            Case 4 'région 4
                Vb = 28
        End Select
        Kr = 0.19 * (Z0 / 0.05) ^ 0.07
        Cr = Kr * Log(Zs / Z0)
        Vm = Cr * Co * Vb
        fl = (1 / T) * Lz / Vm
        Sl = 6.8 * fl / ((1 + 10.2 * fl) ^ (5 / 3))
        B2 = 1 / (1 + 0.9 * ((longpan + h) / Lz) ^ 0.63)
        ηh = 4.6 * h * fl / Lz
        ηb = 4.6 * longpan * fl / Lz
        If ηh = 0 Then Rh = 1 Else Rh = (1 / ηh) - ((1 / (2 * ηh ^ 2)) * (1 - Exp(-2 * ηh)))
        If ηb = 0 Then Rb = 1 Else Rb = (1 / ηb) - ((1 / (2 * ηb ^ 2)) * (1 - Exp(-2 * ηb)))
        µe = (GP + GE) * 1000.0 / (longpan * h)
        Ψr = 1 'bâtiment à angle droit
        Select Case pignon / longpan
            Case Is <= 0.2
                Cf0 = 2
            Case Is <= 0.7
                Cf0 = 2.55 + 0.77 * Log10(pignon / longpan)
            Case Is <= 1
                Cf0 = 2.1 - 2 * Log10(pignon / longpan)
            Case Is <= 5
                Cf0 = 2.1 - 1.6 * Log10(pignon / longpan)
            Case Is <= 10
                Cf0 = 1 - 0.1 * (pignon / longpan) / 10
            Case Else
                Cf0 = 0.9
        End Select
        λ = 2 * h / longpan
        Select Case Ψr
            Case Is <= 10
                Ψλ = 0.6 + 0.1 * Log10(λ)
            Case Is <= 70
                Ψλ = 0.7 + 0.125 * Log10(λ)
        End Select
        Cf = Cf0 * Ψr * Ψλ
        δa = Cf * 1.225 * Vm / (2 * µe / T)
        δ = δs + δa
        R2 = (PI ^ 2 / (2 * δ)) * Sl * Rh * Rb
        ν = (1 / T) * Sqrt(R2 / (B2 + R2))
        If ν < 0.08 Then ν = 0.08
        Kp = Sqrt(2 * Log(ν * 600)) + 0.6 / Sqrt(2 * Log(ν * 600))
        If Kp < 3 Then Kp = 3
        Select Case Orocas
            Case 0 ' terrain plat pour l'Orographie
                ki = 1 - 0.0002 * (Log10(Z0) + 3) ^ 6
            Case 1 'cas I pour l'Orographie
                ki = Co * (1 - 0.0002 * (Log10(Z0) + 3) ^ 6)
            Case 2 ' cas II pour l'Orographie 
                ki = 1 - 0.0002 * (Log10(Z0) + 3) ^ 6
        End Select
        Iv = ki / (Co * Log(Zs / Z0)) '  Iv = .Ki / (.Coro * Log(.Ze(i) / Z0))
        CsCd = (1 + 2 * Kp * Iv * Sqrt(B2 + R2)) / (1 + 7 * Iv)
        NotedeCalcul_CsCd(longpan, pignon, h, RegVent, Vb, CatVent, Cvt, Co, Orocas, GP, GE, Zs, T, Z0, Zmin,
                          Kr, Cr, Vm, ki, Iv, δ, δs, α, Lz, fl, Sl, B2, ν, Kp, ηh, Rh, ηb, Rb, Cf, Cf0, Ψr, λ, Ψλ, µe, δa, R2, CsCd, rtf)
    End Sub
    Private Sub NotedeCalcul_CsCd(ByVal longpan As Double, ByVal pignon As Double, ByVal h As Double, ByVal RegVent As Integer, ByVal Vb As Integer, ByVal CatVent As Integer,
                                  ByVal Cvt As Integer, ByVal Co As Double, ByVal Orocas As Integer,
                           ByVal GP As Double, ByVal GE As Double, ByVal Zs As Double, ByVal T As Double, ByVal Z0 As Double, ByVal Zmin As Double,
                            ByVal kr As Double, ByVal cr As Double, ByVal Vm As Double, ByVal ki As Double, ByVal Iv As Double, ByVal δ As Double, ByVal δs As Double,
                            ByVal α As Double, ByVal Lz As Double, ByVal fl As Double, ByVal Sl As Double, ByVal B2 As Double,
                             ByVal ν As Double, ByVal Kp As Double, ByVal ηh As Double, ByVal Rh As Double, ByVal ηb As Double, ByVal Rb As Double,
                             ByVal Cf As Double, ByVal Cf0 As Double, ByVal Ψr As Double, ByVal λ As Double, ByVal Ψλ As Double, ByVal µe As Double, ByVal δa As Double,
                             ByVal R2 As Double, ByVal CsCd As Double, ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String
        rtf.WriteStartGroup()
        rtf.NewParagraph(RtfAnsiTextWriter.Align.Center) : rtf.Bold = True : rtf.FontSize = 18 : rtf.Underline = True
        rtf.WriteString("Calcul du coefficient CsCd suivant l'EN 1991-1-4  Annexe B")
        rtf.NewLine()
        rtf.Bold = False : rtf.FontSize = 10 : rtf.Underline = False : rtf.NewParagraph(RtfAnsiTextWriter.Align.Left)
        rtf.WriteString("Note de calcul du : ") : msg = Mise_en_Forme_date(CStr(DateTime.Now)) : rtf.WriteString(msg) : rtf.NewLine()
        rtf.WriteString("Rédacteur : " & Aff.Redacteur) : rtf.NewLine()
        rtf.WriteString("Chantier : " & Aff.Chantier) : rtf.NewLine()
        rtf.WriteString("Logiciel : calculette bâtiment  -  version 1.0  2015 - 2016") : rtf.NewLine()
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("1 - Rappel des hypothèses") : rtf.Bold = False : rtf.Underline = False
        rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("Bâtiment à plan rectangulaire  ") : rtf.NewLine()
        rtf.WriteString(" b: " & longpan.ToString("#0.00") & "m -  d: " & pignon.ToString("#0.00") & " m - hauteur h: " & h.ToString("#0.00") & "m  ") : rtf.NewLine()
        Try
            Dim myImage As Image ' Create Image Element
            myImage = My.Resources.CsCdBat
            rtf.InsertImage(myImage)
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
        End Try
        rtf.WriteString("Masses:   Globale permanente = " & GP.ToString("#0.00") & "Tonnes - Globale exploitation = " & GE.ToString("#0.00") & " tonnes. ") : rtf.NewLine()
        'suivant annexe 4 NV65
        Select Case Cvt
            Case 1 'maçonnerie ou béton banché
                rtf.WriteString("Contreventement par murs en maçonnerie ou béton banché.") : rtf.NewLine()
            Case 2 'voile BA (béton banché ferraillé)
                rtf.WriteString("Contreventement par voiles BA (béton banché ferraillé).") : rtf.NewLine()
            Case 3 'portique BA
                rtf.WriteString("Contreventement par portiques BA.") : rtf.NewLine()
            Case 4 'portique CM
                rtf.WriteString("Contreventement par portiques CM.") : rtf.NewLine()
        End Select
        rtf.WriteString("Région d'implantation: " & CStr(RegVent) & " - Vb = " & Vb.ToString() & " m/s.") : rtf.NewLine()
        Select Case CatVent 'rugosité du terrain
            Case 1 '0:
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie 0 - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 2 'II
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie II - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 3 ' IIIa
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IIIa - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 4 'IIIb
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IIIb - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 5 'IV
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IV - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
        End Select
        Select Case Orocas 'orographie du terrain
            Case 0
                rtf.WriteString("Orographie de terrain du site d'implantation: terrain plat  - C0 = " & Co.ToString("#0.00")) : rtf.NewLine()
            Case 1 'II
                rtf.WriteString("Orographie de terrain: catégorie I - C0 = " & Co.ToString("#0.00")) : rtf.NewLine()
            Case 2 ' IIIa
                rtf.WriteString("Orographie de terrain: catégorie II - C0 = " & Co.ToString("#0.00")) : rtf.NewLine()
        End Select
        rtf.Underline = True
        rtf.WriteString("Rappel:") : rtf.Underline = False : rtf.NewLine()
        rtf.WriteString("Le calcul du coefficient Cs.Cd établi ci-après est valable pour la façade au vent. Ce coefficient sera différent pour la façade perpendiculaire en raison d'un rugosité différente, d'inertie différente, etc. ...") : rtf.NewLine()
        rtf.NewLine()
        rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("2 - Calcul de CsCd") : rtf.NewLine() : rtf.NewLine()
        rtf.FontSize = 9 : rtf.WriteString("Valable uniquement pour la façade au vent") : rtf.Bold = False : rtf.Underline = False
        rtf.NewLine() : rtf.NewLine()
        'tableau
        rtf.NewParagraph()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Variables") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Valeur") : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Unité") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Commentaires") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Fréquence fondamentale de flexion dans le plan perpendiculaire au Longpan (petite inertie)")
        rtf.EndCell() : rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("f1") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString((1 / T).ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Hz") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Fréquence propre de la structure- mode fondamental - Formules NV65/CECM") : rtf.EndCell() : rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("f2") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString((46 / h).ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Hz") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Fréquence propre de la structure- mode fondamental - Expression (F2)") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Fréquence f1 retenu pour la suite des calculs = fréquence fondamentale de flexion")
        rtf.EndCell() : rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Zs") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Zs.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("m") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Hauteur de référence = 0,6.h") : rtf.EndCell() : rtf.EndRow()
        'ligne 3
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("kr") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(kr.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("ANF Exp(4.5) ") : rtf.EndCell() : rtf.EndRow()
        'ligne 4
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("cr(Zs)") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(cr.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Zs - Anf Exp(4.4)") : rtf.EndCell() : rtf.EndRow()
        'ligne 5
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Vm(Zs)") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Vm.ToString("#0.00")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("m/s") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Vitesse moyenne(Zs) = cr.c0.Vb pour la hauteur Zs - Exp(4.3)") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Caractéristiques de la turbulence")
        rtf.EndCell() : rtf.EndRow()
        'ligne 6
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("ki") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(ki.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell() : rtf.EndRow()
        'ligne 7
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Iv(Zs)") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Iv.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Intensité de turbulence pour la hauteur de référence Zs - Expression (4.7)") : rtf.EndCell() : rtf.EndRow()
        'ligne 8
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("α") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(α.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("α - Exp(B.1)") : rtf.EndCell() : rtf.EndRow()
        'ligne 10
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Lz") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Lz.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("m ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Echelle de turbulence > Zmin- Exp(B.1)") : rtf.EndCell() : rtf.EndRow()
        'ligne 11
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("fL(zs,n)") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(fl.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Suivant Annexe B, §B.1(2)") : rtf.EndCell() : rtf.EndRow()
        'ligne 12
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("SL(zs,n)") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Sl.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Densité spectrale de puissance - exp(B.2)") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Calcul du coefficient de réponse quasi-statique B²")
        rtf.EndCell() : rtf.EndRow()
        'ligne 13
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("B²") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(B2.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Coefficient de réponse quasi-statique - exp(B.3)") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Calcul du coefficient de réponse résonante R² (effet de la turbulence)")
        rtf.EndCell() : rtf.EndRow()
        'ligne 16
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("ηb") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(ηb.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Expression (B.8)") : rtf.EndCell() : rtf.EndRow()
        'ligne 17
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Rb") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Rb.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Fonction d'admittance aérodynamique - Expression (B.8)") : rtf.EndCell() : rtf.EndRow()
        'ligne 18
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("ηh") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(ηh.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Expression (B.7)") : rtf.EndCell() : rtf.EndRow()
        'ligne 19
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Rh") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Rh.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Fonction d'admittance aérodynamique - Expression (B.7)") : rtf.EndCell() : rtf.EndRow()
        'ligne 20
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("δs ") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(δs.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Amortissement structural - Tableau F.2") : rtf.EndCell() : rtf.EndRow()
        'ligne 21
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("µe") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(µe.ToString("#,##0")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Kg/m² ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Masse équivalente par unité de surface - Exp(F.17) et ANF") : rtf.EndCell() : rtf.EndRow()
        'ligne 22
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Cf0") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Cf0.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Coefficient de force section rectangulaire arêtes vives sans écoulement de contournement - figure 7.23") : rtf.EndCell() : rtf.EndRow()
        'ligne 23
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Ψr") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Ψr.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("facteur de réduction pour angles arrondis - figure 7.24") : rtf.EndCell() : rtf.EndRow()
        'ligne 24
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("λ") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(λ.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Elancement tableau ANF 7.16") : rtf.EndCell() : rtf.EndRow()
        'ligne 25
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Ψλ") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Ψλ.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("facteur d'effet d'extrémité - Figure 7.36, taux de remplissage=1") : rtf.EndCell() : rtf.EndRow()
        'ligne 26
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Cf") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Cf.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Cf = Cf0.Ψr.Ψλ Exp(7.10)") : rtf.EndCell() : rtf.EndRow()
        'ligne 27
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("δa") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(δa.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Amortissement aérodynamique - Exp(F.16)") : rtf.EndCell() : rtf.EndRow()
        'ligne 27
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("δ") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(δ.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Décrément logarithmique d'amortissement δ = δs + δa; δd=0 - Exp(F.15)") : rtf.EndCell() : rtf.EndRow()
        'ligne 27
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("R²") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(R2.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString(" Coefficient de réponse résonante Exp(B6)") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Calcul du facteur de pointe: Kp")
        rtf.EndCell() : rtf.EndRow()
        'ligne 14
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("ν") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(ν.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Hz") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Fréquence de franchissement - exp(B.5)") : rtf.EndCell() : rtf.EndRow()
        'ligne 15
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Kp") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Kp.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Facteur de pointe - expression (B.4)") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Calcul du Coefficient structural Cs.Cd")
        rtf.EndCell() : rtf.EndRow()
        'ligne 27
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("CsCd") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(CsCd.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString(" Coefficient structural Exp(6.1)") : rtf.EndCell() : rtf.EndRow()
        rtf.WriteEndGroup()

    End Sub
#End Region
#Region "Calcul détachement tourbillonnaire"
    Public Sub Calcul_detachement_tourbillonnaire(ByVal b As Double, ByVal d As Double, ByVal h As Double, ByVal RegVent As Integer, ByVal CatVent As Integer,
                                                    ByVal Co As Double, ByVal Orocas As Integer, ByVal Cvt As Integer, ByRef Edt1 As Double, ByRef Edt2 As Double,
                                                 ByRef Vcrit As Double, ByRef Vm As Double, ByRef verif As Boolean, ByRef rtf As RtfAnsiTextWriter)
        Dim Vb, Zmin As Integer
        Dim Cr, d_b, Kr, St, T, Vlim, Z0, Zs As Double

        If h > b Then Edt1 = h / b Else Edt1 = b / h
        If h > d Then Edt2 = h / d Else Edt2 = d / h
        'If Edt1 >= 6 And Edt2 >= 6 Then
        '    Call NotedeCalcul_Tourbillon1(b, d, h, RegVent, Vb, CatVent, Co, Z0, Zmin, Edt1, Edt2, rtf)
        '    Exit Sub
        'End If
        Select Case CatVent 'rugosité du terrain
            Case 1 '0:
                Z0 = 0.005 : Zmin = 1
            Case 2 'II
                Z0 = 0.05 : Zmin = 2
            Case 3 ' IIIa
                Z0 = 0.2 : Zmin = 5
            Case 4 'IIIb
                Z0 = 0.5 : Zmin = 9
            Case 5 'IV
                Z0 = 1 : Zmin = 15
        End Select
        Zs = h
        If Zs < Zmin Then Zs = Zmin
        'Vitesse moyenne du vent  
        Select Case RegVent
            Case 1 'région 1
                Vb = 22
            Case 2 'région 2
                Vb = 24
            Case 3 'région 3
                Vb = 26
            Case 4 'région 4
                Vb = 28
        End Select
        Kr = 0.19 * (Z0 / 0.05) ^ 0.07
        Cr = Kr * Log(Zs / Z0)
        Vm = Cr * Co * Vb
        d_b = d / b
        If d_b > 10 Then
            MessageBox.Show("d/b > 10 (= " & d_b.ToString("#0.0") & "), les dimensions sont hors limite de la méthode de l'annexe E. Calcul arrêté.",
                            "Module calcul détachement tourbillonnaire", MessageBoxButtons.OK, MessageBoxIcon.Error)
            verif = False : Exit Sub
        End If
        Select Case d_b
            Case Is <= 1
                St = 0.12
            Case Is <= 2
                St = 0.12 - 0.07 * (d_b - 1)
            Case Is <= 3
                St = 0.05
            Case Is <= 3.5
                St = 0.05 + 0.1 * (d_b - 3) / 0.5
            Case Is <= 5
                St = 0.15 - 0.04 * (d_b - 3.5) / 1.5
            Case Is <= 10
                St = 0.11 - 0.01 * (d_b - 10) / 5
        End Select
        'suivant annexe 4 NV65
        Select Case Cvt
            Case 1 'maçonnerie ou béton banché
                T = 0.06 * h / b ^ 0.5 * (h / (2 * b + h)) ^ 0.5
            Case 2 'voile BA (béton banché ferraillé)
                T = 0.08 * h / b ^ 0.5 * (h / (b + h)) ^ 0.5
            Case 3 'portique BA
                T = 0.09 * h / b ^ 0.5
            Case 4 'portique CM
                T = 0.1 * h / b ^ 0.5
        End Select
        Vcrit = b / (T * St)
        Vlim = 1.25 * Vm
        Call NotedeCalcul_Tourbillon2(b, d, h, RegVent, Vb, CatVent, Co, Z0, Zmin, Edt1, Edt2, Kr, Cr, Vm, d_b, St, T, Vcrit, Vlim, rtf)
    End Sub
    Private Sub NotedeCalcul_Tourbillon1(ByVal longpan As Double, ByVal pignon As Double, ByVal h As Double, ByVal RegVent As Integer, ByVal Vb As Integer, ByVal CatVent As Integer,
                                  ByVal Co As Double, ByVal Z0 As Double, ByVal Zmin As Double, ByVal edt1 As Double, ByVal edt2 As Double, ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String
        rtf.WriteStartGroup()
        rtf.NewParagraph(RtfAnsiTextWriter.Align.Center) : rtf.Bold = True : rtf.FontSize = 18 : rtf.Underline = True
        rtf.WriteString("Effet du détachement tourbillonnaire suivant EN 1991-1-4 Annexe E")
        rtf.NewLine()
        rtf.Bold = False : rtf.FontSize = 10 : rtf.Underline = False : rtf.NewParagraph(RtfAnsiTextWriter.Align.Left)
        rtf.WriteString("Note de calcul du : ") : msg = Mise_en_Forme_date(CStr(DateTime.Now)) : rtf.WriteString(msg) : rtf.NewLine()
        rtf.WriteString("Rédacteur : " & Aff.Redacteur) : rtf.NewLine()
        rtf.WriteString("Chantier : " & Aff.Chantier) : rtf.NewLine()
        rtf.WriteString("Logiciel : calculette bâtiment  -  version 1.0  2015 - 2016") : rtf.NewLine()
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("1 - Rappel des hypothèses") : rtf.Bold = False : rtf.Underline = False
        rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("Bâtiment à plan rectangulaire  ") : rtf.NewLine()
        rtf.WriteString(" b: " & longpan.ToString("#0.00") & "m -  d: " & pignon.ToString("#0.00") & " m - hauteur h: " & h.ToString("#0.00") & "m  ") : rtf.NewLine()
        Try
            Dim myImage As Image ' Create Image Element
            myImage = My.Resources.Tourbillon
            rtf.InsertImage(myImage)
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
        End Try
        rtf.WriteString("Région d'implantation: " & CStr(RegVent) & " - Vb = " & Vb.ToString() & " m/s.") : rtf.NewLine()
        Select Case CatVent 'rugosité du terrain
            Case 1 '0:
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie 0 - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 2 'II
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie II - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 3 ' IIIa
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IIIa - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 4 'IIIb
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IIIb - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 5 'IV
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IV - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
        End Select
        rtf.WriteString("Orographie de terrain du site d'implantation: C0 = " & Co.ToString("#0.00")) : rtf.NewLine()
        rtf.Underline = True
        rtf.WriteString("Rappel:") : rtf.Underline = False : rtf.NewLine()
        rtf.WriteString("Le calcul de l'effet du détachement tourbillonnaire ci-après est valable pour la façade au vent. Ce calcul sera différent pour la façade perpendiculaire en raison d'un rugosité différente, d'inertie différente, etc. ...") : rtf.NewLine()
        rtf.NewLine()
        rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("2 - Calcul de l'effet du détachement tourbillonnaire") : rtf.NewLine() : rtf.NewLine()
        rtf.FontSize = 9 : rtf.WriteString("Valable uniquement pour la façade au vent") : rtf.Bold = False : rtf.Underline = False
        rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("Rapport des dimensions transversales suivant dispositions Annexe E §E.1.2(1):") : rtf.NewLine()
        rtf.WriteString("Rapport h/b (ou b/h) = " & edt1.ToString("#0.00") & " < 6 - Aucun effet de détachement tourbillonnaire.") : rtf.NewLine()
        rtf.WriteString("Rapport h/d (ou d/h) = " & edt2.ToString("#0.00") & " < 6 - Aucun effet de détachement tourbillonnaire.") : rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub
    Private Sub NotedeCalcul_Tourbillon2(ByVal longpan As Double, ByVal pignon As Double, ByVal h As Double, ByVal RegVent As Integer, ByVal Vb As Integer,
                                         ByVal CatVent As Integer, ByVal Co As Double, ByVal Z0 As Double, ByVal Zmin As Double, ByVal edt1 As Double, ByVal edt2 As Double,
                                        ByVal kr As Double, ByVal cr As Double, ByVal Vm As Double, ByVal d_b As Double, ByVal St As Double, ByVal T As Double,
                                         ByVal Vcrit As Double, ByVal Vlim As Double, ByRef rtf As RtfAnsiTextWriter)
        Dim msg As String
        rtf.WriteStartGroup()
        rtf.NewParagraph(RtfAnsiTextWriter.Align.Center) : rtf.Bold = True : rtf.FontSize = 18 : rtf.Underline = True
        rtf.WriteString("Effet du détachement tourbillonnaire suivant EN 1991-1-4 Annexe E")
        rtf.NewLine()
        rtf.Bold = False : rtf.FontSize = 10 : rtf.Underline = False : rtf.NewParagraph(RtfAnsiTextWriter.Align.Left)
        rtf.WriteString("Note de calcul du : ") : msg = Mise_en_Forme_date(CStr(DateTime.Now)) : rtf.WriteString(msg) : rtf.NewLine()
        rtf.WriteString("Rédacteur : " & Aff.Redacteur) : rtf.NewLine()
        rtf.WriteString("Chantier : " & Aff.Chantier) : rtf.NewLine()
        rtf.WriteString("Logiciel : calculette bâtiment  -  version 1.0  2015 - 2016") : rtf.NewLine()
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("1 - Rappel des hypothèses") : rtf.Bold = False : rtf.Underline = False
        rtf.FontSize = 10 : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("Bâtiment à plan rectangulaire  ") : rtf.NewLine()
        rtf.WriteString(" b: " & longpan.ToString("#0.00") & "m -  d: " & pignon.ToString("#0.00") & " m - hauteur h: " & h.ToString("#0.00") & "m  ") : rtf.NewLine()
        Try
            Dim myImage As Image ' Create Image Element
            myImage = My.Resources.Tourbillon
            rtf.InsertImage(myImage)
        Catch ex As Exception
            msg = "Le logiciel n'a pas pu chargé l'image correspondante." & vbCrLf & "Erreur: " & ex.Message & ex.StackTrace & vbCrLf & "Note de calcul sans image"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Logiciel Calculette Bâtiment")
        End Try
        rtf.WriteString("Région d'implantation: " & CStr(RegVent) & " - Vb = " & Vb.ToString() & " m/s.") : rtf.NewLine()
        Select Case CatVent 'rugosité du terrain
            Case 1 '0:
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie 0 - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 2 'II
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie II - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 3 ' IIIa
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IIIa - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 4 'IIIb
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IIIb - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
            Case 5 'IV
                rtf.WriteString("Catégorie de terrain du site d'implantation: catégorie IV - z0 = " & Z0.ToString & " m - Zmin = " & Zmin.ToString & " m.") : rtf.NewLine()
        End Select
        rtf.WriteString("Orographie de terrain du site d'implantation: C0 = " & Co.ToString("#0.00")) : rtf.NewLine()
        rtf.Underline = True
        rtf.WriteString("Rappel:") : rtf.Underline = False : rtf.NewLine()
        rtf.WriteString("Le calcul de l'effet du détachement tourbillonnaire ci-après est valable pour la façade au vent. Ce calcul sera différent pour la façade perpendiculaire en raison d'un rugosité différente, d'inertie différente, etc. ...") : rtf.NewLine()
        rtf.NewLine()
        rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("2 - Calcul de l'effet du détachement tourbillonnaire") : rtf.NewLine() : rtf.NewLine()
        rtf.FontSize = 9 : rtf.WriteString("Valable uniquement pour la façade au vent") : rtf.Bold = False : rtf.Underline = False
        rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("Rapport des dimensions transversales suivant dispositions Annexe E §E.1.2(1):") : rtf.NewLine()
        rtf.WriteString("Rapport h/b (ou b/h) = " & edt1.ToString("#0.00"))
        If edt1 < 6 Then
            rtf.WriteString(" < 6 - Aucun effet de détachement tourbillonnaire.") : rtf.NewLine()
        Else
            rtf.WriteString(" > 6 - Effet de détachement tourbillonnaire à examiner.") : rtf.NewLine()
        End If
        rtf.WriteString("Rapport h/d (ou d/h) = " & edt2.ToString("#0.00"))
        If edt2 < 6 Then
            rtf.WriteString(" < 6 - Aucun effet de détachement tourbillonnaire.") : rtf.NewLine()
        Else
            rtf.WriteString(" > 6 - Effet de détachement tourbillonnaire à examiner.") : rtf.NewLine()
        End If
        'tableau
        rtf.NewParagraph()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Variables") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Valeur") : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Unité") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Commentaires") : rtf.EndCell() : rtf.EndRow()

        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Calcul de V limite")
        rtf.EndCell() : rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Zs") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(h.ToString("#0.00")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("m") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Hauteur de référence =  h") : rtf.EndCell() : rtf.EndRow()
        'ligne 3
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("kr") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(kr.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("ANF Exp(4.5) ") : rtf.EndCell() : rtf.EndRow()
        'ligne 4
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("cr(Zs)") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(cr.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Coefficient de rugosité pour la hauteur de référence Zs - Anf Exp(4.4)") : rtf.EndCell() : rtf.EndRow()
        'ligne 5
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Vm(Zs)") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Vm.ToString("#0.00")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("m/s") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Vitesse moyenne(Zs) = cr.c0.Vb pour la hauteur Zs - Exp(4.3)") : rtf.EndCell() : rtf.EndRow()
        'ligne 5
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("V Lim") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Vlim.ToString("#0.00")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("m/s") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Vitesse Limite = 1,25.Vm - Exp(E.1)") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString("Calcul de V critique")
        rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString(" - Fréquence propre de vibration en flexion perpendiculaire au vent")
        rtf.EndCell() : rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("f1") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString((1 / T).ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Hz") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Fréquence propre de la structure- mode fondamental - Formules NV65/CECM") : rtf.EndCell() : rtf.EndRow()
        'ligne 2
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("f2") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString((46 / h).ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Hz") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Fréquence propre de la structure- mode fondamental - Expression (F2)") : rtf.EndCell() : rtf.EndRow()
        'Ligne 1  ligne_Entete_ 
        rtf.BeginRow() : rtf.DeclareCell(10000) : rtf.BeginCell(True) : rtf.WriteString(" - Fréquence f1 retenu pour la suite des calculs = fréquence fondamentale de flexion")
        rtf.EndCell() : rtf.EndRow()
        'ligne 4
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("d/b") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(d_b.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Rapport d/b") : rtf.EndCell() : rtf.EndRow()
        'ligne 5
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("St") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(St.ToString("#0.000")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(" ") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True) : rtf.WriteString("Nombre de Strouhal - Figure E.1") : rtf.EndCell() : rtf.EndRow()
        'ligne 5
        rtf.BeginRow() : rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("V crit") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(Vcrit.ToString("#0.00")) : rtf.EndCell()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("m/s") : rtf.EndCell()
        rtf.DeclareCell(7400) : rtf.BeginCell(True)
        If Vcrit > Vlim Then
            rtf.WriteString("> Vitesse limite = 1,25.Vm - Pas de vérification à faire vis à vis du détachement tourbillonnaire")
        Else
            rtf.WriteString("< Vitesse limite = 1,25.Vm - Vérification à faire vis à vis du détachement tourbillonnaire")
        End If
        rtf.EndCell() : rtf.EndRow()
        rtf.WriteEndGroup()
    End Sub
#End Region
    Private Sub Poubelle()

    End Sub
End Module
